<?php
namespace jvbpdelement\Modules\Userforms\Widgets;

class jv_signup extends Base {

	public function get_name() { return parent::SIGNUP; }
	public function get_title() { return 'JV Signup'; }
	public function get_icon() { return 'eicon-lock-user'; }

	protected function _register_controls() {
		parent::_register_controls();
	}

	protected function render() {
		parent::render();
		$settings = $this->get_settings();
		$current_url = remove_query_arg( 'fake_arg' );

		$isActivateWChook = 'yes' == $this->get_settings_for_display('signup_wc_form_field');
		if($isActivateWChook) {
			$this->add_render_attribute( '_wrapper', 'class', 'woocommerce');
		}

		// if ( 'yes' === $settings['redirect_after_login'] && ! empty( $settings['redirect_url']['url'] ) ) {
		// 	$redirect_url = $settings['redirect_url']['url'];
		// 	$this->add_render_attribute( 'form', Array(
		// 		'data-redirect' => $settings['redirect_url'],
		// 	) );
		// } else {
		// 	$redirect_url = $current_url;
		// }

		$be_redirection = 'yes' === $this->get_settings_for_display('redirect_after_login');

		$this->add_render_attribute( 'form', Array(
			'data-redirect' => $be_redirection ? $this->get_settings_for_display('redirect_url') : $current_url,
		) );

		//if ( is_user_logged_in() && ! Plugin::elementor()->editor->is_edit_mode() ) {
		if ( is_user_logged_in() && !is_admin() ) {
			if ( 'yes' === $settings['show_logged_in_message'] ) {
				$current_user = wp_get_current_user();

				echo '<div class="elementor-login">' .
				sprintf( __( 'You are Logged in as %1$s (<a href="%2$s">Logout</a>)', 'jvfrmtd' ), $current_user->display_name, wp_logout_url( $current_url ) ) .
				'</div>';
			}
			return;
		}

		$field_size ="";
		if( !empty( $settings['input_size'] ) ) {
			$field_size = "field-size-". $settings['input_size'];
		}

		$btn_size="";
		if( !empty( $settings['button_size'] ) ) {
			$btn_size = "btn-size-". $settings['button_size'];
		}

		$this->add_render_attribute( 'form', Array(
			'method' => 'post',
			'enctype' => 'multipart/form-data',
			'data-jvbpd-signup-form' => '',
		) );

		$this->add_render_attribute( 'output', Array(
			'class' => 'btn-wrap submit-wrap',
		) ); ?>

		<form <?php echo $this->get_render_attribute_string( 'form' ); ?>>
			<div class="modal-body">
				<?php do_action( 'jvbpd_register_form_before' ); ?>
				<?php $isActivateWChook && do_action('woocommerce_register_form_start'); ?>
				<div class="row">
					<div class="col-md-6">
						<div class="form-group">
							<label class="" for="reg-username"><?php esc_html_e('Username', 'jvfrmtd' );?></label>
							<input type="text" id="reg-username" name="user_login" class="form-control <?php echo $field_size ?>" required="" placeholder="<?php esc_attr_e( 'Username', 'jvfrmtd' );?>">
						</div>
					</div><!-- /.col-md-6 -->
					<div class="col-md-6">
						<div class="form-group">
							<label class="" for="reg-email"><?php esc_html_e('Email Address', 'jvfrmtd' );?></label>
							<input type="email" id="reg-email" name="user_email" class="form-control <?php echo $field_size ?>" required="" placeholder="<?php esc_attr_e( 'Your email', 'jvfrmtd' );?>">
						</div>
					</div><!-- /.col-md-6 -->
				</div><!-- /.row -->
				<div class="row">
					<div class="col-md-6">
						<div class="form-group">
							<label class="" for="firstname"><?php esc_html_e('First Name', 'jvfrmtd' );?></label>
							<input type="text" id="firstname" name="first_name" class="form-control <?php echo $field_size ?>" required="" placeholder="<?php esc_attr_e( 'Your first name', 'jvfrmtd' );?>">

						</div>
					</div><!-- /.col-md-6 -->
					<div class="col-md-6">
						<div class="form-group">
							<label class="" for="lastname"><?php esc_html_e('Last Name', 'jvfrmtd' );?></label>
							<input type="text" id="lastname" name="last_name" class="form-control <?php echo $field_size ?>" required="" placeholder="<?php esc_attr_e( 'Your last name', 'jvfrmtd' );?>">

						</div>
					</div><!-- /.col-md-6 -->
				</div><!-- /.row -->
				<div class="row">
					<div class="col-md-6">
						<div class="form-group">
							<label class="" for="reg-password"><?php esc_html_e('Password', 'jvfrmtd' );?></label>
							<input type="password" id="reg-password" name="user_pass" class="form-control <?php echo $field_size ?>" required="" placeholder="<?php esc_attr_e( 'Desired Password', 'jvfrmtd' );?>">

						</div>
					</div><!-- /.col-md-6 -->
					<div class="col-md-6">
						<div class="form-group">
							<label class="" for="reg-con-password"><?php esc_html_e('Confirm Password', 'jvfrmtd' );?></label>
							<input type="password" id="reg-con-password" name="user_con_pass" class="form-control <?php echo $field_size ?>" required="" placeholder="<?php esc_attr_e( 'Confirm Password', 'jvfrmtd' );?>">

						</div>
					</div><!-- /.col-md-6 -->
				</div><!-- /.row -->

				<?php $isActivateWChook && do_action('woocommerce_register_form'); ?>

				<?php
				//echo $this->getPartSignUpAgree();
				do_action( 'jvbpd_register_form_after' ); ?>
			</div>

			<?php if ( 'yes' == $this->get_settings_for_display('signup_bp_field') && function_exists('bp_is_active') && bp_is_active( 'xprofile' ) && bp_nouveau_base_account_has_xprofile() ) : ?>
				<?php bp_nouveau_signup_hook( 'before', 'signup_profile' ); ?>
				<div class="register-section extended-profile" id="profile-details-section">
					<h2 class="bp-heading"><?php esc_html_e( 'Profile Details', 'buddypress' ); ?></h2>
					<?php while ( bp_profile_groups() ) : bp_the_profile_group(); ?>
						<?php while ( bp_profile_fields() ) : bp_the_profile_field(); ?>
							<div<?php bp_field_css_class( 'editfield' ); ?>>
								<fieldset>
									<?php
									$field_type = bp_xprofile_create_field_type( bp_get_the_profile_field_type() );
									$field_type->edit_field_html(); ?>
								</fieldset>
							</div>
						<?php endwhile; ?>
					<input type="hidden" name="signup_profile_field_ids" id="signup_profile_field_ids" value="<?php bp_the_profile_field_ids(); ?>" />
					<?php endwhile; ?>
					<?php bp_nouveau_signup_hook( '', 'signup_profile' ); ?>
				</div><!-- #profile-details-section -->
				<?php bp_nouveau_signup_hook( 'after', 'signup_profile' ); ?>
			<?php endif; ?>

			<?php function_exists('twl_before_registration_submit_buttons') && twl_before_registration_submit_buttons(); ?>

			<?php
			'yes' == $this->get_settings_for_display('use_nocaptcha') &&
			self::isActiveNoCaptcha() && self::render_noCaptcha(); ?>

			<div <?php echo $this->get_render_attribute_string( 'output' ); ?>>
				<button type="submit" id="signup" name="submit" class="btn <?php echo $btn_size ?>"><?php echo $settings['button_text']; ?></button> &nbsp;
			</div>

			<?php $isActivateWChook && do_action('woocommerce_register_form_end'); ?>

		</form>
		<?php
	}

}