<?php

add_filter( 'pt-ocdi/regenerate_thumbnails_in_content_import', '__return_false' );
add_filter( 'pt-ocdi/disable_pt_branding', '__return_true' );

function jvcore_ocdi_confirmation_dialog_options ( $options ) {
    return array_merge( $options, array(
        'width'       => 400,
        'dialogClass' => 'wp-dialog',
        'resizable'   => false,
        'height'      => 'auto',
        'modal'       => true,
    ) );
}
add_filter( 'pt-ocdi/confirmation_dialog_options', 'jvcore_ocdi_confirmation_dialog_options', 10, 1 );

function jvcore_ocdi_intro_text( $default_text ) {
    $default_text .= '<div class="ocdi_custom-intro-text notice notice-info inline">';
    $default_text .= sprintf (
        '%1$s <a href="%2$s" target="_blank">%3$s</a> %4$s',
        esc_html__( 'Install and activate all ', 'jvfrmtd' ),
        get_admin_url(null, 'themes.php?page=tgmpa-install-plugins' ),
        esc_html__( 'required plugins', 'jvfrmtd' ),
        esc_html__( 'before you click on the "Import" button.', 'jvfrmtd' )
    );
    $default_text .= sprintf (
        ' %1$s <a href="%2$s" target="_blank">%3$s</a> %4$s',
        esc_html__( 'You will find all the pages in ', 'jvfrmtd' ),
        get_admin_url(null, 'edit.php?post_type=page' ),
        esc_html__( 'Pages.', 'jvfrmtd' ),
        esc_html__( 'Other pages will be imported along with the main Homepage.', 'jvfrmtd' )
    );
    $default_text .= '<br>';
    $default_text .= sprintf (
        '%1$s <a href="%2$s" target="_blank">%3$s</a>',
        esc_html__( 'If you fail to import the demo data, follow the alternative way', 'jvfrmtd' ),
        'https://goo.gl/mMLj3B',
        esc_html__( 'here.', 'jvfrmtd' )
    );
    $default_text .= '</div>';

    return $default_text;
}
add_filter( 'pt-ocdi/plugin_intro_text', 'jvcore_ocdi_intro_text' );
add_filter( 'pt-ocdi/import_files', 'jvcore_import_files' );
function jvcore_import_files() {
    return array (
        Array(
            'import_file_name' => esc_html__( 'Demo 1', 'jvfrmtd' ),
            'import_file_url' => 'http://wpjavo.com/demo/javo-demo/listopia.xml',
            'import_preview_image_url' => trailingslashit( get_template_directory_uri() ).'screenshot.png',
            'import_notice' => wp_kses_post(__( 'All other pages will be imported along with the main Homepage.', 'jvfrmtd' )),
            'preview_url' => 'https://jd-4.wpjavo.com/theme/',
            'categories' => array ( esc_html__( 'New', 'jvfrmtd' ) ),
            'local_import_redux' => array(
                Array(
                    'file_path'   => jvbpdCore()->import_path . 'file/lp-theme-settings.txt',
                    'option_name' => 'jvbpd_themes_settings',
                ),
            ),
        ),
        // Array(
        //     'import_file_name' => esc_html__( 'Demo 2', 'jvfrmtd' ),
        //     'import_file_url' => 'http://wpjavo.com/demo/javo-demo/demo.xml',
        //     'import_preview_image_url' => trailingslashit( get_template_directory_uri() ).'screenshot.png',
        //     'import_notice' => wp_kses_post(__( 'All other pages will be imported along with the main Homepage.', 'jvfrmtd' )),
        //     'preview_url' => 'https://droitthemes.com/wp/saasland-theme/home-event/',
        //     'categories' => array ( esc_html__( 'New', 'jvfrmtd' ) ),
        //     'local_import_redux' => array(
        //         Array(
        //             'file_path'   => jvbpdCore()->import_path . 'file/javo-demo/theme-settings.txt',
        //             'option_name' => 'jvbpd_themes_settings',
        //         ),
        //     ),
        // ),
    );
}

function jvcore_after_import_setup($selected_import) {

    jvcroe_import_listing_category_icon();
    jvcroe_import_amenities_in_categories();
    jvcore_import_category_featured_images();
    jvcore_import_category_markers();
    jvcore_import_review_fields();

    // Disable Elementor's Default Colors and Default Fonts
    update_option( 'elementor_disable_color_schemes', 'yes' );
    update_option( 'elementor_disable_typography_schemes', 'yes' );
    update_option( 'elementor_global_image_lightbox', '' );

    if ( 'Home - Directory 1' == $selected_import['import_file_name'] ) {
        $front_page_id = get_page_by_title( 'Home' );
    }

    $blog_page_id  = get_page_by_title( 'Blog' );
    update_option( 'show_on_front', 'page' );
    update_option( 'page_on_front', $front_page_id->ID );
    update_option( 'page_for_posts', $blog_page_id->ID );

}
add_action( 'pt-ocdi/after_import', 'jvcore_after_import_setup' );


function jvcroe_import_listing_category_icon() {
    $icons = Array(
        'fas fa-address-book',
        'fas fa-baby-carriage',
        'fas fa-beer',
        'fas fa-bible',
        'fas fa-blender-phone',
        'fas fa-book-medical',
        'fas fa-briefcase',
        'fas fa-bus',
        'fas fa-calendar-plus',
        'fas fa-cash-register',
        'fas fa-cart-arrow-down',
        'fas fa-chart-pie',
        'fas fa-charging-station',
        'fas fa-church',
        'fas fa-city',
        'fas fa-couch',
        'fas fa-door-closed',
        'fas fa-glass-martini',
        'fas fa-hourglass-start',
        'fas fa-hospital-alt',
    );

    if(!function_exists('lava_directory')) {
        return;
    }

    shuffle($icons);

    foreach(get_terms(Array(
        'taxonomy' => 'listing_category',
        'hide_empty' => false,
        'fields' => 'ids',
    ))as $term_index => $term_id) {
        $iconKey = $term_index % sizeof($icons);
        lava_directory()->admin->setTermOption(get_term($term_id), 'icon', $icons[$iconKey]);
    }

    foreach(get_terms(Array(
        'taxonomy' => 'listing_amenities',
        'hide_empty' => false,
        'fields' => 'ids',
    ))as $term_index => $term_id) {
        $iconKey = $term_index % sizeof($icons);
        lava_directory()->admin->setTermOption(get_term($term_id), 'icon', $icons[$iconKey]);
    }
}

function jvcroe_import_amenities_in_categories() {
    if(!function_exists('lava_directory')) {
        return;
    }

    $amenities = get_terms(Array(
        'taxonomy' => 'listing_amenities',
        'hide_empty' => false,
        'fields' => 'ids',
    ));

    foreach(get_terms(Array(
        'taxonomy' => 'listing_category',
        'hide_empty' => false,
        'fields' => 'ids',
    ))as $term_index => $term_id) {
        shuffle($amenities);
        $selectedAmenities = Array();
        for($iLoop=0;$iLoop<3;$iLoop++) {
            $selectedAmenities[] = $amenities[$iLoop];
        }
        lava_directory()->admin->setTermOption(get_term($term_id), 'features', $selectedAmenities);
    }
}

function jvcroe_findFeaturedCategoryImages(){
    $query = new \WP_Query(Array(
        'post_type' => 'attachment',
        'post_status' => 'any',
        'post_mime_type' => 'image/jpeg',
        'posts_per_page' => -1,
        'fields' => 'ids',
    ));
    $images = Array();
    foreach($query->get_posts() as $attachID) {
        $metaData = wp_get_attachment_metadata($attachID);
        if(1000 < intVal($metaData['width'])) {
            $images[] = $attachID;
        }
    }
    return $images;
}

function jvcore_import_category_featured_images() {
    if(!function_exists('lava_directory')) {
        return;
    }
    $images = jvcroe_findFeaturedCategoryImages();
    foreach(get_terms(Array(
        'taxonomy' => 'listing_category',
        'hide_empty' => false,
        'fields' => 'ids',
    ))as $term_index => $term_id) {
        $imageKey = $term_index % sizeof($images);
        $imageID = $images[$imageKey];
        lava_directory()->admin->setTermOption(get_term($term_id), 'featured', $imageID);
    }
}

function jvcore_import_category_markers() {
    if(!function_exists('lava_directory')) {
        return;
    }
    $markers = Array(
        'sport', 'yoga', 'airport', 'beer', 'bowling', 'bueaty', 'cafe',
        'car', 'club', 'education', 'food', 'game', 'health', 'hospital', 'hotel',
        'movie', 'music', 'restoran', 'shopping',
    );
    shuffle($markers);
    foreach(get_terms(Array(
        'taxonomy' => 'listing_category',
        'hide_empty' => false,
        'fields' => 'ids',
    )) as $term_index => $term_id) {
        $markerKey = $term_index % sizeof($markers);
        $fileURI = sprintf('%1$simages/markers/%2$s.png', jvbpdCore()->assets_url, $markers[$markerKey]);
        lava_directory()->admin->setTermOption(get_term($term_id), 'marker', $fileURI);
    }
}

function jvcore_import_review_fields() {
    $options = get_option('lava_lv_listing_review_param');
    $settings = is_array($options) ? $options : Array();
    $settings['rating_field'] = Array(
        'Service',
        'Location',
        'Quality',
        'Price',
        'Others',
    );
    update_option('lava_lv_listing_review_param', $settings);
}