<?php
class jvbpd_block extends Jvbpd_Shortcode_Parse {

	public $items_tag = 'div';
	public $item_tag = 'div';

	public $templates = Array();
	public $column_open = false;

	public function output( $attr, $content='' ) {
		parent::__construct( $attr );
		ob_start();
		$this->sHeader();
		?>
		<div id="<?php echo $this->sID; ?>" class="shortcode-container fadein">
			<?php
			if( 'taxonomy' != $this->block_type ) : ?>
				<div class="shortcode-header">
					<div class="shortcode-title">
						<div class="title_inner">
						<?php
						$header_title = $this->title;
						if (!empty($this->subtitle)&&'two_titles' == $this->filter_style){
						$header_title .= "<span class='subtitle'>".$this->subtitle."</span>";
						}
						echo $header_title;
						?>
						</div>
					</div>
					<div class="shortcode-nav">
						<?php $this->sFilter(); ?>
					</div>
				</div>

				<div class="shortcode-content">
					<?php if('yes' == $this->use_sidebar) { ?>
						<div class="shortcode-sidebar">
							<?php $this->redner_sidebar(); ?>
						</div>
					<?php } ?>
					<?php
					endif;
					$containerClass = apply_filters( 'javo_core/shortcode/block/output/css', Array( 'shortcode-output' ), get_class( $this ) );
					if( 'carousel' === $this->block_display_type ) {
						$containerClass[] = 'swiper-container';
					} ?>
					<div class="<?php echo join(' ', $containerClass); ?>">
						<?php
						$queried = Array();
						if( 'post' == $this->block_type ) {
							$queried = $this->get_post();
						}

						if( 'taxonomy' == $this->block_type ) {
							$queried = $this->get_terms();
						}
						$this->loop( $queried ); ?>
						<div class="swiper-pagination swiper-pagination-custom"></div>
					</div>

				</div>
			<?php
			if( 'carousel' === $this->block_display_type ) {
				echo $this->getSwiperControls();
			} ?>
		</div>
		<?php
		$this->sFooter(); return ob_get_clean();
	}

	public function getSwiperControls() {
		ob_start();
		?>
		<div class="swiper-button-prev"></div>
		<div class="swiper-button-next"></div>
		<?php
		return ob_get_clean();
	}

	public function parse_queried( $obj ) {
		if( $obj instanceof \WP_Post ) {
			$obj->_id = $obj->ID;
		}
		if( $obj instanceof \WP_Term ) {
			$obj->_id = $obj->term_id;
		}
		return $obj;
	}

	public function loop( $queried ) {
		if('yes'==$this->masonry){
			$this->items_tag = 'ul';
			$this->item_tag = 'li';
		}

		$containerClasses = Array('row');

		if('pre' == $this->module_type) {
			$containerClasses[] = 'products';
		}

		$output = sprintf('<%s class="%s">', $this->items_tag, implode(' ', $containerClasses) );
		if( 'carousel' === $this->block_display_type ) {
			$output ='<div class="swiper-wrapper">';
		}
		$queried = array_map( Array( $this, 'parse_queried' ), $queried );

		// Query Start
		$column_open = false;

		if( ! empty( $queried ) ) :
			if('pre' == $this->module_type) {
				$originPost = $GLOBALS['post'];
				ob_start();
				'yes' !== $this->masonry && 'carousel' !== $this->block_display_type && function_exists('woocommerce_product_loop_start') && woocommerce_product_loop_start();
				'yes' === $this->masonry && printf('<li class="masonry-gutter invisible m-0 p-0"></li>');
				function_exists('woocommerce_template_loop_add_to_cart') && remove_action( 'woocommerce_after_shop_loop_item', 'woocommerce_template_loop_add_to_cart', 10 );
				add_filter('woocommerce_post_class', Array($this, 'singleProductClass'), 10, 2);
				add_filter('single_product_archive_thumbnail_size', Array($this, 'singleProductThumbSize'));
				foreach( $queried as $index => $obj ) {
					$obj instanceof \WP_Post && $GLOBALS['post'] = get_post($obj->ID);
					setup_postdata($GLOBALS['post']);
					'carousel' === $this->block_display_type && printf('<div class="swiper-slide"><ul>');
					function_exists('wc_get_template_part') && wc_get_template_part( 'content', 'product' );
					'carousel' === $this->block_display_type && printf('</ul></div>');
				}
				remove_filter('woocommerce_post_class', Array($this, 'singleProductClass'), 10, 2);
				remove_filter('single_product_archive_thumbnail_size', Array($this, 'singleProductThumbSize'));
				$GLOBALS['post'] = $originPost;
				'yes' !== $this->masonry && 'carousel' !== $this->block_display_type && function_exists('woocommerce_product_loop_end') && woocommerce_product_loop_end();
				function_exists('woocommerce_template_loop_add_to_cart') && add_action( 'woocommerce_after_shop_loop_item', 'woocommerce_template_loop_add_to_cart', 10 );
				$output .= ob_get_clean();
			}else{
				if('yes' === $this->masonry) {
					$output .= sprintf('<li class="masonry-gutter invisible m-0 p-0"></li>');
				}
				if( ! in_array( $this->layout_type, Array( 'type_d', 'type_e' ) ) ) {
					foreach( $queried as $index => $obj ) {
						if( method_exists( $this, $this->layout_type ) ) {
							$output .= call_user_func_array( Array( $this, $this->layout_type ), Array( $obj, $index ) );
						}
					}
				}else{
					if( method_exists( $this, $this->layout_type ) ) {
						$output .= call_user_func_array( Array( $this, $this->layout_type ), Array( $queried ) );
					}
				}
			}
		endif;

		if( $this->column_open ) {
			$output .= '</div>';
			$this->column_open = false;
		}

		$output .= sprintf('</%s>', $this->items_tag);
		/*
		if( 'carousel' === $this->block_display_type ) {
			$output .= $this->getSwiperControls();
		} */
		echo $output;
		$this->sParams();
		$this->pagination();
	}

	public function getTemplates( $obj, $template ) {
		$wrapper_attribute = '';
		$wrapper_properties = apply_filters( 'javo_core/module/attribute', Array(
			'class' => 'module-item',
		), $obj);

		if( ! array_key_exists( $template, $this->templates ) ) {
			$templateContent = Elementor\Plugin::instance()->frontend->get_builder_content_for_display( "{$this->$template}" );
			if('' == $templateContent) {
				$templateContent = '<div class="alert alert-warning" role="alert">';
				$templateContent .= esc_html__("Please select a module", 'jvfrmtd');
				$templateContent .= '</div>';
			}
			$this->templates[ $template ] = $templateContent;
		}
		if('yes'== $this->module_click_popup){
			$wrapper_properties['data-popup-post-id'] = $obj->_id;
		}
		foreach($wrapper_properties as $property => $value) {
			$wrapper_attribute .= sprintf('%s="%s"', $property, esc_attr($value)) . ' ';
		}
		$wrapper = '<div ' . $wrapper_attribute . '>';
		$wrapper .= $this->templates[ $template ];
		$wrapper .= '</div>';
		return $wrapper;
	}

	public function redner_sidebar() {
		?>
		<div class="shortcode-sidebar-wrap">
			<div class="sidebar-filters">
				<div class="filter-item filter-active-item">
					<strong><?php esc_html_e("Active Filters"); ?></strong>
					<div class="filter-wrap">
						<ul class="filter-lists"></ul>
						<a href="javascript:void(0);" data-remove-all-filter>
							<span class="filter-label"><?php esc_html_e("Remove All", 'jvfrmtd'); ?></span>
							<span class="filter-remove">&times;</span>
						</a>
					</div>
					<hr class="mt-3">
				</div>

				<?php if(function_exists('WC')) { ?>
					<div class="filter-item filter-category">
						<strong><?php esc_html_e("Filter By Category"); ?></strong>
						<div class="filter-wrap">
							<ul class="filter-lists">
								<?php
								foreach(get_terms(Array(
									'taxonomy' => 'product_cat',
									'fields' => 'id=>name',
								)) as $cateID => $cateName) {
									?>
									<li class="" data-tax="product_cat" data-term="<?php echo esc_attr($cateID); ?>">
										<a href="javascript:void(0);" data-filter-trigger>
											<span class="filter-label"><?php echo $cateName; ?></span>
											<span class="filter-remove">&times;</span>
										</a>
									</il>
									<?php
								} ?>
							</ul>
						</div>
						<hr class="mt-3">
					</div>
				<?php } ?>

				<?php if(function_exists('WC') && taxonomy_exists('pa_color')) { ?>
					<div class="filter-item filter-color">
						<strong><?php esc_html_e("Filter By Color"); ?></strong>
						<div class="filter-wrap">
							<ul class="filter-lists">
								<?php
								foreach(get_terms(Array(
									'taxonomy' => 'pa_color',
								)) as $attr) {
									$colorCode = '#ffffff';
									switch($attr->slug) {
										case 'black': $colorCode = '#000000'; break;
										case 'blue': $colorCode = '#1000ff'; break;
										case 'brown': $colorCode = '#795548'; break;
										case 'gold': $colorCode = '#ff9800'; break;
										case 'gray': $colorCode = '#454545'; break;
										case 'green': $colorCode = '#4caf50'; break;
										case 'light-blue': $colorCode = '#7daafb'; break;
										case 'light-orange': $colorCode = '#ffb458'; break;
										case 'pink': $colorCode = '#ff01d4'; break;
										case 'red': $colorCode = '#ff0000'; break;
										case 'silver': $colorCode = '#9e9e9e'; break;
										case 'yellow': $colorCode = '#ffc107'; break;
									} ?>

									<li class="" data-tax="pa_color" data-term="<?php echo esc_attr($attr->term_id); ?>">
										<a href="javascript:void(0);" data-filter-trigger>
											<span class="filter-label"><?php echo esc_html($attr->name); ?></span>
											<span class="filter-color" style="background-color:<?php echo esc_attr($colorCode); ?>;"></span>
											<span class="filter-remove">&times;</span>
										</a>
									</il>
									<?php
								} ?>
							</ul>
						</div>
						<hr class="mt-3">
					</div>
				<?php } ?>

				<?php if(function_exists('WC') && taxonomy_exists('pa_size')) { ?>
					<div class="filter-item filter-size">
						<strong><?php esc_html_e("Filter By Size"); ?></strong>
						<div class="filter-wrap">
							<ul class="filter-lists">
								<?php
								foreach(get_terms(Array(
									'taxonomy' => 'pa_size',
								)) as $attr) {
									$outputLabel = $attr->name;
									switch($attr->slug) {
										case 'small': $outputLabel = 'S'; break;
										case 'medium': $outputLabel = 'M'; break;
										case 'large': $outputLabel = 'L'; break;
									} ?>
									<li class="" data-tax="pa_size" data-term="<?php echo esc_attr($attr->term_id); ?>">
										<a href="javascript:void(0);" data-filter-trigger>
											<span class="filter-label"><?php echo esc_html($outputLabel); ?></span>
											<span class="filter-remove">&times;</span>
										</a>
									</il>
									<?php
								} ?>
							</ul>
						</div>
						<hr class="mt-3">
					</div>
				<?php } ?>

				<?php if(function_exists('WC')) { ?>
					<div class="filter-item filter-price">
						<strong><?php esc_html_e("Filter By Price"); ?></strong>
						<div class="filter-wrap">
							<p class="mt-2"></p>
							<div class="price-slider jvbpd-ui-slider not-layer" data-noui data-min="0" data-max="1000"></div>
							<div class="price-range-label mt-2 clearfix">
								<div class="price-label price-min float-left"></div>
								<div class="price-label price-max float-right"></div>
							</div>
						</div>
					</div>
				<?php } ?>

			</div>
		</div>
		<?php
	}

	public function type_a( $obj, int $index=0 ) {
		$output = '';

		switch( intVal( $this->columns ) ) {
			case 2: $output .= '<div class="col-md-6">'; break;
			case 3: $output .= '<div class="col-md-4">'; break;
			case 4: $output .= '<div class="col-md-3">'; break;
			case 6: $output .= '<div class="col-md-2">'; break;
			default: $output .= '<div class="col-md-12">';
		}

		if( 'carousel' === $this->block_display_type ) {
			$output = '<div class="swiper-slide">';
		}
		if('yes'==$this->masonry){
			$output = sprintf('<%s class="masonry-item">', $this->item_tag);
		}

		$instance = new Jvbpd_Replace_Content( $obj->_id, $this->getTemplates( $obj, 'column_1' ), $this->block_type, $this->filter_by );
		$output .= $instance->render();
		$output .= sprintf('</%s>', $this->item_tag);
		return $output;
	}

	public function type_b( $obj, int $index=0 ) {
		$output = '';
		if( 0 == $index ) {
			$instance = new Jvbpd_Replace_Content( $obj->_id, $this->getTemplates( $obj, 'column_1' ), $this->block_type, $this->filter_by );
			$output .= '<div class="col-md-6">';
				$output .= $instance->render();
			$output .= '</div><div class="col-md-6">';
			$this->column_open = true;
		}else {
			$instance = new Jvbpd_Replace_Content( $obj->_id, $this->getTemplates( $obj, 'column_2' ), $this->block_type, $this->filter_by );
			$output .= $instance->render();
		}
		return $output;
	}

	public function type_c( $obj, int $index=0 ) {
		$output = '';
		if( intVal( $this->columns ) <= $index ) {
			$instance = new Jvbpd_Replace_Content( $obj->_id, $this->getTemplates( $obj, 'column_2' ), $this->block_type, $this->filter_by );
		}else{
			$instance = new Jvbpd_Replace_Content( $obj->_id, $this->getTemplates( $obj, 'column_1' ) , $this->block_type, $this->filter_by );
		}
		switch( intVal( $this->columns ) ) {
			case 2: $output .= '<div class="col-md-6">'; break;
			case 3: $output .= '<div class="col-md-4">'; break;
			case 4: $output .= '<div class="col-md-3">'; break;
			case 6: $output .= '<div class="col-md-2">'; break;
			default: $output .= '<div class="col-md-12">';
		}
			$output .= $instance->render();
		$output .= '</div>';
		return $output;
	}

	public function type_d( array $queried_posts=Array() ) {
		$output = '';
		for( $iColumn=1; $iColumn<=4; $iColumn++ ) {
			switch( $iColumn ) {
				case 1: $output .= '<div class="col-md-6">'; break;
				case 2: $output .= '<div class="col-md-6"> <div class="row"><div class="col-md-12">'; break;
				case 3: $output .= '</div><div class="row"><div class="col-md-6">'; break;
				case 4: $output .= '<div class="col-md-6">'; $this->column_open = true; break;
			}
			if( !empty( $queried_posts[ $iColumn ] ) ) {
				$instance = new Jvbpd_Replace_Content( $queried_posts[ $iColumn ]->_id, $this->getTemplates( $obj, 'column_1' ), $this->block_type, $this->filter_by );
				$output .= $instance->render();
			}
			$output .= '</div>';
		}
		return $output;
	}

	public function type_e( array $queried_posts=Array() ) {
		$output = '';
		for( $iColumn=1; $iColumn<=5; $iColumn++ ) {
			switch( $iColumn ) {
				case 1: $output .= '<div class="col-md-6">'; break;
				case 2: $output .= '<div class="col-md-6"> <div class="row"><div class="col-md-6">'; break;
				case 3: $output .= '<div class="col-md-6">'; break;
				case 4: $output .= '</div><div class="row"><div class="col-md-6">'; break;
				case 5: $output .= '<div class="col-md-6">'; $this->column_open = true; break;
			}
			if( !empty( $queried_posts[ $iColumn ] ) ) {
				$instance = new Jvbpd_Replace_Content( $queried_posts[ $iColumn ]->_id, $this->getTemplates( $obj, 'column_1' ), $this->block_type, $this->filter_by );
				$output .= $instance->render();
			}
			$output .= '</div>';
		}
		return $output;
	}

	public function singleProductClass($classes=Array(), $product=null) {
		if('yes' == $this->masonry) {
			$classes[] = 'masonry-item';
			if($this->filter_by) {
				$terms = wp_get_object_terms($product->get_id(), $this->filter_by, Array('fields' => 'ids'));
				$term = isset($terms[0]) ? current($terms) : false;
				if(false !== $term) {
					$classes[] = 'cat-' . $term;
				}
			}
		}
		return $classes;
	}

	public function singleProductThumbSize($image) {
        return $this->module_thumb_size;
	}

}