( function( $ ) {

	let CLASS_LAZY = 'jvbpd-lazy';
	let CLASS_LAZYLOAD = 'lazy-loaded';
	let Util = function() {}
	Util.prototype.constructor = Util;

	Util.prototype.updateURL = function(url, param, paramVal) {
		var newAdditionalURL = "";
		var tempArray = url.split("?");
		var baseURL = tempArray[0];
		var additionalURL = tempArray[1];
		var temp = "";
		if (additionalURL) {
			tempArray = additionalURL.split("&");
			for (var i=0; i<tempArray.length; i++){
				if(tempArray[i].split('=')[0] != param){
					newAdditionalURL += temp + tempArray[i];
					temp = "&";
				}
			}
		}

		var rows_txt = temp + "" + param + "=" + paramVal;
		return baseURL + "?" + newAdditionalURL + rows_txt;
	}

	Util.prototype.getLightBox = function(selector) {
		var $selector = $('#' + selector);

		if(!$selector.length) {
			$selector = $('<div>').prop({
				'class': 'modal fade',
				'id': selector,
				'role': 'dialog'
			}).append(
					$('<div>').prop('class', 'modal-dialog').append(
					$('<div>').prop('class', 'modal-content text-right').append(
						new Array(
							$('<button>').attr({
								type: 'button',
								class: 'close text-right',
								'data-dismiss': 'modal',
							}).html(
								'<span aria-hidden="true">&times;</span>'
							),
							$('<div>').prop('class', 'modal-body text-left')
						)
					)
				)
			).appendTo($('body'));
		}
		return $selector;
	}

	Util.prototype.getToast = function(selector) {
		var $selector = $('#' + selector);

		if(!$selector.length) {
			$selector = $('<div>').attr({
				'class': 'javo-core-toast',
				'id': selector,
			}).append(
				$('<div>').attr({
					'class': 'toast',
					'role': 'alert',
					'aria-live': 'assetive',
					'aria-atomic': 'true'
				}).append(
					new Array(
						$('<div>').prop('class', 'toast-header').append(
							new Array(
								$('<strong>').addClass('toast-title mr-auto'),
								$('<button>').attr({
									'type': 'button',
									'data-dismiss': 'toast',
								}).addClass('ml-2 mb-1 close').html(
									'<span aria-hidden="true">&times;</span>'
								)
							)
						),
						$('<div>').addClass('toast-body')
					)
				)
			).appendTo($('body'));
		}
		return $selector;
	}

	Util.prototype.getExtendPanel = function(selector) {
		var $selector = $('#' + selector);

		if(!$selector.length) {
			$selector = $('<div>').prop({
				'class': 'javo-map-block-extend-panel hidden',
				'id': selector,
			}).append(
					$('<div>').prop('class', 'panel-wrap').append(
					$('<div>').prop('class', 'panel-content text-right').append(
						new Array(
							$('<button>').attr({
								type: 'button',
								class: 'close text-right',
								'data-dismiss': 'panel',
							}).html(
								'<span aria-hidden="true">&times;</span>'
							),
							$('<div>').prop('class', 'panel-body text-left')
						)
					)
				)
			).appendTo($('body'));
		}
		$('button.close[data-dismiss]', $selector).each(function(){
			var $button = $(this);
			if($button.hasClass('bind-event')) {
				return;
			}
			$button.addClass('bind-event').on('click', function(event){
				event.preventDefault();
				$selector.addClass('hidden').trigger('panel.close', selector);
			})
		})
		return $selector;
	}

	Util.prototype.getNOUISliderParam = function( element ) {
		var
			el = $( element ),
			property = {};

		property.min = parseFloat( el.data( 'min' ) || 0 );
		property.max = parseFloat( el.data( 'max' ) || 0 );
		property.prefix = el.data( 'prefix' ) || '';
		property.suffix = el.data( 'suffix' ) || '';
		property.current = parseFloat( el.data( 'current' ) || 0 );
		property.step = parseFloat( el.data( 'step' ) || 1 );

		return {
			start : [ property.min, property.max ],
			step : property.step,
			connect : true,
			range : { 'min' : property.min, 'max' : property.max },
			tooltips: [ false, false, true ],
			serialization : {
				lower :[
					$.Link( {
						target : $( '.tooltip-min', el ),
						method : function(v) {
							$( this ).html( '<span>' + property.prefix + v + property.suffix +'</span>' );
						},
						format : { decimals : 0, thousand : ',' }
					})
				],
				upper : [
					$.Link({
						target : $( '.tooltip-max', el ),
						method : function(v) {
							$( this ).html( '<span>' + property.prefix + v + property.suffix + '</span>' );
						},
						format : { decimals : 0, thousand : ',' }
					})
				]
			}
		}
	}

	// InView Animation
	$.fn.JVinAppearAnimationsInit = function( $scope ){
        $scope = $scope || $(this);

        var $target = $scope.hasClass('jvfrm-appear-watch-animation') ? $scope : $scope.find('.jvfrm-appear-watch-animation');

        if( ! $target.length ){
            return;
        }

        if ( $('body').hasClass('jvfrm-page-animation') ) {

            $('body').on('AuxinPageAnimationDone', function(){
             // InView Animations
                $target.appearl({
                    offset: '200px',
                    insetOffset:'0px'
                }).one( 'appear', function(_event, _data) {
                    this.classList.add('jvfrm-animated');
                    this.classList.add('jvfrm-animated-once');
                });
            });
        } else {
            // InView Animations
            $target.appearl({
                offset: '200px',
                insetOffset:'0px'
            }).one( 'appear', function(_event, _data) {
                this.classList.add('jvfrm-animated');
                this.classList.add('jvfrm-animated-once');
            });
        }
	}

	$.fn.JVinParallaxBoxInit = function( $scope ){
        $scope = $scope || $(this);

        // General parallax box
        $scope.find('.jvfrm-parallax-box').AvertaParallaxBox();
    }

    // Parallax Section
    $.fn.JVinParallaxSectionInit = function( $scope ){
        $scope = $scope || $(this);

		var $target = $scope.hasClass('jvfrm-parallax-section') ? $scope : $scope.find('.jvfrm-parallax-section');
        if( ! $target.length ){
            return;
        }

        // Only init the parallax on deepest section
        $target.each( function(_key, _item){
            var $parallax_box = $(this);

            if( ! $parallax_box.find('.jvfrm-parallax-section').length ){
                $parallax_box.AvertaParallaxBox({
                    targets: 'jvfrm-parallax-piece'
                });
            }
        });
    };


    // Parallax Section
    $.fn.JVinScrollableAnimsInit = function( $scope ){
        $scope = $scope || $(this);

		var $target = $scope.hasClass('jvfrm-scroll-anim') ? $scope : $scope.find('.jvfrm-scroll-anim');
        if( ! $target.length ){
            return;
		}
        // Only init the parallax on deepest section
        $target.each( function(_key, _item){
            var $parallax_box = $(this);
            $parallax_box.AvertaScrollAnims();
        });
	}
	var jvbpd_core_elementor = function() {
		this.isExistsElmentor = typeof elementor !== 'undefined';
		this.args = jvbpd_elementor_args;
		this.util = new Util;
		this.init();
	}

	jvbpd_core_elementor.prototype = {
		selectors : {
			carousel : 'jvbpd-swiper-carousel',
			thumbnail : 'jvbpd-thumbs-swiper',
		}
	};

	jvbpd_core_elementor.prototype.constructor = jvbpd_core_elementor;

	jvbpd_core_elementor.prototype.init = function() {
		var
			self = this,
			loadModuleCallbacks = function() {
				self.moduleBriefOnBlockWidget();
				self.moduleDetailImagesOnBlockWidget();
				self.sliderDetailImagesOnBlockWidget();
				self.moduleVideoOnBlockWidget();
				self.authorReviewModal();
				self.jvbpdPopupModal();
				// if(typeof jQuery.fn.flexSlider !== 'undefined') {
					self.cardDetailSlider();
					self.cardStreetView();
				// }

				self.blockExtendPanel();
				self.setupTooltips();
				self.dynamicCompareButton();
			};

		//if( !$( 'body' ).hasClass( 'lv-map-template' ) ) {
			loadModuleCallbacks();
		//}

		$( window ).on( 'javo:map/items/get/after', function() {
			loadModuleCallbacks();
		} );

		$( window ).on('jvbpd_core/shortcode/render/after', function(){
			self.postBlockAnimOnScroll();
		})

		$(window).on('javo:map/items/get/after', self.itemGetAfterMasonry());

		$( window ).on( 'jvbpd_core/shortcode/loaded', function( _event, obj ) {
			$( this ).on( 'jvbpd_core/shortcode/filter/after.' + obj.ID, function() {
				loadModuleCallbacks();
			});
		});

		if( self.isExistsElmentor ) {
			$( document ).ready( function() {
				self.bindEvents();
			} );
		}

		$( document ).ready( function() {
			self.setupMapnoUISlider();
			self.setupTooltips();
		} );

		self.searchFormSubmit();
		self.scrollSpy();
		self.applySlimScroll();
		self.postBlockAnimOnScroll();
		self.portfolioGallery();
		// self.singleGalleryMasonry();
		self.allBlockEffectAni();
		self.parallaxSections();
		// self.fullHeightSections();
		self.postBlockPopups();
		self.testimoonialPopups();
		self.mapBlockOrder();
		self.navMetisMenus();
		// self.mapBlockAnimOnScroll();
		self.mapBlockSetCount();
		self.authorReviewModal();
		self.jvbpdPopupModal();
		self.swapDistanceUnit();
		self.mapSwitch();
		self.mapSearchForm();
		self.mapListingTypeSelect();
		self.jvTabsScript();
		self.navMenuSub();
		self.singleGroup();
		self.singleHeader();
		self.mapSidePanel();
		self.lavaNearby();
		self.lavaYelpNearby();
		self.lavaDynamicAccordion();
		self.lavaDynamicCompare();
		self.reviewFilter();
		self.categoryBlock();

		$( document ).ready( function() {
			// self.mapListFilterSlimScroll();
			self.mapListFilterCollapse();
			self.mapTotalCounter();
			self.bindStickyElements();
			self.customLavaAS();

		} );

		$(window).on('load', function(){
			self.scrollMagic();
		});

		$( window ).on( 'load', self.navMenuScript() );
		$( window ).on( 'load', self.carousel() );
		$( window ).on( 'load', self.slick() );
		self.loginForm();
		self.getMemberForm();
		$( window ).on( 'load', self.loginForm() );
		$( window ).on( 'elementor/frontend/init', self.elementor_edithook() );
		$( document ).ready( self.bind_reset_filter() );
		$( document ).ready( self.bind_list_grid_toggle() );
		$( document ).ready( self.block_bind_mansorny() );
		$( window ).on( 'load', self.map_sort_dropdown() );
		$( window ).on( 'load', self.map_list_banner() );
		$( window ).on( 'load', self.map_location_filter() );
		$( window ).on( 'jvbpd_core/canvas/get/completed', function() {
			self.navMetisMenus();
		});
		$( document ).ready( self.menu_opener() );
		$( document ).on( 'lava:single-msp-setup-after', self.applyMapStyle() );
		$('body:not(.lv-map-template) .jvbpd-search-form-section').on('submit', self.search_section_submit());

		$('.lava-ajax-search-form-wrap').on('lava:init/before', self.searchFormAjax());

		if( false && 'enable' == self.args.settings.lazyload ) {
			$( window ).on( 'load', function() {
				$( this ).on( 'scroll' , self.lazyRollover() ).trigger( 'scroll' );
			} );

			$( window ).on( 'lava:post-review/add-listing/template/before-insert', function( _event, template ) {
				self.lazyload( template );
				$( window ).trigger( 'scroll' );
			} );

			$( window ).on( 'jvbpd_core/shortcode/loaded', function( _event, obj ) {
				self.lazyload( $( '.shortcode-output', obj.el ) );
				$( window ).trigger( 'scroll' );
			} );

			$( document ).ready( function(){
				self.lazyload( $( 'body' ) );
			} );
		}
	}

	jvbpd_core_elementor.prototype.bindEvents = function() {
		var self = this;
		self.previewChange( 'search_shortcode_in_header', function( value ) {
			var header = $( '.jvbpd-header-map-filter-container' );
			if( value == 'yes' ) {
				header.removeClass( 'hidden' );
			}else{
				header.addClass( 'hidden' );
			}
		} );
		self.previewChange( '', function( _value ) {
			this.save( function() {
				elementor.reloadPreview();
			});
		} );
	}

	jvbpd_core_elementor.prototype.previewChange = function( setting, callback ) {
		elementor.settings.page.addChangeCallback( setting, callback );
	}

	jvbpd_core_elementor.prototype.setupNavMenuWidget = function() {
		var
			callback,
			property = {},
			megaMenu = $( '.wide-nav-overlay' ),
			megaMenuWidth = 1024;

		callback = function() {
			var
				winX = $( this ).width(),
				megaX = megaMenu.offset().left,
				offX = 0;

			offx = Math.max( 0, ( winX - megaMenu.width() ) / 2 );
			offX = offx - megaX;
			if( winX >= megaMenuWidth ) {
				property.width = megaMenuWidth;
				property.left = offX + 'px';
			}else{
			}
			megaMenu.css( property );
		}

		$( window ).on( 'resize', callback );
		callback();
	}

	jvbpd_core_elementor.prototype.setupMapnoUISlider = function() {
		let self = this;
		$( 'body.lv-map-template .jvbpd-ui-slider' ).each( function() {
			let opt = self.util.getNOUISliderParam(this);
			$( '.slider', this ).noUiSlider(opt);
			$( '.slider', this ).on( 'set', function( _event, _value ) {
				$( window ).on( 'javo:map/filter/after', function( _event, _items ) {
					let items = _items.items;
					// let _value = $( '.jvbpd-ui-slider .slider' ).val();
					let value = {
						min : parseFloat( _value[0] ),
						max : parseFloat( _value[1] )
					}

					if(value.min == opt.range.min && value.max == opt.range.max) {
						return;
					}

					_items.set( new Array() );

					$.each( items, function( index, data ) {
						let price = parseFloat( data.price );
						if(0< parseFloat(data.sale_price)){
							price = parseFloat( data.sale_price )
						}

						data = data || {};

						if( price >= value.min && price <= value.max ) {
							_items.add( items[ index ] );
						}
					} );
					$(this).off(_event);
				} );
				$( document ).trigger( 'javo:map_refresh' );
			} );
		} );
	}

	jvbpd_core_elementor.prototype.setupTooltips = function() {
		var bindCallback = function() {
			$('[data-toggle="tooltip"]').each(function(){
				var $this = $(this);
				if($this.data('bind-tooltip')) {
					return true;
				}
				$this.data('bind-tooltip', true);
				$this.tooltip();
			});
		}
		$(window).on('scroll', bindCallback);
		bindCallback();
		return this;
	}

	jvbpd_core_elementor.prototype.dynamicCompareToast = function(options) {
		var self = this;
		var $toast = self.util.getToast('dynamic-compare-toast');
		var opt = $.extend(true, {}, {
			title: '',
			content: '',
			icon: false,
			animation: true,
			autohide: true,
			delay: 1000,
		}, options);
		var title = opt.title;
		if(opt.icon) {
			title = '<i class="' + opt.icon +'"></i>' + ' ' + title;
		}
		$('strong.toast-title', $toast).html(title);
		$('div.toast-body', $toast).html(opt.content);
		$('.toast', $toast).toast(opt);
		$('.toast', $toast).toast('show');
	}

	jvbpd_core_elementor.prototype.dynamicCompareButton = function() {
		var self = this;
		var compareArgs = 'undefined' != typeof lava_dynamic_compare_args ? lava_dynamic_compare_args : {};

		$('a.lava-dynamic-compare-button.type-in-module:not(.bind)').on('click', function(event){
			event.preventDefault();

			var compareIDs = ( $.cookie('lava-dynamic-compare-ids') || '|').split('|').filter(function(a){return a!==''});

			var $button = $(this);
			var post_id = $button.data('post-id').toString();

			var output = '<a href="' + compareArgs.compare_page + '" class="btn btn-primary">' + $button.data('comopare-text') + '</a>';
			var thumbURL = $button.data('thumb');

			if(thumbURL) {
				output = '<div class="media"> ' +
				'<img src="' + thumbURL + '" class="pr-3" style="max-width:80px;">' +
				'<div class="media-body pt-2">' + output + '</div>' +
				'</div>';
			}

			self.dynamicCompareToast({
				'title': $button.data('title'),
				'content': output,
				'delay': 3000,
			});

			if(-1 == compareIDs.indexOf(post_id)) {
				compareIDs.push(post_id);
			}

			$.cookie('lava-dynamic-compare-ids', compareIDs.join('|'), {
				'expires' : 365,
				'path' : '/',
			});
			$(window).trigger('lava/dynamicCompare/add_item', [compareIDs, post_id]);

			$button.addClass('bind');
		})
	}

	jvbpd_core_elementor.prototype.getAdvancedFields = function( form ) {
		$( '.jvbpd-advanced-button' ).each( function() {
			var
				div = $( '<div>' ).addClass( 'hidden' ),
				section = $( $( this ).data( 'target' ) ),
				controls = $( 'input, select', section );
			if( section.length ) {
				controls.clone().appendTo( div );
				div.appendTo( form );
			}
		} );
	}

	jvbpd_core_elementor.prototype.searchFormSubmit = function() {
		var self = this;

		$( '.jvbpd-search-submit' ).each( function() {
			var
				$this = $( this ),
				parentForm = $this.closest( '.jvbpd-search-form-section' ),
				parentFormExists = parentForm.length;

			if( $this.data('bind-submit') ) {
				return;
			}

			if( parentFormExists ) {
				$( this ).on( 'click', function( event ) {
					event.preventDefault();
					self.getAdvancedFields( parentForm );
					parentForm.submit();
				} );
				$this.data('bind-submit', 'true');
			}
		} );
	}

	jvbpd_core_elementor.prototype.search_section_submit = function() {
		var self = this;
		return function(event) {
			var
				$form = $(this),
				fields = {},
				submit_form = $('#jvbpd-search-submit-form');
			event.preventDefault();

			if(submit_form.length) {
				submit_form.remove();
			}

			$('input[type="text"], input[type="hidden"]', $form).each(function(){
				var
					$this = $(this),
					key = $this.prop('name'),
					val = $this.val();

				if(val){
					fields[key] = val;
				}
			});

			$('input[type="checkbox"]:checked', $form).each(function(){
				var
					$this = $(this),
					key = $this.prop('name'),
					val = $this.val();

				if(val){
					if(typeof fields[key] != 'object'){
						fields[key] = new Array();
					}
					fields[key].push(val);
				}
			});

			$('select', $form).each(function(){
				var
					val = '',
					$this = $(this),
					instance = this.selectize,
					key = $this.prop('name');

				if(instance){
					val = instance.getValue();
					if(val){
						fields[key] = val;
					}
				}
			});

			submit_form = $('<form>').prop({
				'id': 'jvbpd-search-submit-form',
				'method': 'get',
				'action': $form.attr('action'),
			}).addClass('hidden');

			$.each(fields, function(fieldKey, fieldValue){
				if(typeof fieldValue != 'object') {
					$('<input>').prop({
						type: 'hidden',
						name: fieldKey,
						value: fieldValue,
					}).appendTo(submit_form);
				}else{
					$.each(fieldValue, function(){
						$('<input>').prop({
							type: 'hidden',
							name: fieldKey,
							value: this,
						}).appendTo(submit_form);
					});
				}
			});
			submit_form.appendTo($('body'));
			submit_form.submit();
		}
	}

	jvbpd_core_elementor.prototype.navMenuScript = function() {
		var
			self = this,
			menus = $( 'div[id^="jvbpd-nav-menu-id"], .jvbpd-collapse-section' );

		return function() {
			if( typeof elementorFrontend == 'undefined' ) {
				return;
			}
			menus.each( function() {
				var
					obj = $( this ),
					parent = $( this ).closest( '.elementor-element' ),
					isFullWidth = parent.hasClass( 'jvbpd-nav-menu-full-width' );

				if( typeof elementorFrontend.modules == 'undefined' ) {
					return;
				}

				if( ! isFullWidth && ! obj.is( '.jvbpd-collapse-section' ) ) {
					return ;
				}

				if( ! obj.data( 'stretch' ) ) {
					obj.data( 'stretch', new elementorFrontend.modules.StretchElement( { element: obj } ) );
				}

				obj.on( 'show.bs.collapse', function() {
					obj.removeClass( 'collapse' );
					if( obj.is( '.jvbpd-collapse-section-absolute' ) ) {
						obj.css( 'position', 'absolute' );
					}
					obj.data( 'stretch' ).stretch();
					obj.css( 'top', obj.data( 'position-top' ) );
					obj.addClass( 'collapse' );
				} );

				obj.on( 'hidden.bs.collapse', function() {
					if( ! obj.is( '.jvbpd-collapse-section-absolute' ) ) {
						obj.data( 'stretch' ).reset();
					}
				} );

			} );

			if( ! elementorFrontend.isEditMode() ) {
				elementorFrontend.addListenerOnce( 'nav_menu_resize', 'resize', function() {
					menus.each( function() {
						var
							obj = $( this ),
							parent = obj.closest( '.elementor-element' ),
							isFullWidth = parent.hasClass( 'jvbpd-nav-menu-full-width' );

						if($(window).width() < 767){
							parent.removeClass('cur-device-mobile').addClass('cur-device-tablet');
						}else if($(window).width() < 486){
							parent.removeClass('cur-device-tablet').addClass('cur-device-mobile');
						}else{
							parent.removeClass('cur-device-tablet').removeClass('cur-device-mobile');
						}

						if( ! isFullWidth && $( this ).is( '.jvbpd-collapse-section' ) ) {
							return true;
						}

						obj.css( 'top', obj.data( 'position-top' ) );

						if( obj.data( 'stretch' ) ) {
							if( $( window ).width() < 767 ) {
								obj.data( 'stretch' ).stretch();
							}else{
								obj.data( 'stretch' ).reset();
							}
						}

					} );
				} );
			}
		}
	}

	jvbpd_core_elementor.prototype.mapListFilterSlimScroll = function() {
		var
			listFilter = $( '.jvbpd_map_list_sidebar_wrap' ),
			cbContainer = $( '.ui-checkbox .panel-body', listFilter );

		if( typeof $.fn.slimScroll !== 'function' || ! cbContainer.length ) {
			return false;
		}
		cbContainer.each( function() {
			var containerHeight = $( this ).outerHeight();
			$( this ).slimScroll({
				height: containerHeight + 'px',
				distance: '6px',
				railVisible: true,
				alwaysVisible: true,
				railColor: '#ccc',
				railOpacity: 0.8,
			});
		} );
	}

	jvbpd_core_elementor.prototype.mapListFilterCollapse = function() {
		$('.elementor-widget-jvbpd-map-list-filters').each(function(){

			// Show child term on click parent term
			let $widget = $(this);
			$('.chk-label', $widget).on('click', function(){
				let $wrap = $(this).closest('.form-check');
				let $checkbox = $('input[type=checkbox]', $wrap);
				let $subDiv = $('.child-term-checkbox.parent-term-' + $checkbox.val(), $widget);

				$subDiv.toggleClass('hidden');
			});

			// Coallpse Panel
			$('input[type="checkbox"][data-tax]:checked', $widget).each(function(){
				var $wrap = $(this).closest('.panel');
				var $formCheck = $(this).closest('.child-term-checkbox');

				$('.panel-heading', $wrap).removeClass('collapsed');
				$formCheck.removeClass('hidden');
				$('.panel-collapse', $wrap).addClass('show');

			});
		});
	}

	jvbpd_core_elementor.prototype.mapTotalCounter = function() {
		var self = this;
		$('.elementor-widget-jvbpd-map-list-filter-total-count').each(function(){
			var $widget = $(this);
			var $output = $('.counter-output', $widget);
			$(window).on('javo:map/items/get/after', function(_event, _args, obj){
				var count = obj.apply_item.length;
				$output.html(
					count.toString().replace(/(\d)(?=(?:\d{3})+(?!\d))/g, '$1,')
				);
			});
		});
		/*
		$( '.jvbpd-map-list-total-count-wrap' ).each( function() {
			var
				output = $( '.counter-output', this );
			if( output.length ) {
				$( window ).on( 'javo:map/filter/after', function( event, item ) {
					item.unique();
					output.html( item.items.length.toString().replace(/(\d)(?=(?:\d{3})+(?!\d))/g, '$1,') );
				} );
			}
		} ); */
	}

	jvbpd_core_elementor.prototype.bindStickyElements = function() {
		var
			self = this,
			custom_settings = {},
			adminbar = $('#wpadminbar'),
			header = $('.header.header-elementor .jvbpd-sticky-element'),
			elements = $('.jvbpd-sticky-element');

		elements.each( function() {
			var $this = $(this);
			var offY = 0;
			var settings = $this.data('settings') || {};
			var skin = $this.data('sticky-skin');

			if($this.data('offset')) {
			// if($this.closest('.header.header-elementor').length) {
				$this = $( '>div', $this);
				offY += $this.offset().top;
			}else{
				if( header.length ) {
					// offY += header.height();
				}
				if( adminbar.length ) {
					offY += adminbar.height();
				}
				/*
				custom_settings = $this.data('settings');
				if(custom_settings.jvbpd_sticky_offset&&0<parseInt(custom_settings.jvbpd_sticky_offset.size)) {
					offY += parseInt(custom_settings.jvbpd_sticky_offset.size);
				} */
			}

			if('skin2' == skin) {
				$(window).on('scroll', function(){
					if(offY + $this.outerHeight() < $(this).scrollTop() ) {
						var sticky = $this._sticky({topSpacing:offY, zIndex:settings.jvbpd_sticky_zIndex||1000});
						if(!$this.hasClass('animated')){
							var nItmeID = setInterval(function(){
								$this.addClass('animated')
								clearInterval(nItmeID);
							}, 100);
						}
					}else{
						var usticky = $this._unstick({topSpacing:offY, zIndex:settings.jvbpd_sticky_zIndex||1000});
						$this.removeClass('animated');
					}
				})
			}else if('skin3' == skin){
				var $column = $this.closest('.elementor-element.elementor-column');

				$this.addClass('theiaStickySidebar');
				if( header.length ) {
					offY += header.height();
				}
				$column.theiaStickySidebar({ additionalMarginTop : offY });
			}else{
				var sticky = $this._sticky({topSpacing:offY, zIndex:settings.jvbpd_sticky_zIndex||1000});
			}
		});
	}

	jvbpd_core_elementor.prototype.waitButton = function( button, available ) {
		var _DISABLE = 'disabled';
		if( available ) {
			button.removeClass( _DISABLE ).removeAttr( _DISABLE ).prop( _DISABLE, false );
		}else{
			button.addClass( _DISABLE ).attr( _DISABLE, _DISABLE ).prop( _DISABLE, true );
		}
	}

	jvbpd_core_elementor.prototype.preview_map = function( container ) {
		var
			self = this,
			map = $( '.jvbpd-preview-map', container ),
			latLng = new google.maps.LatLng( map.data( 'lat' ) || 0, map.data( 'lng' ) || 0 );
		map.height(300).gmap3({
			map: {
				options: {
					'center' : latLng,
					'zoom' : 16
				}
			},
			marker: {
				'latLng' :  latLng,
			}
		});
	}

	jvbpd_core_elementor.prototype.ajax = function( _action, _param, callback, failcallback ) {
		var self = this;

		if(window.FormData && _param instanceof FormData ) {
			_param.append('action', 'jvbpd_' + _action);
			$.ajax({
				url: self.args.ajaxurl,
				data: _param,
				type : 'POST',
				processData: false,
				contentType: false,
				success : function(data){
					if( typeof callback == 'function' ) {
						callback( data );
					}
				},
				error : function(xhr, _state, err) {
					if( typeof failcallback == 'function' ) {
						failcallback( xhr, err );
					}
				}
			});
		}else{
			var param = $.extend( true, {}, { action: 'jvbpd_' + _action }, _param );
			$.post( self.args.ajaxurl, param, function( data ) {
				if( typeof callback == 'function' ) {
					callback( data );
				}
			}, 'JSON')
			.fail( function( xhr, err ){
				if( typeof failcallback == 'function' ) {
					failcallback( xhr, err );
				}
			} );
		}

	}

	jvbpd_core_elementor.prototype.moduleBriefOnBlockWidget = function() {
		var
			self = this,
			previewOpen = false,
			callback = function( event ) {
				event.preventDefault();
				var
					modal = $( '#javo-infow-brief-window' ),
					body = $( '.modal-body', modal ),
					button = $( this ),
					item_id = button.closest( '.module' ).data( 'post-id' ),
					preview_id = 0;

				if( button.data( 'post-id' ) ) {
					item_id = button.data( 'post-id' );
				}

				var $widget = $(this).closest('.elementor-widget[data-settings]');
				var widgetSettings = $widget.data('settings') || {};

				if( widgetSettings.module_preview_id ) {
					preview_id = widgetSettings.module_preview_id;
				}

				if( previewOpen ) {
					return;
				}

				previewOpen = true;

				self.waitButton( button, false );
				self.ajax( 'map_brief', { post_id: item_id, preview: preview_id}, function( data ) {
					body.html( data.html ).scrollTop(0);
					modal.off( 'shown.bs.modal' ).on( 'shown.bs.modal', function() {
						self.preview_map( body );
					} );
					modal.modal( 'show' );
					self.waitButton( button, true );
					previewOpen = false;
				} );
			};

		$( '.module[data-post-id] .javo-infow-brief, a.javo-infow-brief' ).each( function() {
			if( ! $( this ).data( 'preview_instance' ) ) {
				$( this ).on( 'click', callback );
				$( this ).data( 'preview_instance', true );
			}
		} );
	}

	jvbpd_core_elementor.prototype.moduleDetailImagesOnBlockWidget = function() {
		var
			self = this,
			previewOpen = false,
			callback = function( event ) {
				event.preventDefault();
				var
					modal = $( '#javo-infow-brief-window' ),
					body = $( '.modal-body', modal ),
					button = $( this ),
					item_id = button.closest( '.module' ).data( 'post-id' );

				if( button.data( 'post-id' ) ) {
					item_id = button.data( 'post-id' );
				}

				if( previewOpen ) {
					return;
				}

				previewOpen = true;

				self.waitButton( button, false );
				self.ajax( 'detail_images', { post_id: item_id }, function( data ) {
					body.html( data.html ).scrollTop(0);
					modal.off( 'shown.bs.modal' ).on( 'shown.bs.modal', function() {
						var mySwiper = new Swiper( $( '.swiper-container', body ), {
							loop: true,
							pagination: {
								el: '.swiper-pagination',
							},
							navigation: {
								nextEl: '.swiper-button-next',
								prevEl: '.swiper-button-prev',
							},
							// And if we need scrollbar
							scrollbar: {
								el: '.swiper-scrollbar',
							},
						});
					} );
					modal.modal( 'show' );
					self.waitButton( button, true );
					previewOpen = false;
				} );
			}
		$( '.jvbpd-preview-detail' ).each( function() {
			if( ! $( this ).data( 'preview_instance' ) ) {
				$( this ).on( 'click', callback );
				$( this ).data( 'preview_instance', true );
			}
		} );
	}

	jvbpd_core_elementor.prototype.sliderDetailImagesOnBlockWidget = function() {
		var self = this, callback;
		callback = function(event) {
			var
				$this = $(this),
				images = $this.data('images'),
				adminbar = $('#wpadminbar');
			event.preventDefault();
			if( typeof $.fn.lightGallery != 'undefined' ){
				$this.on('onBeforeOpen.lg', function(_event) {
					adminbar.length && adminbar.addClass('hidden');
				}).on('onBeforeClose.lg', function(_event){
					adminbar.length && adminbar.removeClass('hidden');
				});
				$this.lightGallery({
					dynamic		: true,
					dynamicEl	: images,
				});
			}
		}
		$( '.jvbpd-slider-detail' ).each( function() {
			if( ! $( this ).data( 'preview_instance' ) ) {
				$( this ).on( 'click', callback );
				$( this ).data( 'preview_instance', true );
			}
		} );
	}

	jvbpd_core_elementor.prototype.moduleVideoOnBlockWidget = function() {
		var
			self = this,
			previewOpen = false,
			callback = function( event ) {
				event.preventDefault();
				var
					modal = $( '#javo-infow-brief-window' ),
					body = $( '.modal-body', modal ),
					button = $( this ),
					video_url = $(this).data('video'),
					output;

				if( previewOpen ) {
					return;
				}

				previewOpen = true;
				self.waitButton( button, false );
				output = $('<iframe>').prop({
					'width': $(window).width() / 2,
					'height': $(window).height() / 2,
					'frameborder': '0',
					'src' : video_url,
				});
				body.empty().append(output).scrollTop(0);
				modal.modal( 'show' );
				self.waitButton( button, true );
				previewOpen = false;
			};

		$( '.jvbpd-preview-video' ).each( function() {
			if( ! $( this ).data( 'preview_instance' ) ) {
				$( this ).on( 'click', callback );
				$( this ).data( 'preview_instance', true );
			}
		} );
	}

	jvbpd_core_elementor.prototype.carousel = function( $scope ) {
		var self = this;
		var lightGalleryCall = function($widget) {
			return function() {
				var adminbar = $('#wpadminbar');
				$('.elementor-widget-container', ).on('onBeforeOpen.lg', function(_event) {
					adminbar.length && adminbar.addClass('hidden');
				}).on('onBeforeClose.lg', function(_event){
					adminbar.length && adminbar.removeClass('hidden');
				});
				$('.elementor-widget-container', $widget).lightGallery( {
					dynamic : true,
					hash : false,
					dynamicEl : $widget.data('galleries'),
				} );
			}
		}
		return function() {
			if( typeof window.Swiper == 'undefined' ) {
				return false;
			}

			var $widgets = $( '.elementor-widget-jv-media-carousel:not(.bind), .elementor-widget-jv-media-carousel-single-listing:not(.bind), .is-jvcore-swiper:not(.bind)' );

			if( $scope ) {
				$widgets = $scope;
			}

			$widgets.each(function(){
				var $widget = $(this);
				var widgetSettings = JSON.parse( $widget.find( '.slider-value' ).val() );
				var mainSliderSettings, thumbSliderSettings;

				var slidesCount = $('.jvbpd-swiper-carousel .swiper-slide', $widget).length;

				if(!widgetSettings.slidesPerView) {
					widgetSettings.slidesPerView = 1;
				}

				// Main
				mainSliderSettings = {
					'loop' : 'yes',
					'speed' : widgetSettings.speed,
					'lazyLoading' : true,
					'loopedSlides' : slidesCount,
					'slidesPerView' : Math.min(slidesCount, widgetSettings.slidesPerView),
					'slideToClickedSlide' : true,
					'preventClicks' : false,
					'preventClicksPropagation' : false,
					'slideToClickedSlide' : true,
					'navigation' : {
						'prevEl' : '.jvbpd-nav-button-prev .eicon-chevron-left',
						'nextEl' : '.jvbpd-nav-button-next .eicon-chevron-right',
					},
					'on' : {
						'init' : function() {
							$('.swiper-slide-active', $widget).find('video').each(function() {
								$(this).get(0).play();
							});
						},
						'slideChangeTransitionStart' : function () {
							$('.swiper-slide-active', $widget).find('video').each(function() {
								$(this).get(0).play();
							});
						},
						'slideChangeTransitionEnd' : function () {
							$('.swiper-slide-prev', $widget).find('video').each(function() {
								$(this).get(0).pause();
							});
							$('.swiper-slide-next', $widget).find('video').each(function() {
								$(this).get(0).pause();
							});
						},
					},
				}

				// Thumbnail
				thumbSliderSettings = {
					'loop' : 'yes',
					'spaceBetween' : 10,
					'loopedSlides' : slidesCount,
					'slideToClickedSlide' : true,
					'onSlideChangeEnd' : function( swiper ) {
						swiper.fixLoop();
					},
				}

				if('yes' == widgetSettings.autoplay) {
					mainSliderSettings.autoplay ={
						'delay' : widgetSettings.autoplay_speed,
						'disableOnInteraction' : true,
					}
				}

				if('slideshow' == widgetSettings.skin) {
					// Main
					mainSliderSettings.slidesPerView = 1;
					thumbSliderSettings.slidesPerView = Math.max(1, widgetSettings.slideshow_slides_per_view);

					// Thumbnail
					/*
					thumbSliderSettings.breakpoints = {
						'320' : { 'slidesPerView': Math.min(slidesCount, 3), 'spaceBetween' : 20 },
						'480' : { 'slidesPerView': Math.min(slidesCount, 4), 'spaceBetween' : 20 },
						'640' : { 'slidesPerView': Math.min(slidesCount, 5), 'spaceBetween' : 20 },
					} */
					if(typeof widgetSettings.breakpoints != 'undefined'){
						thumbSliderSettings.breakpoints = widgetSettings.breakpoints;

					}
				}else{
					if(typeof widgetSettings.breakpoints != 'undefined'){
						mainSliderSettings.breakpoints = widgetSettings.breakpoints;
					}
					if(0 < parseInt(widgetSettings.spaceBetween)) {
						mainSliderSettings.spaceBetween = widgetSettings.spaceBetween;
					}
				}

				var mainSlider = new Swiper($('.jvbpd-swiper-carousel', $widget), mainSliderSettings);
				if('slideshow' == widgetSettings.skin) {
					var thumbSlider;
					mainSlider.controller.control = thumbSlider = new Swiper($('.jvbpd-thumbs-swiper', $widget), thumbSliderSettings);
					thumbSlider.controller.control = mainSlider;
				}



				if('yes' == $widget.data('light-gallery')) {
					$('.carousel-image', $widget).on('click', lightGalleryCall($widget));
				}
				$widget.addClass('bind');
			});
		}
	}

	jvbpd_core_elementor.prototype.slick = function( $scope ) {
		var self = this;
		return function() {
			var selector = $( '.jvbpd-slider-wrap' );

			if( $scope ) {
				selector = $( '.jvbpd-slider-wrap', $scope );
			}

			selector.each( function() {
				var
					$this = $( this ),
					settings = $this.data( 'settings' );

				if($this.data('bindSlick')) {
					return;
				}

				$.each( new Array( 'adaptiveHeight', 'autoplay', 'arrows', 'dots', 'fade', 'infinite' ), function( _index, key ) {
					settings[ key ] = 'yes' === settings[ key ];
				} );

				if( typeof settings.slidesToShow != 'undefined' ) {
					settings.slidesToShow = parseInt(settings.slidesToShow);
					settings.slidesToScroll = settings.slidesToShow;
				}
				$this.slick( settings );
				$this.data('bindSlick', true);
			} );
		}
	}

	var jvbpd_form = function( el, parent, type ) {
		this.el = $( el );
		this.type = type;
		this.output = $( '.submit-wrap', this.el );
		this.parent = parent;
		this.init();
	}

	jvbpd_form.prototype.constructor = jvbpd_form;

	jvbpd_form.prototype.init = function() {
		var self = this;
		self.createMessageBox();
		if(self.el) {
			self.el.on( 'submit', self.submit() );
		}
	}

	jvbpd_form.prototype.createMessageBox = function() {
		var self = this;
		$( '<div>' ).addClass( 'jvbpd-form-msgbox' ).css({ 'display': 'none' }).appendTo( self.output );
	}

	jvbpd_form.prototype.message = function( str, type, _button ) {
		var
			self = this,
			output = self.output,
			button = $( 'button[type="submit"]', output ),
			content = $( '.jvbpd-form-msgbox', output ),
			contentInit,
			types = {
				'success': 'state-success',
				'processing': 'state-process',
				'danger': 'state-danger',
				'warning': 'state-warning',
			};

		contentInit = function() {
			$.each( types, function( _typeKey, typeSelector ) {
				content.removeClass( typeSelector );
			} );
		}

		if( false === str ) {
			button.prop( 'disabled', false );
			content.slideUp();
			return false;
		}

		content.html( str );

		if( type && ( -1 < Object.keys( types ).indexOf( type ) ) ) {
			contentInit();
			content.addClass( types[ type ] );
		}

		if( _button ) {
			button.prop( 'disabled', false );
		}else{
			button.prop( 'disabled', true );
		}
		content.slideDown();
	}

	jvbpd_form.prototype.getProcessingTemplate = function( _string ) {
		var
			self = this,
			parent = self.parent,
			template = '<i class="{class}"></i><span>{text}</span>';
		template = template.replace( /{class}/g, 'loader-icon' );
		template = template.replace( /{text}/g, _string || parent.args.strings.login.strProcessing );
		return template;
	}

	jvbpd_form.prototype.getParams = function( form ) {
		var
			self = this,
			parent = self.parent,
			form = $( form ),
			output = {};

		let $noCaptcha = $('[name="g-recaptcha-response"]');

		// output.security = parent.args.strings.login.security;
		output.security = $( '[name="security"]', form ).val();
		output.redirect = form.data( 'redirect' );

		if($noCaptcha.length) {
			output.nocaptcha_response = $noCaptcha.val();
		}

		if( self.type == 'login' ) {
			output.log = $( '[name="log"]', form ).val();
			output.pwd= $( '[name="pwd"]', form ).val();
			output.referer = $( '[name="referer"]', form ).val();
			output.remember = false;
		}

		if( self.type == 'join' ) {
			$.each( form.serializeArray(), function( _i, data ) {
				output[ data.name ] = data.value;
			} );

			if( output.user_pass != output.user_con_pass ) {
				self.message( parent.args.strings.join.errPasword, 'warning', true );
				output = false;
			}else{
				if(typeof FormData !== 'undefined') {
					output = new FormData(form.get(0));
					output.append('security', $( '[name="security"]', form ).val());
					output.append('redirect', form.data( 'redirect' ));
					if($noCaptcha.length) {
						output.append('nocaptcha_response', $noCaptcha.val());
					}
				}
			}
		}
		return output;
	}

	jvbpd_form.prototype.loginSuccess = function( xhr ) {
		var
			self = this,
			parent = self.parent;

		if( typeof xhr.error != 'undefined' ) {
			self.message( xhr.error, 'warning', true );
		}else{
			var successMessage = parent.args.strings.login.strSuccessLogin;
			successMessage += ' ';
			successMessage += '<div class="spinner-border spinner-border-sm align-middle" role="status"></div>';
			self.message( self.getProcessingTemplate( successMessage ), 'processing' );
			if( 'refresh' != xhr.redirect ) {
				window.location.href = xhr.redirect;
			}else{
				window.location.reload();
			}
		}
	}

	jvbpd_form.prototype.joinSuccess = function( xhr ) {
		var
			self = this,
			parent = self.parent;

		if( typeof xhr.err != 'undefined' ) {
			self.message( xhr.err, 'warning', true );
		}else{
			if( xhr.state == 'success' ){
				self.message( self.getProcessingTemplate( parent.args.strings.join.strSuccessJoin ), 'processing' );
				if( 'refresh' != xhr.link ) {
					window.location.href = xhr.link;
				}else{
					window.location.reload();
				}
			}else{
				self.message( xhr.comment, 'warning', true );
			}
		}
	}

	jvbpd_form.prototype.submit = function() {
		var
			self = this,
			parent = self.parent;
		return function( event ) {
			var params;
			event.preventDefault();

			var controller = {continue:true}
			params = self.getParams( this );

			if(self.type == 'join') {
				let $user_login = $('[name=user_login]', this);
				if($user_login.val().match(/\s/g)) {
					$user_login.focus();
					self.message( parent.args.strings.join.errBetweenSpace, 'warning', true );
					return false;
				}
			}

			if( false === params ) {
				return false;
			}

			$(window).trigger('jvbpd_form/submit/prepare', controller, self);
			if(!controller.continue) {
				return false;
			}

			self.message( self.getProcessingTemplate(), 'processing' );
			$( self ).trigger( 'jvbpd_form/submit/before', params, self );

			parent.ajax( 'ajax_user_' + self.type, params, function( xhr ) {
				if( self.type == 'login' ) {
					self.loginSuccess( xhr );
				}

				if( self.type == 'join' ) {
					self.joinSuccess( xhr );
				}

				$( self ).trigger( 'jvbpd_form/submit/after', xhr, self );
			}, function() {
				self.message( parent.args.strings.login.errLoginServer, 'danger', true );
			});
		}
	}

	jvbpd_core_elementor.prototype.loginForm = function() {
		var self = this;
		return function() {
			$( 'form.jvbpd-login-form' ).each( function(){
				if( ! $( this ).data( 'jvbpd-form' ) ) {
					$( this ).data( 'jvbpd-form', new jvbpd_form( this, self, 'login' ) );
				}
			} );
			$( 'form[data-jvbpd-signup-form]' ).each( function(){
				if( ! $( this ).data( 'jvbpd-form' ) ) {
					$( this ).data( 'jvbpd-form', new jvbpd_form( this, self, 'join' ) );
				}
			} );
		}
	}

	jvbpd_core_elementor.prototype.getMemberForm = function() {
		var
			self = this,
			loginAfterCallback = self.loginForm(),
			modals = {
				LoginForm : $( "#login_panel"),
				SignUpForm : $( "#register_panel"),
			},
			loadingTemplate = '<div class="sk-three-bounce">' +
				'<div class="sk-child sk-bounce1"></div>' +
				'<div class="sk-child sk-bounce2"></div>' +
				'<div class="sk-child sk-bounce3"></div>' +
			'</div>';

		$.each( modals, function( action, el){
			if(!el.hasClass( 'loaded')){
				$( ".modal-content", el).html( loadingTemplate );
				el.on('show.bs.modal', function(_event){
					self.ajax( 'get_' + action, {}, function( data ) {
						$( ".modal-content", el).html( data.render );
						loginAfterCallback();
						el.addClass('loaded');
					});
				});
			}
		});
	}

	var reset_filter = function( el, parent ) {
		this.el = $( el );
		this.output = '.elementor-widget-jvbpd-map-list-reset-filter .items';
		this.parent = parent;

		if(!window.jvbpd_reset){
			window.jvbpd_reset = {};
			window.jvbpd_reset.filters = {
				address : {
					label: parent.args.strings.map_list_reset_filter.address,
					field: [
						{ type: 'input', selector: '#javo-map-box-location-trigger' },
						{ type: 'input', selector: 'input.address.javo-location-search' },
						{ type: 'input', selector: 'input[name="radius_key"]' },

					],
				},
				category: {
					label: parent.args.strings.map_list_reset_filter.category,
					field: [
						{ type: 'selectize', selector: '.ui-select [name="list_filter[listing_category]"]' },
						{ type: 'checkbox', selector: 'input[type="checkbox"][data-tax="listing_category"]' },
					]
				},
				location: {
					label: parent.args.strings.map_list_reset_filter.location,
					field: [
						{ type: 'selectize', selector: '.ui-select [name="list_filter[listing_location]"]' },
						{ type: 'checkbox', selector: 'input[type="checkbox"][data-tax="listing_location"]' },
					]
				},
				amenities: {
					label: parent.args.strings.map_list_reset_filter.amenities,
					field: [
						{ type: 'selectize', selector: '.ui-select [name="list_filter[listing_amenities]"]' },
						{ type: 'checkbox', selector: 'input[type="checkbox"][data-tax="listing_amenities"]' },
					]
				},
			}
		}
		if(Object.keys(jvbpd_elementor_args.more_taxonomy).length) {
			window.jvbpd_reset.filters = $.extend(true, {},
				window.jvbpd_reset.filters,
				jvbpd_elementor_args.more_taxonomy
			);
        }
		this.init();
	}

	reset_filter.prototype.constructor = reset_filter;

	reset_filter.prototype.init = function() {
		var self = this;
		self.mapInstance = window.jvbpd_map_box_func;

		if( ! self.mapInstance ) {
			return;
		}

		self.scanFilter();
		$( window ).on( 'javo:map/filter/before', function() {
			self.scanFilter();
		} );

		$( '[data-filter="all-reset"]', self.el ).on( 'click', function( _event ) {
			$.each( window.jvbpd_reset.filters, function( key, _data ) {
				$( 'span.filter-item[data-filter="' + key + '"]' ).remove();
				self.resetFilter( key );
			} );
			self.otherReset();
			self.parent.listingTypeFilterID = false;
			self.mapInstance.filter();
		} );
	}

	reset_filter.prototype.isActiveFilter = function( filter ) {
		return -1 < window.jvbpd_reset.activateFilter.indexOf( filter );
	}

	reset_filter.prototype.checkFilter = function( data ) {
		var
			output = false,
			instance;

		$.each( data.field, function( _index, field ) {
			var existValue;

			if( ! $( field.selector ).length ) {
				return true;
			}

			switch( field.type ) {
				case 'input' :
				case 'selectize' : existValue = 0 < ($( field.selector ).val() || new Array()).length; break;
				case 'checkbox' : existValue = 0 < $( field.selector + ':checked' ).length; break;
			}
			if( existValue ) {
				output = true;
				return false;
			}
		} );
		return output;
	}

	reset_filter.prototype.resetFilter = function( filter ) {
		var
			self = this,
			target = false,
			instance,
			filters = Object.keys( window.jvbpd_reset.filters );

		if( -1 < filters.indexOf( filter ) ) {
			target = window.jvbpd_reset.filters[filter];
			$.each( target.field, function( _targetIndex, targetField ) {

				if( ! $( targetField.selector ).length ) {
					return true;
				}

				switch( targetField.type ) {
					case 'input' : $( targetField.selector ).val( '' ); break;
					case 'selectize' :
						$( targetField.selector ).each(function(){
							var
								$this = $(this),
								instance = $this.get(0).selectize;
							// instance.clear();
							$this.val(new Array());
						});
						break;
					case 'checkbox' :
						$( targetField.selector ).prop( 'checked', false ); break;
				}

			} );

			if( self.isActiveFilter( filter ) ) {
				window.jvbpd_reset.activateFilter.splice( window.jvbpd_reset.activateFilter.indexOf( filter ), 1 );
			}
		}
	}

	reset_filter.prototype.otherReset = function() {
		var
			searchForm = $('form.jvbpd-search-form-section'),
			// search_fields = $('.field-ajax_search'),
			search_fields = $('form.jvbpd-search-form-section'),
			amenities_fields = $('.amenities-filter-area'),
			selectize_fields = $('.shortcode-jvbpd_search_field [data-selectize], select[data-tax].selectized'),
			keyword_fields = $('[name="keyword"]', searchForm);

		// Search field
		search_fields.each(function() {
			var
				$this = $(this),
				input = $('input[name="keyword"], input[name="category"]', $this);
			input.val('');
		});

		// Amenities field
		amenities_fields.each(function(){
			var
				$this = $(this),
				checkboxes = $('input[data-tax]',$this);
			checkboxes.prop('checked', false);
		});

		// Selectize field
		window.jvbpd_core_map_block_filter = true;
		selectize_fields.each(function(){
			var
				$this = $(this),
				instance = $this.get(0).selectize;

			if(instance) {
				instance.clear();
			}
		});
		window.jvbpd_core_map_block_filter = false;
	}

	reset_filter.prototype.scanFilter = function() {
		var self = this;
		window.jvbpd_reset.activateFilter = new Array();
		$.each( window.jvbpd_reset.filters, function( key, data ) {
			$( 'span.filter-item[data-filter="' + key + '"]' ).remove();
			if( self.checkFilter( data ) && !self.isActiveFilter( key ) ) {
				self.add({ filter: key, label: data.label });
			}
		} );
	}

	reset_filter.prototype.getTemplate = function( data ) {
		var template = '<span class="filter-item" data-filter="{filter}">{label} <i class="filter-item-remove-icon">&times;</i></span>';
		template = template.replace( /{filter}/g, data.filter || '' );
		template = template.replace( /{label}/g, data.label || '' );
		return template;
	}

	reset_filter.prototype.add = function( data ) {
		var
			self = this,
			button = self.getTemplate( data );

		$(self.output).each(function(){
			$(this).append( $(button).on( 'click', function(){ self.remove( this ); } ) );
		});
		window.jvbpd_reset.activateFilter.push( data.filter );
	}

	reset_filter.prototype.remove = function( _button ) {
		var
			self = this,
			button = $( _button );
		button.remove();
		self.resetFilter( button.data( 'filter' ) );
		self.mapInstance.filter();
	}

	jvbpd_core_elementor.prototype.bind_reset_filter = function() {
		var self = this;
		return function( _items ) {
			$( '.jvbpd-map-list-reset-filter-wrap' ).each( function() {
				if( ! $( this ).data( 'reset_filter' ) ) {
					$( this ).data( 'reset_filter', new reset_filter( this, self ) );
				}
			} );
			$(window).on('javo:map/items/get/after', function(_event, _args, obj){
				self.mapInstance = obj;
				$('.reset-filter-wrap').each( function() {
					if( ! $( this ).data( 'reset_filter' ) ) {
						$( this ).data( 'reset_filter', new reset_filter( this, self ) );
					}
				} );
			});
		}
	}

	jvbpd_core_elementor.prototype.bind_list_grid_toggle = function() {
		var self = this;
		return function( _event ) {
			var
				instance = window.jvbpd_map_box_func,
				TOGGLE_ACTIVE = 'active';

			$.each( { map: '.module-switcher input[name="module_switcher"]', list: '.jvbpd-map-list-grid-toogle-wrap' }, function( type, selector ) {
				$( selector ).each( function() {
					var
						items,
						items_event,
						$this = $(this),
						widget = $this.closest('.elementor-widget-jvbpd-map-list-grid-toggle'),
						settings = widget.data('settings');

					if( 'map' == type ) {
						items = $this;
						items_event = 'change';
					}else{
						items = $( '.toggle-item', $this );
						items_event = 'click';
					}

					items.on( items_event, function( _event ) {
						var $this;

						if( 'map' == type ) {
							$this = $( this ).parent();
						}else{
							$this = $( this );
						}

						if( $this.hasClass( TOGGLE_ACTIVE ) ) {
							return;
						}

						items.removeClass( TOGGLE_ACTIVE );

						if( 'map' != type ) {
							$this.addClass( TOGGLE_ACTIVE );
						}
						$( window ).on( 'javo:map/items/get/before', function( _event, args ) {
							var module_name = $this.data( 'module' );
							var columns_count = $this.data( 'columns' );
							if( module_name && columns_count ) {
								args.parametter.map.module = module_name;
								args.parametter.map.columns = columns_count;
								args.parametter.list.module = module_name;
								args.parametter.list.columns = columns_count;
							}
						});
						self.loopCount = 0;
						if($('#javo-map-box-location-trigger').length && '' != $('#javo-map-box-location-trigger').val()) {
							var eventhandle = $.Event('keydown');
							eventhandle.keyCode = 13;
							$('#javo-map-box-location-trigger').trigger(eventhandle);

						}else{
							instance.filter();
						}

					} );
				} );
			} );

		}
	}

	jvbpd_core_elementor.prototype.block_bind_mansorny = function() {
		$( window ).on( 'javo:map/items/get/before', function( _event, args ) {
			/*
			var
				module_name = $this.data( 'module' ),
				columns_count = $this.data( 'columns' );
			if( module_name && columns_count ) {
				args.parametter.map.module = module_name;
				args.parametter.map.columns = columns_count;
				args.parametter.list.module = module_name;
				args.parametter.list.columns = columns_count;
			} */

			$.each([args.controls.map.output,args.controls.list.output], function(){
				var
					$blockThis = $(this),
					widget = $blockThis.closest('.elementor-widget-jvbpd-map-listing-blocks, .elementor-widget-jvbpd-map-list-listing-blocks'),
					settings = widget.data('settings'),
					effect;

				if(!settings) {
					return;
				}
				if('yes' == settings.use_masonry) {
					if(settings.masonry_ani) {
						effect  = 'effect-' + settings.masonry_ani;
						$blockThis.addClass('jvbpd-grid').addClass(effect);
					}
					/*
					widget.removeClass(function(i, className){
						return (className.match (/(^|\s)columns-\S+/g) || []).join(' ');
					}); */
					widget.addClass('masonry-yes');
				}else{
					widget.removeClass('masonry-yes');
					$blockThis.removeClass('jvbpd-grid');
				}
			});
		} );
	}

	jvbpd_core_elementor.prototype.elementor_edithook = function() {
		var self = this;
		return function() {
			var
				instance = window.jvbpd_map_box_func,
				carusel_callback = function( $scope, _$ ) { var callback = self.carousel( $scope ); callback(); },
				slick_callback = function( $scope, _$ ) { var callback = self.slick( $scope ); callback(); };

			elementorFrontend.hooks.addAction( 'frontend/element_ready/jv-media-carousel.default', carusel_callback );
			elementorFrontend.hooks.addAction( 'frontend/element_ready/jv-media-carousel-single-listing.default', carusel_callback );
			elementorFrontend.hooks.addAction( 'frontend/element_ready/jv-page-slider.default', slick_callback );

			elementorFrontend.hooks.addAction( 'frontend/element_ready/jvbpd_testimonial.default', slick_callback );
			elementorFrontend.hooks.addAction( 'frontend/element_ready/jvbpd_testimonial_wide.default', slick_callback );
			elementorFrontend.hooks.addAction( 'frontend/element_ready/jvbpd_featured_block.default', slick_callback );

			elementorFrontend.hooks.addAction( 'frontend/element_ready/jvbpd-map-list-listing-blocks.default', function( _$scope, _$ ) {
				if( elementorFrontend.isEditMode() ) {
					self.mapBlockAnimOnScroll();

					instance.filter();
				}
			} );

			elementorFrontend.hooks.addAction( 'frontend/element_ready/jvbpd-map-list-filters.default', function( _$scope, _$ ) {
				if( elementorFrontend.isEditMode() ) {
					instance.setDistanceBar();
				}
			} );

			elementorFrontend.hooks.addAction( 'frontend/element_ready/jvbpd-single-header.default', function( _$scope, _$ ) {
				if( elementorFrontend.isEditMode() ) {
					window.jvbpd_singleInstance.init();
				}
			} );

			elementorFrontend.hooks.addAction( 'frontend/element_ready/jvbpd-map-maps.default', function( _$scope, _$ ) {
				if( elementorFrontend.isEditMode() ) {
					instance.init();
					instance.filter();
				}
			} );

			elementorFrontend.hooks.addAction( 'frontend/element_ready/lava-nearby-places.default', function( _$scope, _$ ) {
				if( elementorFrontend.isEditMode() ) {
					self.lavaNearby();
				}
			} );

			var ApplyMasonryScript = function( _$scope, _$ ) {
				if( elementorFrontend.isEditMode() ) {
					_$scope.removeClass('bind-masonry');
					self.postBlockAnimOnScroll();
				}
			}

			elementorFrontend.hooks.addAction( 'frontend/element_ready/jvbpd-page-block.default', ApplyMasonryScript );
			elementorFrontend.hooks.addAction( 'frontend/element_ready/jvbpd-single-gallery.default', ApplyMasonryScript );
			var CallbackPortfolioGallery = function() {
				self.portfolioGallery();
			}
			elementorFrontend.hooks.addAction( 'frontend/element_ready/jvbpd-single-portfolio-gallery.default',CallbackPortfolioGallery);
			elementorFrontend.hooks.addAction( 'frontend/element_ready/jvbpd-single-post-base-meta',CallbackPortfolioGallery);

			elementorFrontend.hooks.addAction( 'frontend/element_ready/jv_tabs.default', function(){
				if( elementorFrontend.isEditMode() ) {
					self.jvTabsScript();
				}
			});

			if( elementorFrontend.isEditMode() ) {
				elementor.hooks.addFilter('editor/style/styleText', function(css, view) {
					if(!view){
						return;
					}
					var model = view.getEditModel();
					var jv_css = model.get('settings').get('jv_custom_css') || '';
					jv_css = jv_css.replace(/selector/g, '.elementor-element.elementor-element-' + model.id)
					if(jv_css) {
						css += jv_css;
					}
					return css;
				});
			}

			function jvGlobalElementorFrondEndElementReady( $scope ){
				// Initialize the Entrance Animation on render
				if( $scope.hasClass('jvfrm-appear-watch-animation') ){
					$.fn.JVinAppearAnimationsInit( $scope );
				}
				if( $scope.hasClass('jvfrm-parallax-section') ){
					$.fn.JVinParallaxSectionInit( $scope );
				}
			}

			elementorFrontend.hooks.addAction( 'frontend/element_ready/section', jvGlobalElementorFrondEndElementReady );
			elementorFrontend.hooks.addAction( 'frontend/element_ready/column' , jvGlobalElementorFrondEndElementReady );
			elementorFrontend.hooks.addAction( 'frontend/element_ready/widget' , jvGlobalElementorFrondEndElementReady );
		}
	}

	jvbpd_core_elementor.prototype.map_sort_dropdown = function() {
		var
			self = this,
			MAP_SORT_TYPE = 'map-sort-type';
		return function( _event ) {
			var
				apply = false,
				filter = { by:'', type: '' },
				instance = window.jvbpd_map_box_func,
				filter_selector = 'select[data-map-sort-by]',
				order_selector = 'button[data-' + MAP_SORT_TYPE + ']';

			$( filter_selector ).on( 'change', function( _event ) {
				apply = true;
				filter.by = $( this ).val();
				instance.filter();
			} );
			$( order_selector ).on( 'click', function( _event ) {
				var currentOrder = $( this ).data( MAP_SORT_TYPE );
				$( 'i', this ).addClass( 'hidden' );
				if( 'asc' == currentOrder ) {
					$( this ).data( MAP_SORT_TYPE, 'desc' );
					$( 'i[data-sort="desc"]' ).removeClass( 'hidden' );
				}else{
					$( this ).data( MAP_SORT_TYPE, 'asc' );
					$( 'i[data-sort="asc"]' ).removeClass( 'hidden' );
				}
				apply = true;
				filter.type = $( this ).data( MAP_SORT_TYPE );
				instance.filter();
			} );

			$( window ).on( 'javo:map/filter/after', function( _event, item ) {
				var
					items = item.items,
					sortBy = filter.by,
					sortType = filter.type;

				if( !apply ) {
					return;
				}

				if( 0 <= new Array( 'reviewed', 'rating' ).indexOf( sortBy ) ) {
					items.sort( instance.order_raty( sortBy ) );
				}else{
					items.sort( instance.compare( sortBy ) );
				}

				if( 'asc' == sortType ) {
					items.reverse();
				}
				item.set( items );
			} );
		}
	}

	jvbpd_core_elementor.prototype.map_list_banner = function() {
		var
			self = this,
			CATEGORY = 'listing_category',
			selector = '.jvbpd-map-list-category-banner-wrap',
			filter = 'select[data-tax="' + CATEGORY + '"]';
		return function( _event ) {

			$( filter ).on( 'change', function() {
				var term = $( this ).val();
				self.ajax( 'get_listing_category_featured_iamge', {term_id: term }, function( xhr ) {
					$( selector ).each( function() {
						$( this ).css( {
							'background-image': 'url(' + xhr.full +')',
							'background-size': 'cover',
							'background-position': 'center',
							'height':150,
						} );
					} );
				} );
			} );
		}
	}

	jvbpd_core_elementor.prototype.map_location_filter = function() {
		var self = this;
		var mapInstance = window.jvbpd_map_box_func;
		var old_loadmore = null;
		var sort_direction = null;

		$('.elementor-widget-jvbpd-map-location-filters').each(function(){
			var $widget = $(this);


			$('a.jvbpd-filter-review-top-10', $widget).on('click', function(event){
				sort_direction = 'desc';
				mapInstance.filter();
			})
			$('a.jvbpd-filter-review-bottom-10', $widget).on('click', function(event){
				sort_direction = 'asc';
				mapInstance.filter();
			})
		})

		$( window ).on( 'javo:map/items/prepare', function( _event, obj ) {
			var items = obj.apply_item;

			if(sort_direction === null) {
				return false;
			}

			old_loadmore = obj.args.loadmore_amount;
			obj.args.loadmore_amount = 10;

			items.sort( obj.order_raty( 'rating' ) );
			if( 'asc' == sort_direction ) {
				items.reverse();
			}
			// item.set( items );
			obj.apply_item = items;
		} );

		$( window ).on( 'javo:map/items/get/after', function( _event, args, obj ) {
			if(null !== sort_direction) {
				sort_direction = null;
				$('.module-card', args.controls.map.output).addClass('show-review-rank');
				$('.module-card', args.controls.list.output).addClass('show-review-rank');
			}
			if(null !== old_loadmore) {
				mapInstance.args.loadmore_amount = old_loadmore;
				old_loadmore = null;
			}
		});
	}

	jvbpd_core_elementor.prototype.lazyload = function( wrap ) {
		var
			exludeClasses = new Array(
				'.wide-nav-overlay',
				'.module-rating-wrap',
				'.module-ratings'
			);

		$( '*:not(.' + CLASS_LAZY + ')', wrap ).each( function() {
			var
				$this = $( this ),
				hasExcludeSelector = false,
				bg = $this.css( 'background-image' );

			$.each( exludeClasses, function( _excIndex, excSelector ) {
				if( $this.is( excSelector ) ) {
					hasExcludeSelector = true;
					return false;
				}
			} );

			if( hasExcludeSelector ) {
				return;
			}

			if( -1 < bg.indexOf( 'url' ) ) {
				$this.css( 'background-image', '' );
				$this.data( 'src', bg );
				$this.addClass( CLASS_LAZY );
			}
		} );

		$( 'img:not(.' + CLASS_LAZY + ')', wrap ).each( function() {
			var
				$this = $( this ),
				hasExcludeSelector = false;
			$.each( exludeClasses, function( _excIndex, excSelector ) {
				if( $this.is( excSelector ) ) {
					hasExcludeSelector = true;
					return false;
				}
			} );

			if( hasExcludeSelector ) {
				return;
			}

			$.each( new Array( 'src', 'srcset' ), function( _imgIndex, imgProp ) {
				var value = $this.attr( imgProp );
				if( value ) {
					$this.data( imgProp, value );
					$this.addClass( CLASS_LAZY );
					$this[0].setAttribute( imgProp, '' );
				}
			} );
		} );
	}

	jvbpd_core_elementor.prototype.lazyRollover = function() {
		var
			self = this,
			lazyStarted		= false,
			intWinScrollTop	= 0,
			intWinHeight	= 0,
			intSumOffset	= 0,
			intCurrentIDX	= 0,
			intInterval		= 100,
			objWindow		= $( window );
		return function( _event ){
			intWinScrollTop	= objWindow.scrollTop();
			intWinHeight	= objWindow.height() * 0.9;
			intSumOffset	= intWinScrollTop + intWinHeight;

			$( '.' + CLASS_LAZY ).each( function() {
				var
					$this = $( this ),
					bg = $this.data( 'src' ), src;

				if( bg ) {
					src =  bg.replace( /(^url\()|(\)$|[\"\'])/g, '' );
					if( intSumOffset > $this.offset().top ) {
						$( '<img/>' ).attr( 'src', src ).on( 'load', function() {
							$( this ).remove();
							$this.addClass( CLASS_LAZYLOAD );
							$this.css( 'background-image', bg );
						} );
					}
				}
			} );

			$( 'img' ).each( function() {
				var $this = $( this );
				$.each( new Array( 'src', 'srcset' ), function( _imgIndex, imgProp ) {
					var value = $this.data( imgProp );
					if( value ) {
						if( intSumOffset > $this.offset().top ) {
							$this.attr( imgProp, value );
						}
					}
				} );
				$this.on( 'load', function() {
					$this.addClass( CLASS_LAZYLOAD );
				} );
			} );
		}
	}

	jvbpd_core_elementor.prototype.menu_opener_bind_events = function( wrap ) {
		$( '.jvbpd-menu-closer', wrap ).on( 'click', function() {
			$( 'body' ).removeClass( 'jvbpd-menu-active' );
			wrap.removeClass( 'jvbpd-visible' );
		} );
	}

	jvbpd_core_elementor.prototype.menu_opener = function() {
		var self = this;
		return function() {
			$( '.jvbpd-menu-opener' ).each( function() {
				var
					$this = $( this ),
					uniqID = $this.data( 'id' ),
					hideBody = true,
					templateID = $this.data( 'template' ),
					containerSelector = '.jvbpd-canvas-container';

				var interValSpeed = 0;

				if('floating_right' == $this.data('direction')) {
					hideBody = false;
					interValSpeed = 500;
				}

				$this.on( 'click', function() {
					var
						winY = $( window ).height(),
						canvas = $( containerSelector + '[data-id="' + uniqID + '"]' );

					if( ! canvas.hasClass( 'loaded' ) ) {
						$( window ).trigger( 'jvbpd_core/canvas/get/before', [ $this ] );
						var nTimeID = setInterval(function(){
							self.ajax( 'get_canvas', { template: templateID }, function( xhr ) {
								canvas.addClass( 'loaded' );
								$( window ).trigger( 'jvbpd_core/canvas/get/after', [ $this, xhr ] );
								canvas.html( xhr.render );
								$( window ).trigger( 'jvbpd_core/canvas/get/completed', [ $this, xhr ] );
								self.menu_opener_bind_events( canvas );
							} );
							interValSpeed = 0;
							clearInterval(nTimeID);
						}, interValSpeed);
					}
					canvas.addClass( 'jvbpd-visible' ).css( 'min-height', winY );
					hideBody && $( 'body' ).addClass( 'jvbpd-menu-active' );
					!hideBody && $('.jvbpd-canvas-overlay[data-id=' + uniqID + ']').addClass('active');
				} );
				$('.jvbpd-canvas-overlay[data-id=' + uniqID + ']').on('click', function(){
					var $overlay = $(this);
					var $canvas = $( containerSelector + '[data-id="' + uniqID + '"]' );
					$overlay.removeClass('active');
					$canvas.removeClass('jvbpd-visible');
					$(document.body).removeClass('jvbpd-menu-active');
				})
			} );
		}
	}

	jvbpd_core_elementor.prototype.scrollSpy = function() {
		var trigger = $('.javo-single-nav > a');
		trigger.on('click', function( _event ){
			var
				targetID = $(this).attr("href"),
				target = $( targetID ),
				adminbar = $('#wpadminbar'),
				stickHeader = $('.header.jvbpd-sticky-element'),
				offY = 0;

			if( target.length ) {
				offY += target.offset().top;
				offY -= $( this ).closest(".jvbpd-sticky-element").height();
				if( adminbar.length ) {
					offY -= adminbar.height();
				}
				if( stickHeader.length ) {
					offY -= stickHeader.height();
				}
				offY = 0 < offY ? offY : 0;
				$("html, body").animate({scrollTop:offY}, 500);
			}
			return false;
		});
	}

	jvbpd_core_elementor.prototype.applySlimScroll = function() {
		var elements = $(".item-list-page-wrap, .list-block-wrap");
		if( typeof $.fn.slimScroll !== 'function' ) {
			return;
		}
		elements.each( function(){
			var $this = $(this);
			if( !$this.hasClass('set-vscroll')){
				return true;
			}
			$this.slimScroll({
				height: $this.height() + 'px',
				distance: '0px',
				railVisible: true,
				alwaysVisible: true,
				railColor: '#ccc',
				railOpacity: 0.8,
			});
		});
	}

	jvbpd_core_elementor.prototype.postBlockAnimOnScroll = function() {
		$('.elementor-widget-jvbpd-page-block:not(.bind-masonry), .elementor-widget-jvbpd-single-gallery:not(.bind-masonry), .elementor-widget-jvbpd-reward-list:not(.bind-masonry)').each(function(){
			/*
				effect,
				is_masonry = false, // $(this).hasClass('masonry-yes'),
				settings = $(this).data('settings'),
				container =
			*/

			var $widget = $(this);
			var settings = $widget.data('settings') || {};
			var container = new Array();
			var is_masonry = false;
			var animateType = settings.masonry_ani || '';

			if($widget.is('.elementor-widget-jvbpd-page-block')) {
				// is_masonry = 'yes' == settings.use_masonry;
				is_masonry = $widget.hasClass('masonry-yes');
				container = $('.shortcode-output > .row', $widget);
			} else if($widget.is('.elementor-widget-jvbpd-single-gallery')) {
				is_masonry = 'masonry' == settings.render_type;
				container = $('ul.mansory-wrap', $widget);
			} else if($widget.is('.elementor-widget-jvbpd-reward-list')) {
				is_masonry = true;
				container = $('ul.reward-list-items', $widget);
			}

			if(!is_masonry || !container.length){
				return;
			}

			var masonry_type = $widget.data('masonry-type');
			var gutter = $widget.data('masonry-gutter') || 0;

			var masonry_items = function() {}
				masonry_items.prototype.constructor = masonry_items;
				masonry_items.prototype.resize = function() {
					var $gutter = $('li.masonry-gutter', $widget);
					$('.masonry-item:not(.bind-sized)', $widget).each(function(){
						var $item = $(this);
						$item.css('width', '-=' + $gutter.outerWidth() + 'px').addClass('bind-sized');
					});
				}

			container.addClass( 'jvbpd-grid' )
				.addClass( 'effect-' + animateType )
				.data('masonry-type', masonry_type)
				.data('masonry-gutter', gutter)
				.data('masonry-items', new masonry_items());

			if( !container.attr('id')){
				container.attr('id','animon-id-' + $widget.data('id'));
			}

			if('isotope' == masonry_type) {
				$('li.masonry-item', container).addClass('shown');
				container.addClass('not-transition')
					.data('masonry-items').resize();
				container.isotope({
					itemSelector: 'li.masonry-item',
					masonry:{
						gutter: 'li.masonry-gutter',
					}
				});
			}else{
				var aosInstance = new AnimOnScroll(container.get(0), {
					minDuration: 0.4,
					maxDuration: 0.7,
					viewportFactor: 0.8,
					childSelector: 'li.masonry-item',
					masonry_gutter: 'li.masonry-gutter',
					// masonry_gutter: gutter,
				});

				container.data('aos',aosInstance);
				container.data('masonry-items').resize();

				var parentTab = $widget.closest('.elementor-widget-jv_tabs');
				if(parentTab.length) {
					$('a.nav-link', parentTab).on('click', function(_event){
						aosInstance._init();
						var interval = setInterval(function(){
							aosInstance._init();
							clearInterval(interval);
						}, 500);
					});
				}
			}
			$widget.addClass('bind-masonry');
			$( window ).on('jvbpd_core/shortcode/render/before', function(_event, _obj, output, _xhr, is_setTerm){
				if(is_setTerm) {
					output.closest('.bind-masonry').removeClass('bind-masonry');
				}
			})
		});
	}

	jvbpd_core_elementor.prototype.portfolioGallery = function() {
		var self = this;
		$('.portfolio-gallery-wrap:not(.bind)').each(function(){
			var $this = $(this);

			$this.addClass('bind');
			if($this.hasClass('type-masonry')) {
				$this.addClass( 'jvbpd-grid');
				var aosInstance = new AnimOnScroll($this.get(0), {
					minDuration: 0.4,
					maxDuration: 0.7,
					viewportFactor: 0.8
				});
				$this.data('anim-on-scroll', aosInstance);
				$this.removeClass('hidden');
			}else if($this.hasClass('type-slider')){
				var titles = [];
				var subtitle = [];
				var counter = [];
				var itemIDs = new Array();
				var $container = $this.closest('.swiper-container');

				$('.swiper-slide', $container).each(function(_i) {
					titles.push($(this).data('title'))
					subtitle.push($(this).data('subtitle'))
					counter.push($(this).data('number'))
					itemIDs.push($(this).data('id'))
				});

				function checkEnableTlit() {
					return 'no-id' != $('.swiper-slide-active', $container).data('id');
				}

				var enableTlit = checkEnableTlit();

				var interleaveOffset = 0.4;

				var swiperOptions = {
					direction: "horizontal",
					loop: false,
					grabCursor: true,
					resistance : true,
					resistanceRatio : 0,
					watchSlidesProgress: true,
					speed:1200,
					autoplay: false,
					effect: "slide",
					mousewheel: true,
					pagination: {
						el: '.showcase-pagination',
						clickable: true,
						renderBullet: function (index, className) {
							return '<div class="tab__link  elementor-repeater-item-' + itemIDs[index] + ' ' + className + '">' + '<div class="counter-wrap">' + '<div class="counter">' +
							counter[index] + '</div>' + '</div>' + '<div class="subtitle">' + subtitle[index] + '</div>' + '<div class="title">' +
							titles[index] + '</div>' + '</div>';

						},
					},
					navigation: {
						nextEl: '.swiper-button-next',
						prevEl: '.swiper-button-prev',
					},
					on: {
						progress: function() {
							var swiper = this;
							for (var i = 0; i < swiper.slides.length; i++) {
								var slideProgress = swiper.slides[i].progress;
								var innerOffset = swiper.width * interleaveOffset;
								var innerTranslate = slideProgress * innerOffset;
								swiper.slides[i].querySelector(".img-mask").style.transform = "translate3d(" + innerTranslate + "px,0, 0)";
							}
						},
						touchStart: function() {
							var swiper = this;
							for (var i = 0; i < swiper.slides.length; i++) {
								swiper.slides[i].style.transition = "";
							}
						},
						setTransition: function(speed) {
							var swiper = this;
							for (var i = 0; i < swiper.slides.length; i++) {
								swiper.slides[i].style.transition = speed + "ms";
								swiper.slides[i].querySelector(".img-mask").style.transition = speed + "ms";
							}
						},
						init: function () {

							setTimeout(function(){
								TweenMax.to($('.swiper-slide-active', $container).nextAll().find('.slide-title span'), 0,{scale:1.1, x:100, opacity:0, ease:Power2.easeInOut});
								TweenMax.to($('.swiper-slide-active', $container).nextAll().find('.slide-cat'), 0,{x:20, opacity:0, delay:0.3, ease:Power2.easeIn});
							} , 100 );

							$('.swiper-slide-active', $container).find('video').each(function() {
								$(this).get(0).play();
							});

						},
						slideNextTransitionStart: function () {
							var prevslidetitle = new TimelineLite();
							prevslidetitle.staggerTo($('.swiper-pagination-bullet-active', $container).prev().find('.title span'), 0.5, {scale:0.9, x:-100, opacity:0, ease:Power2.easeInOut},  0.02)
							var prevslidecaption = new TimelineLite();
							prevslidecaption.staggerTo($('.swiper-pagination-bullet-active', $container).prev().find('.subtitle'), 0.5, {x:-20, opacity:0, delay:0.3, ease:Power2.easeIn},  0.02)

							var activeslidetitle = new TimelineLite();
							activeslidetitle.staggerTo($('.swiper-pagination-bullet-active', $container).find('.title span'), 0.5, {scale:1, x:0, opacity:1, scale:1, delay:0.3, ease:Power2.easeOut}, 0.02)
							var activeslidecaption = new TimelineLite();
							activeslidecaption.staggerTo($('.swiper-pagination-bullet-active', $container).find('.subtitle'), 0.5, {x:0, opacity:1, scale:1, delay:0.6, ease:Power2.easeOut}, 0.02)

							var nextslidetitle = new TimelineLite();
							nextslidetitle.staggerTo($('.swiper-pagination-bullet-active', $container).next().find('.title span'), 0.5, {scale:1.1, x:100, opacity:0, ease:Power2.easeInOut},  0.02)
							var nextslidecaption = new TimelineLite();
							nextslidecaption.staggerTo($('.swiper-pagination-bullet-active', $container).next().find('.subtitle'), 0.5, {x:20, opacity:0, delay:0.3, ease:Power2.easeIn},  0.02)

							var tl = new TimelineLite();
							$('.swiper-pagination-bullet-active', $container).prev().find('.counter').each(function(index, element) {
								tl.to(element, 0.3, {scale:1, y:-20, opacity:0, ease:Power2.easeIn}, index * 0.01)
							});

							$('.swiper-pagination-bullet-active', $container).find('.counter').each(function(index, element) {
								tl.to(element, 0.4, {scale:1, y:0, opacity:1, scale:1, delay:0.3, ease:Power2.easeOut}, index * 0.01)
							});

							$('.swiper-pagination-bullet-active', $container).next().find('.counter').each(function(index, element) {
								tl.to(element, 0.3, {scale:1, y:20, opacity:0, ease:Power2.easeIn}, index * 0.01)
							});

						},
						slidePrevTransitionStart: function () {
							var prevslidetitle = new TimelineLite();
							prevslidetitle.staggerTo($('.swiper-pagination-bullet-active', $container).prev().find('.title span'), 0.5, {scale:1.1, x:-100, opacity:0, ease:Power2.easeInOut},  -0.02)
							var prevslidecaption = new TimelineLite();
							prevslidecaption.staggerTo($('.swiper-pagination-bullet-active', $container).prev().find('.subtitle'), 0.5, {x:-20, opacity:0, delay:0.3, ease:Power2.easeIn},  -0.02)

							var activeslidetitle = new TimelineLite();
							activeslidetitle.staggerTo($('.swiper-pagination-bullet-active', $container).find('.title span'), 0.5, {scale:1, x:0, opacity:1, scale:1, delay:0.5, ease:Power2.easeOut}, -0.02)
							var activeslidecaption = new TimelineLite();
							activeslidecaption.staggerTo($('.swiper-pagination-bullet-active', $container).find('.subtitle'), 0.5, {x:0, opacity:1, scale:1, delay:0.6, ease:Power2.easeOut}, -0.02)

							var nextslidetitle = new TimelineLite();
							nextslidetitle.staggerTo($('.swiper-pagination-bullet-active', $container).next().find('.title span'), 0.5, {scale:0.9, x:100, opacity:0, ease:Power2.easeInOut},  -0.02)
							var nextslidecaption = new TimelineLite();
							nextslidecaption.staggerTo($('.swiper-pagination-bullet-active', $container).next().find('.subtitle'), 0.5, {x:20, opacity:0, delay:0.3, ease:Power2.easeIn},  -0.02)


							var tl = new TimelineLite();

							$('.swiper-pagination-bullet-active', $container).prev().find('.counter').each(function(index, element) {
								tl.to(element, 0.3, {scale:1, y:-20, opacity:0, delay:0.1,  ease:Power2.easeIn}, index * 0.01)
							});

							$('.swiper-pagination-bullet-active', $container).find('.counter').each(function(index, element) {
								tl.to(element, 0.4, {scale:1, y:0, opacity:1, scale:1, delay:0.45, ease:Power2.easeOut}, index * 0.01)
							});

							$('.swiper-pagination-bullet-active', $container).next().find('.counter').each(function(index, element) {
								tl.to(element, 0.3, {scale:1, y:20, opacity:0, delay:0.1,  ease:Power2.easeIn}, index * 0.01)
							});

						},
						slideChangeTransitionStart: function () {
							$('.swiper-button-white', $container).addClass('disable-click');
							LinesWidth();
							$('.swiper-slide-active', $container).find('video').each(function() {
								$(this).get(0).play();
							});
						},
						slideChangeTransitionEnd: function () {
							$('.swiper-button-white', $container).removeClass('disable-click');
							$('.swiper-slide-prev', $container).find('video').each(function() {
								$(this).get(0).pause();
							});
							$('.swiper-slide-next', $container).find('video').each(function() {
								$(this).get(0).pause();
							});

							enableTlit = checkEnableTlit();
						}
					},
				};

				function LinesWidth() {
					// var carouselWidth = $('#showcase-holder').width();
					var carouselWidth = $container.width();
					var captionWidth = $('.swiper-pagination-bullet-active .title', $container).width();
					if ($(window).width() >= 1466) {
						lineWidth = carouselWidth / 2 - 440
					} else if ($(window).width() >= 1024) {
						lineWidth = carouselWidth / 2 - 220
					} else if ($(window).width() >= 767) {
						lineWidth = carouselWidth / 2 - 160
					} else if ($(window).width() >= 479) {
						lineWidth = carouselWidth / 2 - 50
					} else {
						lineWidth = carouselWidth / 2 - 40
					}

					$(".caption-border.left", $container).css({
						'width': lineWidth - captionWidth/2 + 'px',
						'opacity': 1,
					});
					$(".caption-border.right", $container).css({
						'width': lineWidth - captionWidth/2 + 'px',
						'opacity': 1,
					});

				}// End First Load

				var swiper = new Swiper($container[0], swiperOptions);

				LinesWidth();

				$('.title', $container).each(function(){
					var words = $(this).text().split(" ");
					var total = words.length;
					$(this).empty();
					for (index = 0; index < total; index ++){
						$(this).append($("<div /> ").text(words[index]));
					}
				});

				$('.title div', $container).each(function(){
					var words = $(this).text().slice(" ");
					var total = words.length;
					$(this).empty();
					for (index = 0; index < total; index ++){
						$(this).append($("<span /> ").text(words[index]));
					}
				});

				// Tilt Showcase Wrapper
				// var maxTilt = 1.05;
				var maxTilt = 10;
				var mouseX, mouseY;
				// $(document).on("mousemove", function(event) {
				$(window).on("mousemove", function(_event) {
					// mouseX = event.pageX;
					// mouseY = event.pageY;
				});

				// $('#showcase-tilt').each(function() {
				$('.elementor-widget-jvbpd-single-portfolio-gallery .portfolio-gallery-tilt').each(function() {
					var $portfolioGalleryContainer = $(this);
					var thisWidth = $portfolioGalleryContainer.outerWidth();
					var thisHeight = $portfolioGalleryContainer.outerHeight();
					var thisOffset = $portfolioGalleryContainer.offset();
					// $(document).mousemove(function(event) {
					$portfolioGalleryContainer.mousemove(function(event) {
						mouseX = event.clientX;
						mouseY = event.clientY;
						var horTilt = ((mouseX / thisWidth) * (maxTilt * 2)) - maxTilt;
						var verTilt = (((mouseY - thisOffset.top) / thisHeight) * (maxTilt * 2)) - maxTilt;
						if(enableTlit) {
							TweenMax.to($portfolioGalleryContainer, 1, {rotationY: horTilt, rotationX: verTilt, scale: 1.05, ease: Power1.easeOut});
						}else{
							TweenMax.to($portfolioGalleryContainer, 0, {rotationY: 0, rotationX: 0, scale: 1.05 });
						}

						// var sxPos = mouseX / thisWidth * 100 -50;
						// var syPos = mouseY / thisHeight * 100 -50;
						// TweenMax.to($portfolioGalleryContainer, 1, {rotationY: (maxTilt / 4) * sxPos, rotationX: maxTilt * syPos, scale: 1.05, ease: Power1.easeOut});

					});
				});

				$('#ball').removeClass('hidden');

				// $('#showcase-slider').on('mousedown touchstart', function(event) {
				$this.on('mousedown touchstart', function(_event) {
					$('body').addClass('scale-up');
					TweenMax.to('#ball', 0.1,{transformOrigin: '15px 15px', borderWidth: '1px', scale: 2});
					$('.caption-border, .arrows-wrap').fadeOut(200);
				});
				// $('#showcase-slider').on('mouseup touchend', function(event) {
				$this.on('mouseup touchend', function(_event) {
					$('body').removeClass('scale-up');
					TweenMax.to('#ball', 0.1,{borderWidth: '2px', scale:1, x: -15, y: -15});
					$('.caption-border, .arrows-wrap').fadeIn(200)
				}).trigger('mouseup');

				// $(".swiper-slide").on('mouseenter', function(event) {
					// TweenMax.to('#ball', 0.2,{transformOrigin: '15px 15px', borderWidth: '1px', scale: 1.8});
					// TweenMax.to('#ball-loader', 0.2,{borderWidth: '1px', top: 1, left: 1});
					// $( "#ball" ).addClass("with-icon").append( '<i class="fa fa-plus"></i>' );
				// });

				$('.swiper-slide').on('mousedown', function(_event) {
					// return false;
				});

				// $(".swiper-slide").on('mouseleave', function(event) {
				// 	TweenMax.to('#ball', 0.2,{borderWidth: '2px', scale:1, x: -15, y: -15});
				// 	TweenMax.to('#ball-loader', 0.2,{borderWidth: '2px', top: 0, left: 0});
				// 	$("#ball").removeClass("with-icon");
				// 	$('#ball i').remove();
				// 	$(this).find('video').each(function() {
				// 		$(this).get(0).pause();
				// 	});
				// });

				// TweenMax.set($("#showcase-holder"), {opacity:0, scale:1.1});
				// TweenMax.to($("#showcase-holder"), 0.8, {force3D:true, opacity:1, scale:1, delay:0, ease:Power2.easeOut});
				TweenMax.set($container, {opacity:0, scale:1.1});
				TweenMax.to($container, 0.8, {force3D:true, opacity:1, scale:1, delay:0, ease:Power2.easeOut});
				TweenMax.to($(".swiper-pagination-bullet-active .subtitle", $container), 0.4, {force3D:true, opacity:1, y:0, delay:0.1, ease:Power2.easeOut});
				TweenMax.to($(".swiper-pagination-bullet-active .title", $container), 0.4, {force3D:true, opacity:1, y:0, delay:0.15, ease:Power2.easeOut});
				TweenMax.to($(".footer-button-wrap"), 0.4, {force3D:true, opacity:1, y:0, delay:0.2, ease:Power2.easeOut});
				TweenMax.to($(".showcase-counter, .swiper-pagination-bullet-active .counter, .arrows-wrap"), 0.3, {force3D:true, opacity:1, delay:0.15, ease:Power2.easeOut});
			}

		});
	}

	jvbpd_core_elementor.prototype.singleGalleryMasonry = function() {
		$('.elementor-widget-jvbpd-single-gallery').each(function(){
			var $widget = $(this);
			var settings = $widget.data('settings') || {};
			if('masonry' == settings.render_type){
				var $masonryWrap = $('ul.mansory-wrap', $widget);
				$masonryWrap.masonry({
					itemSelector: '.gallery-item',
				});
			}
		});
	}

	jvbpd_core_elementor.prototype.allBlockEffectAni = function() {
		$('.elementor-widget-jvbpd-page-block, .elementor-widget-jvbpd-map-listing-blocks, .elementor-widget-jvbpd-map-list-listing-blocks').each(function(){
			var
				$this = $(this),
				settings = $this.data('settings') || {},
				blockTarget = settings.animation_on_target == 'block',
				animation_delay = parseInt(settings.animation_delay || 1000),
				css_from = {},
				css_to = {};


			if(''==settings.animation_property) {
				return;
			}

			switch(settings.animation_property){
				case 'fadeIn':
					css_from = {opacity: 0,};
					css_to = {opacity: 1,};
					break;
				case 'zoomIn':
					css_from = {transform: 'scale(.5)', opacity:0, };
					css_to = {transform: 'scale(1)', opacity:1, };
					break;
				case 'zoomOut':
					css_from = {transform: 'scale(1.5)', opacity:0,};
					css_to = {transform: 'scale(1)', opacity:1,};
					break;
				case 'fromTop':
					css_from = {transform: 'translateY(-100px)', opacity:0,};
					css_to = {transform: 'translateY(0px)', opacity:1,};
					break;
				case 'fromLeft':
					css_from = {transform: 'translateX(-100px)', opacity:0,};
					css_to = {transform: 'translateX(0px)', opacity:1,};
					break;
				case 'fromBottom':
					css_from = {transform: 'translateY(100px)', opacity:0,};
					css_to = {transform: 'translateY(0px)', opacity:1,};
					break;
				case 'fromRight':
					css_from = {transform: 'translateX(100px)', opacity:0,};
					css_to = {transform: 'translateX(0px)', opacity:1,};
					break;
				case 'fromTopLeft':
					css_from = {transform: 'translate(-100px, -100px)', opacity:0,};
					css_to = {transform: 'translate(0px, 0px)', opacity:1,};
					break;
				case 'fromTopRight':
					css_from = {transform: 'translate(100px, -100px)', opacity:0,};
					css_to = {transform: 'translate(0%, 0%)', opacity:1,};
					break;
				case 'fromBottomLeft':
					css_from = {transform: 'translate(-100px, 100px)', opacity:0,};
					css_to = {transform: 'translate(0px)', opacity:1,};
					break;
				case 'fromBottomRight':
					css_from = {transform: 'translate(100px, 100px)', opacity:0,};
					css_to = {transform: 'translate(0px)', opacity:1,};
					break;
				case 'slideTop':
					css_from = {transform: 'translateY(-200%)', opacity:0,};
					css_to = {transform: 'translateY(0%)', opacity:1,};
					break;
				case 'slideLeft':
					css_from = {transform: 'translateX(-200%)', opacity:0,};
					css_to = {transform: 'translateX(0%)', opacity:1,};
					break;
				case 'slideBottom':
					css_from = {transform: 'translateY(200%)', opacity:0,};
					css_to = {transform: 'translateY(0%)', opacity:1,};
					break;
				case 'slideRight':
					css_from = {transform: 'translateX(200%)', opacity:0,};
					css_to = {transform: 'translateX(0%)', opacity:1,};
					break;
				case 'slideTopLeft':
					css_from = {transform: 'translate(-200%, -200%)', opacity:0,};
					css_to = {transform: 'translate(0%, 0%)', opacity:1,};
					break;
				case 'slideTopRight':
					css_from = {transform: 'translate(200%, -200%)', opacity:0,};
					css_to = {transform: 'translate(0%, 0%)', opacity:1,};
					break;
				case 'slideBottomLeft':
					css_from = {transform: 'translate(-200%, 200%)', opacity:0,};
					css_to = {transform: 'translate(0%, 0%)', opacity:1,};
					break;
				case 'slideBottomRight':
					css_from = {transform: 'translate(200%, 200%)', opacity:0,};
					css_to = {transform: 'translate(0%, 0%)', opacity:1,};
					break;
				case 'flipX':
					css_from = {transform: 'rotate3d(1,0,0,90deg) scale(0.8)', opacity:0,};
					css_to = {transform: 'perspective(2000px) rotate3d(1,0,0,0deg) scale(1)', opacity:1,};
					break;
				case 'flipY':
					css_from = {transform: 'rotate3d(0,1,0,90deg) scale(0.8)', opacity:0,};
					css_to = {transform: 'perspective(2000px) rotate3d(0,1,0,0deg) scale(1)', opacity:1,};
					break;
				case 'flipZ':
					css_from = {transform: 'perspective(2000px) rotate3d(0,0,1,45deg) scale(0.2)', opacity:0,};
					css_to = {transform: 'perspective(2000px) rotate3d(0,0,1,0deg) scale(1)', opacity:1,};
					break;
				case 'fromTopFlipX':
					css_from = {transform: 'translateY(-100px) rotate3d(1,0,0,90deg) scale(0.8)', opacity:0,};
					css_to = {transform: 'perspective(2000px) translateY(0) rotate3d(1,0,0,0deg) scale(1)', opacity:1,};
					break;
				case 'fromTopFlipY':
					css_from = {transform: 'translateY(-100px) rotate3d(0,1,0,90deg) scale(0.8)', opacity:0,};
					css_to = {transform: 'perspective(2000px) translateY(0) rotate3d(0,1,0,0deg) scale(1)', opacity:1,};
					break;
				case 'fromTopFlipZ':
					css_from = {transform: 'perspective(2000px) translateY(-100px) rotate3d(0,0,1,45deg) scale(0.2)', opacity:0,};
					css_to = {transform: 'perspective(2000px) translateY(0) rotate3d(0,0,1,0deg) scale(1)', opacity:1,};
					break;
				case 'fromLeftFlipX':
					css_from = {transform: 'translateX(-100px) rotate3d(1,0,0,90deg) scale(0.8)', opacity:0,};
					css_to = {transform: 'perspective(2000px) translateX(0) rotate3d(1,0,0,0deg) scale(1)', opacity:1,};
					break;
				case 'fromLeftFlipY':
					css_from = {transform: 'translateX(-100px) rotate3d(0,1,0,90deg) scale(0.8)', opacity:0,};
					css_to = {transform: 'perspective(2000px) translateX(0) rotate3d(0,1,0,0deg) scale(1)', opacity:1,};
					break;
				case 'fromLeftFlipZ':
					css_from = {transform: 'perspective(2000px) translateX(-100px) rotate3d(0,0,1,45deg) scale(0.2)', opacity:0,};
					css_to = {transform: 'perspective(2000px) translateX(0) rotate3d(0,0,1,0deg) scale(1)', opacity:1,};
					break;
				case 'fromBottomFlipX':
					css_from = {transform: 'translateY(100px) rotate3d(1,0,0,90deg) scale(0.8)', opacity:0,};
					css_to = {transform: 'perspective(2000px) translateY(0) rotate3d(1,0,0,0deg) scale(1)', opacity:1,};
					break;
				case 'fromBottomFlipY':
					css_from = {transform: 'translateY(100px) rotate3d(0,1,0,90deg) scale(0.8)', opacity:0,};
					css_to = {transform: 'perspective(2000px) translateY(0) rotate3d(0,1,0,0deg) scale(1)', opacity:1,};
					break;
				case 'fromBottomFlipZ':
					css_from = {transform: 'perspective(2000px) translateY(100px) rotate3d(0,0,1,45deg) scale(0.2)', opacity:0,};
					css_to = {transform: 'perspective(2000px) translateY(0) rotate3d(0,0,1,0deg) scale(1)', opacity:1,};
					break;
				case 'fromRightFlipX':
					css_from = {transform: 'translateY(100px) rotate3d(1,0,0,90deg) scale(0.8)', opacity:0,};
					css_to = {transform: 'perspective(2000px) translateY(0) rotate3d(1,0,0,0deg) scale(1)', opacity:1,};
					break;
				case 'fromRightFlipY':
					css_from = {transform: 'translateY(100px) rotate3d(0,1,0,90deg) scale(0.8)', opacity:0,};
					css_to = {transform: 'perspective(2000px) translateY(0) rotate3d(0,1,0,0deg) scale(1)', opacity:1,};
					break;
				case 'fromRightFlipZ':
					css_from = {transform: 'perspective(2000px) translateY(100px) rotate3d(0,0,1,45deg) scale(0.2)', opacity:0,};
					css_to = {transform: 'perspective(2000px) translateY(0) rotate3d(0,0,1,0deg) scale(1)', opacity:1,};
					break;
				case 'perspectiveX':
					css_from = {transform: 'perspective(2000px) rotateX(45deg)', opacity:0,};
					css_to = {transform: 'perspective(2000px)', opacity:1,};
					break;
				case 'perspectiveY':
					css_from = {transform: 'perspective(2000px) rotateY(45deg)', opacity:0,};
					css_to = {transform: 'perspective(2000px)', opacity:1,};
					break;
				case 'perspectiveZ':
					css_from = {transform: 'matrix3d(0.70592, 0.02465, 0.37557, -0.00062, -0.06052, 0.79532, 0.06156, -0.0001, -0.46435, -0.10342, 0.87958, -0.00146, -21.42566, 4.13698, 4.81749, 0.99197085)', opacity:0,};
					css_to = {transform: 'matrix3d(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1)', opacity:1,};
					break;
				case 'falling_rotate':
					css_from = {transform: 'matrix3d(0.71,0.71,0.00,0,-0.71,0.71,0.00,0,0,0,1,0,-50,-250,0,1)', opacity:0,};
					css_to = {transform: 'matrix3d(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1)', opacity:1,};
					break;
			}

			var moduleBindEventCallback = function($item, prepare) {
				var prepare = prepare || false;
				var clearProperty = function(){
					$item.css({
						transitionDuration: '',
						transitionProperty: '',
						transition: '',
						transform: '',
					});
				}
				var from = function() {
					$item.css(css_from);
				}
				var to = function() {
					var nTimeID = setInterval(function(){
						clearInterval(nTimeID);
						clearProperty();
						return false;
					}, parseInt(settings.animation_speed));
					css_to.transitionDuration = parseInt(settings.animation_speed) + 'ms';
					css_to.transitionProperty = 'all';
					$item.css(css_to);
				}
				var callback = function(_event){
					var $window = $(this);
					if(!blockTarget){
						if(($window.scrollTop() + $window.height()) >= $item.offset().top) {
							to();
						}
					}
				}
				if($item.data('bind-ani')){
					return true;
				}
				if(prepare){
					from();
					return false;

				}
				$item.addClass('animated');
				$item.data('bind-ani', true);
				clearProperty();
				from();
				if(blockTarget){
					to();
				}else{
					$(window).on('scroll', callback );
					callback();
				}
			}
			$(window).on('scroll javo:map/items/get/after', function(_event) {
				var intStack = 0;
				var $window = $(this);
				$('.module-item:not(.animated), .jvbpd-module:not(.animated)', $this).each(function(){
					var $item = $(this);
					if(blockTarget){
						if(($window.scrollTop() + $window.height()) >= $this.offset().top) {
							moduleBindEventCallback($item, true);
							setInterval(function(){
								moduleBindEventCallback($item);
							}, intStack * animation_delay);
							intStack++;
						}
					}else{
						moduleBindEventCallback($item);
					}
				});
			});
			$(window).on('jvbpd_core/shortcode/loaded', function(_event){
				$(this).trigger('scroll');
			});
		});
	}

	jvbpd_core_elementor.prototype.postBlockPopups = function() {
		var
			self = this,
			lightBox = self.util.getLightBox('post-block-lightbox');
		$('.elementor-widget-jvbpd-page-block').each(function(){
			var
				$this = $(this),
				settings = $this.data('settings') || {},
				items = $('[data-popup-post-id]', $this);
			if('yes' == settings.module_click_popup) {
				items.css({
					'cursor':'pointer',
				}).on('click', function( event) {
					var
						$item = $(this),
						item_id = $item.data('popup-post-id');
					event.preventDefault();
					$('.modal-body', lightBox).html('<i class="fa fa-spinner fa-spin"></i>');
					$('.close', lightBox).addClass('hidden');
					lightBox.modal('show');
					self.ajax( 'page_block_content', { post_id: item_id }, function( data ) {
						$('.close', lightBox).removeClass('hidden');
						$('.modal-body', lightBox).html(data.html);
					});
				});
			}
		});
	}

	jvbpd_core_elementor.prototype.testimoonialPopups = function() {
		var
			self = this,
			lightBox = self.util.getLightBox('testimoonial-lightbox');

		$('script[data-item-additional-content]').each(function() {
			var
				$this = $(this),
				content = $this.html(),
				block = $this.closest('.testimoni-wrapper');

			block.css('cursor', 'pointer').on('click', function(event){
				event.preventDefault();
				$('.modal-body', lightBox).html(content);
				lightBox.modal('show');
			});
		});
	}

	jvbpd_core_elementor.prototype.mapBlockAnimOnScroll = function() {
		$('.elementor-widget-jvbpd-map-listing-blocks, .elementor-widget-jvbpd-map-list-listing-blocks').each(function(){
			var
				effect,
				$this = $(this),
				is_masonry = $this.hasClass('masonry-yes'),
				settings = $this.data('settings') || {},
				container = $('.list-group > .row, .space > .row', $this);
			if(!is_masonry){
				return;
			}
			effect  = 'effect-' + settings.masonry_ani;
			container.addClass( 'jvbpd-grid' ).addClass(effect);
			if( !container.attr('id')){
				container.attr('id','animon-id-' + $(this).data('id'));
			}
			$this.addClass('map-block-container');
		});
	}

	jvbpd_core_elementor.prototype.mapBlockSetCount = function() {
		var self = this;
		$('.elementor-widget-jvbpd-map-listing-blocks, .elementor-widget-jvbpd-map-list-listing-blocks').each(function(){
			var
				$this = $(this),
				settings = $this.data('settings') || false;

			if(!settings){
				return;
			}

			var firstcount = parseInt(settings.count_first_loadmore) || false;
			var moreCount = parseInt(settings.count_loadmore) || false;
			//var listingType = settings.listing_type;

			self.loopCount = 0;
			$( window ).on( 'javo:map/filter/before', function( _event, _item, _obj ) {
				self.loopCount = 0;
				// if(listingType){
				// 	obj.listing_type_filter = listingType;
				// }
			});
			$( window ).on( 'javo:map/items/prepare', function( _event, obj ) {
				if(!obj){
					return false;
				}
				if(0 < moreCount){
					obj.args.loadmore_amount = moreCount;
				}
				if(self.loopCount == 0&& 0 < firstcount){
					obj.args.loadmore_amount = firstcount;
				}
				self.loopCount++;
			});
		});
	}

	jvbpd_core_elementor.prototype.authorReviewModal = function() {
		var self = this;
		var lightBox = self.util.getLightBox('author-review-lightbox');
		var $widgets = $('.elementor-widget-jvbpd-single-author-reviews:not(.binded)');
		$widgets.each(function(){
			var $widget = $(this);
			var $template = $('script[type="text/html"]', $widget).html() || '';
			$('.jvbpd-modal-popup-opener', $widget).on('click', function(){
				$('.modal-body', lightBox).html($template);
				lightBox.modal('show');
			});
			$widget.addClass('binded');
		});
	}

	jvbpd_core_elementor.prototype.jvbpdPopupModal = function() {
		var self = this;
		var lightBox = self.util.getLightBox('jvbpd-modal-lightbox');
		var $widgets = $('.elementor-widget-jvbpd-modal-popup:not(.binded)');
		$widgets.each(function(){
			var $widget = $(this);
			var $template = $('script[type="text/html"]', $widget).html() || '';
			$('.jvbpd-modal-popup-opener', $widget).on('click', function(){
				$('.modal-body', lightBox).html($template);
				lightBox.modal('show');
			});
			$widget.addClass('binded');
		});
	}
	jvbpd_core_elementor.prototype.cardDetailSlider = function() {
		var self = this;
		$('.card-bg-detail-images-slider:not(.bind)').each(function(){
			$(this).addClass('bind');

			var $wrap = $(this);
			var $output = $('.slider-wrap', $wrap);
			var inCursor = false;
            var postID = $wrap.data('post-id');
            var LOADING = 'loading';
			var LOADED = 'loaded';
			var SLIDESTYPE = $wrap.data('slides-type');
			var triggerAction = $wrap.data('trigger-action');
			var slideImagesSize = $wrap.data('slide-images-size');
			var slideSpped = parseInt($wrap.data('slider-speed') || 1000);

			if('yes' == $wrap.data('slider-effect')) {
				$wrap.addClass('effect-zoom-in');
			}

            var flexSliderCall = function(slides) {
                if(typeof $.flexslider != 'undefined') {
					if(0 < slides.length) {
						var flexArgs = {
							manualControls: true,
							start: function(slider) {
								$('.slider-pagination', $wrap).removeClass('hidden');
								$('.slider-pagination > span.current', $wrap).text(slider.currentSlide+1);
								$('.slider-pagination > span.total', $wrap).text(slider.count);

								if('hover' == triggerAction) {
									slider.stop();
									$(window).on('focus', function(){
										slider.stop();
									})
									// slider.mouseenter(function(){
									// slider.mouseover(function(){
									$wrap.mouseenter(function(){
										slider.vars.slideshowSpeed = slideSpped;
										slider.play();
									});

									// slider.mouseleave(function() {
									// slider.mouseout(function() {
									$wrap.mouseleave(function() {
										// slider.pause();
										// slider.pause();
										// slider.flexAnimate(0);
										slider.stop();
									});

									if(inCursor) {
										var nTimeID = setInterval(function(){
											$wrap.trigger('mouseenter');
											clearInterval(nTimeID);
										}, slideSpped);
									}else{
										$wrap.trigger('mouseleave');
									}
								}else{
									slider.flexslider('next');
								}
							},
							after: function(slider) {
								$('.slider-pagination > span.current', $wrap).text(slider.currentSlide+1);
								$('.slider-pagination > span.total', $wrap).text(slider.count);
							},
						}

						if('hover' == triggerAction) {
							flexArgs.directionNav = false;
							flexArgs.slideshowSpeed = slideSpped;
							flexArgs.animationSpeed = 1000;
							flexArgs.slideShow = false;
						}

						$( '.slider', $output).flexslider(flexArgs);

						// $wrap.mouseenter(function(){
						// 	$( '.slider', $output).flexslider('play');
						// }).mouseleave(function(){
						// 	$( '.slider', $output).flexslider(0);
						// });
					}
                }
            }
            var lightGalleryCall = function() {
                $( '.slide-item-wrap', $output).on('click', function(_event){
                    var $slide = $(this);
                    var $slider = $slide.closest('div.slider');
                    $slide.lightGallery({
                        dynamic: true,
                        dynamicEl: $slider.data('images'),
                        share: false,
                        actualSize: false,
                    });
                });
			}
			var loadSlidersCallback = function(){
				inCursor = true;
				if($wrap.hasClass(LOADED)) {
					return;
				}
				$wrap.addClass(LOADING);
				self.ajax('get_slider', {'post_id': postID, 'images_size': slideImagesSize}, function(xhr){
					$wrap.removeClass(LOADING).addClass(LOADED);
					$('.slider', $output).data('images', xhr.data);
					$.each(xhr.slides, function(_slideIndex, slideHTML){
						$('ul.slides', $output).append(slideHTML);
					});
					flexSliderCall(xhr.slides);
					if('popup' == SLIDESTYPE) {
						lightGalleryCall();
					}
				});
			}
			if('hover' == triggerAction) {
				$wrap.mouseenter(loadSlidersCallback);
				$wrap.mouseleave(function(){
					inCursor = false;
				});
			}else{
				$('.load-slider', $wrap).on(triggerAction, loadSlidersCallback);
			}
		});
	}
	jvbpd_core_elementor.prototype.cardStreetView = function() {
		var self = this;
		$('.elementor-widget-jvbpd-module-card').each(function(){
			$('.streetview-container:not(.bind)', $(this)).each(function(){
			// $('.streetview-container:not(.bind)', $(this)).on('click', function(event){
				var $container = $(this);
				var lat = $container.data('lat') || 0;
				var lng = $container.data('lng') || 0;
				var heading =  $container.data('heading') || 0;
				var pitch =  $container.data('pitch') || 0;
				var zoom =  $container.data('zoom') || 0;
				var latLng = new google.maps.LatLng(parseFloat(lat), parseFloat(lng));
				$container.on('click', function(){
					var streetViewService = new google.maps.StreetViewService();
					var STREETVIEW_MAX_DISTANCE = 5;
					if($container.data('street-view')) {
						return false;
					}
					streetViewService.getPanoramaByLocation(latLng, STREETVIEW_MAX_DISTANCE, function (_streetViewPanoramaData, status) {
						if (status === google.maps.StreetViewStatus.OK) {
							var panorama = new google.maps.StreetViewPanorama( $container[0], {
								position: latLng,
								pov: {
									'heading': parseFloat(heading),
									'pitch': parseFloat(pitch),
									'zoom': parseFloat(zoom),
								},
								addressControl: false,
								linksControl: false,
								panControl: false,
								zoomControl: false,
								enableCloseButton: false,
								fullscreenControl: false,
							});
							$container.data('street-view', panorama);
						}
					});
				});
				var thumbURi = 'https://maps.googleapis.com/maps/api/streetview?size=600x300&location=' +
					lat + ',' + lng + '&heading=' + heading + '&pitch=' + pitch;
				if(self.args.google_api) {
					thumbURi += '&key=' + self.args.google_api;
					$container.css('background-image', 'url(' + thumbURi + ')');
				}
				$container.addClass('bind');
			});
		});
	}
	jvbpd_core_elementor.prototype.swapDistanceUnit = function() {
		var widgetSelector = '.elementor-widget-jvbpd-map-list-filters';
		var mapInstance = window.jvbpd_map_box_func;
		$('.distance-unit-switcher input[type="checkbox"]', $(widgetSelector)).on('change', function(event){
			event.preventDefault();
			var $this = $(this);
			var $widget = $this.closest(widgetSelector);
			var unit = $this.is(':checked') ? 'mile' : 'km';
			mapInstance.args.distance_unit = unit;
			$('b.span.distance-unit, span.distance-unit',  $widget).text(unit);
			$(window).on('javo:map/filter/distance/set', function(_event, args){
				args.unit = unit;
			});
			// $('.javo-geoloc-slider-trigger').trigger('set');
		}).trigger('change');
	}

	jvbpd_core_elementor.prototype.itemGetAfterMasonry = function() {
		var self = this;
		return function( _event, args ){
			$.each([args.controls.map.output,args.controls.list.output], function(){
				var
					aosInstance,
					$this = $(this);
				if(!$this.hasClass('jvbpd-grid')){
					return;
				}
				aosInstance = new AnimOnScroll($this.get(0), {
					minDuration: 0.4,
					maxDuration: 0.7,
					viewportFactor: 0.8
				});
				$this.data('instance', aosInstance);
			});
		}
	}

	jvbpd_core_elementor.prototype.customLavaAS = function() {
		var self = this;
		$('.lava-ajax-search-form-wrap > input').each(function(){
			var
				$this = $(this),
				instance = false,
				dropdown = false,
				widget = $this.closest('.elementor-widget-jvbpd-search-form-listing'),
				widgetID = widget.data('id'),
				settings = widget.data('settings') || {};
			instance = $this.data('ui-autocomplete');
			if( instance ) {
				dropdown = instance.menu.element;
				dropdown.addClass('jvbpd-ajax-search-' + widgetID );
				$(window).on('lava:ajax-search-open', function(_event, _args){
					if(settings && 'yes' == settings.ajax_sub_menu_position){
						dropdown.css({
							'top': '+=' + settings.ajax_sub_menu_position_top.size + 'px',
							'left': '+=' + settings.ajax_sub_menu_position_left.size + 'px',
							'width': (settings.ajax_sub_menu_position_width.size) + 'px',
						})
					}
				});
			}
		});
	}

	jvbpd_core_elementor.prototype.searchFormAjax = function() {
		var self = this;
		return function(_event, lasInstance) {
			var $this = $(this);
			var $widget = $this.closest('.elementor-widget-jvbpd-search-form-listing');
			var settings = $widget.data('settings') || {};
			if('yes' == settings.ajax_defult_category) {
				lasInstance.args.listing_category = '[]';
			}

		}
	}

	jvbpd_core_elementor.prototype.parallaxSections = function() {
		var
			self = this,
			sections = typeof parallax_section_data != 'undefined' ? parallax_section_data : {};
		if(!sections){
			return;
		}
		$.each(sections, function(section_id, section_items){
			var
				output = new Array(),
				scrolls = new Array(),
				mousemoves = new Array(),
				section = $('[data-id="' + section_id + '"].elementor-section');

			$.each(section_items, function(_item_index, item){
				var itemEl = $('<div>').prop({
					'class': 'parallax-item item-id-' + item._id + ' ' + 'type-' + item.type,
				}).css({
				}).prepend(
					$('<div>').prop({
						'class' : 'parallax-item-image',
					}).data({
						'speed' : item.speed.size,
						'transform' : item.transform,
						'position-y' : item.backgroundPositionY.size,
					}).css({
						'z-ndex' : item.zIndex,
						'background-size': item.backgroundSize,
						'background-position': item.backgroundPositionX.size + '%' + ' ' + item.backgroundPositionY.size + '%',
						'background-image': 'url(' + item.image.url  + ')',
					})
				);
				output.push(itemEl);
				if('scroll' == item.type)  {
					scrolls.push(itemEl);
				}
				if('mouse_move' == item.type)  {
					mousemoves.push(itemEl);
				}
			});

			$(window).on('scroll', function() {
				var $win = $(this);
				$.each( scrolls, function() {
					var
						$this = $(this),
						$thisHeight = $this.innerHeight(),
						$image = $('.parallax-item-image', $this),
						$imageY = $image.offset().top,
						$imageBgY = $image.data('position-y') || '0',
						scrollTop = $win.scrollTop(),
						winHeight = $win.height(),
						speed = $image.data('speed') || 100,
						transform = $image.data('transform');

					speed = speed / 100;

					switch(transform) {
						case 'back_pos':
							var imgPercent = (scrollTop-$imageY+winHeight)/$thisHeight*100;

							if ( scrollTop < $imageY - winHeight ) imgPercent = 0;
							if ( scrollTop > $imageY + $thisHeight) imgPercent = 200;
							imgPercent *= speed;
							$image.css({
								'background-position-y': 'calc('+ imgPercent + 'px + ' + parseInt($imageBgY) + '%)',
							});
							break;
						case 'transform':
						default:
							var winBottom = scrollTop + winHeight;
							if (winBottom > $imageY && scrollTop < $imageY + $thisHeight) {
								var imgBottom = ((winBottom - $imageY) * speed);
								var imgTop = scrollTop + $thisHeight;
								var imgPercent = ((imgBottom / imgTop) * 100) + (50 - (speed * 50));
							}
							$image.css({
								transform: 'translateY('+ imgPercent + '%)',
							});
					}
				});
			});

			$.each( mousemoves, function(_mousemove_index, mousemove) {
				$(section).on('mousemove', function(event){
					var
						$this = $(mousemove),
						$image = $('.parallax-item-image', $this),
						speed = $image.data('speed') || 100,
						x = event.pageX - $this.offset().left - $this.width() / 2,
						y = event.pageY - $this.offset().top - $this.height() / 2;

					speed = speed / 100;

					x = ( -x * speed ) + 'px';
					y = ( -y * speed ) + 'px';
					$image.css({
						transform: 'translate('+ x + ',' + y + ')',
					});
				});
			});
			section.prepend(output);
		});
	}

	jvbpd_core_elementor.prototype.fullHeightSections = function() {
		$('section.elementor-element.full-height-yes').each(function(){
			var $section = $(this);
			var settings = $section.data('settings');
			var callback = function() {
				var $window = $(this);
				$section.css({
					position:'absolute',
					top:0 + 'px',
					bottom:0 + 'px',
				});
			}
			$(window).on('load', callback);
			callback();
		});
	}

	jvbpd_core_elementor.prototype.singleHeader = function() {
		$('.elementor-widget-jvbpd-single-header').each(function(){
			var $widget = $(this);
			$('.image-wrap', $widget).each(function(){
				var $button = $(this);
				$button.css('cursor', 'pointer').on('click', function(){
					if('undefined' != typeof elementorFrontend) {
						if(elementorFrontend.isEditMode()){
							return;
						}
					}
					if( typeof $.fn.lightGallery != 'undefined' ){
						var galleryArgs = {
							dynamic		: true,
							hash		: false,
							dynamicEl	: $('.container-video-grid', $widget).data('images'),
						}

						var adminbar = $('#wpadminbar');
						$('.container-video-grid', $widget).on('onBeforeOpen.lg', function(_event) {
							adminbar.length && adminbar.addClass('hidden');
						}).on('onBeforeClose.lg', function(_event){
							adminbar.length && adminbar.removeClass('hidden');
						});

						$('.container-video-grid', $widget).lightGallery(galleryArgs)
						$('.container-video-grid', $widget).data('lightGallery').index = parseInt($button.data('index'), 10) || 0;
					}
				})

			})

		});
	}

	jvbpd_core_elementor.prototype.applyMapStyle = function() {
		return function() {
			$('.elementor-widget-jvbpd-single-header, .elementor-widget-jvbpd-single-small-map').each(function(){
				var
					$this = $(this),
					map = $('.container-map', $this),
					mapInstance = $(map).gmap3('get'),
					settings = $this.data('settings') || {};
				if( map.length && mapInstance ) {
					if('yes' == settings.enable_google_map_style) {
						var styleCode = settings.google_map_style || '{}';
						mapInstance.setOptions({styles: JSON.parse(styleCode)});
					}else{
						mapInstance.setOptions({styles: []});
					}
					var zoomLv = parseInt(settings.map_zoom_level) || false;
					if(zoomLv) {
						mapInstance.setZoom(zoomLv);
					}
				}
			});
		}
	}

	jvbpd_core_elementor.prototype.mapBlockOrder = function() {
		var
			self = this,
			instance = window.jvbpd_map_box_func;

		$('.elementor-widget-jvbpd-map-listing-blocks, .elementor-widget-jvbpd-map-list-listing-blocks').each(function(){
			var $this = $(this);
			var order = String($this.data('order')).toLowerCase();
			var orderBy = String($this.data('order-by')).toLowerCase();

			if(orderBy == 'undefined') {
				return true;
			}

			switch(orderBy) {
			case 'title' :
				orderBy = 'name';
				break;
			case 'rand' :
				orderBy = 'random';
				break;
			}

			$( window ).on( 'javo:map/filter/before', function( _event, item, obj ) {
				if(true === obj.distanceFiltered){
					return;
				}
				obj.block_order_filtered = true;
				var items = item.items;
				if( 'rating' == orderBy ) {
					items.sort( instance.order_raty( orderBy ) );
				}else{
					items.sort( instance.compare( orderBy ) );
				}
				if( 'asc' == order ) {
					items.reverse();
				}
				item.set( items );
			});
		});
	}

	jvbpd_core_elementor.prototype.navMetisMenus = function() {
		$('.elementor-widget-jvbpd_nav_menu').each(function(){
			var $this = $(this);
			var $menu = $('ul.jvbpd-nav-menu', $this);
			if('binded' == $menu.data('bind-metis')) {
				return true;
			}
			$menu.metisMenu({
				/*
				triggerElement:':not(.wide-container) > .nav-link',
				parentTrigger:'.nav-item',
				// subMenu:'.menu-depth-1',
				subMenu:'.nav', */
			}).data('bind-metis', 'binded');
		});
	}
	jvbpd_core_elementor.prototype.mapSwitch = function() {
		var mapSwitcher = function(el) {
			this.el = $(el);
			this.map = $(this.el.data('map'));
			this.filter = $(this.el.data('filter'));
			this.list = $(this.el.data('list'));
			this.widths = {
				'map': Math.round(this.map.width() / $(window).width() * 100),
				'filter': Math.round(this.filter.width() / $(window).width() * 100),
				'list': Math.round(this.list.width() / $(window).width() * 100),
			}
			this.type = this.getType();
			this.bindCSS();
			this.bindEvent();
		}
		mapSwitcher.prototype.constructor = mapSwitcher;
		mapSwitcher.prototype.getType = function() {
			var type = false;
			if(this.el.hasClass('type-listOnly')) {
				type = 'list_only_toggle';
			}else if(this.el.hasClass('type-filterToggle')) {
				type = 'filter_open_toggle';
			}else if(this.el.hasClass('type-filterOpener')) {
				type = 'filter_opener';
				this.bindOpener();
			}
			return type;
		}

		mapSwitcher.prototype.bindCSS = function() {
			this.map.addClass('collapse');
			this.filter.addClass('collapse').css('overflow-x', 'visible');
			$.each([this.map, this.filter, this.list], function(){
				this.addClass('map-switch-handle');
				/*
				this.css({
					'transition': 'all .5s',
					'-webkit-transition': 'all .5s',
				}); */
			});
		}
		mapSwitcher.prototype.bindEvent = function() {
			var self = this;
			$('input[type="checkbox"]', self.el).on('change', function(event){
				event.preventDefault();
				var enable = $(this).is(":checked");
				if('list_only_toggle' == self.type) {
					self.listToggle(enable);
				}
				if('filter_open_toggle' == self.type) {
					self.filterOpenToggle(enable);
				}
			}).trigger('change');
			var wrap = $('.map-switch-opener-wrap');
			if(wrap.length) {
				$('.arrow-trigger', wrap).on('click', function(_event){
					$(this).toggleClass('open');
					var enable = $(this).hasClass('open');
					self.filterOpenToggle(enable);
				}).addClass('open').trigger('click');
			}

		}
		mapSwitcher.prototype.bindOpener = function() {
			var self = this;
			var wrap = $('<div>').addClass('map-switch-opener-wrap');
			var icons = '<i class="map-switch-opener filter-open fas fa-chevron-right"></i><i class="map-switch-opener filter-close fas fa-chevron-left"></i>';
			$('<div>').addClass('arrow-trigger').html(icons).appendTo(wrap);
			wrap.appendTo(self.filter);
		}
		mapSwitcher.prototype.listToggle = function(enable) {
			var self = this;
			if(self.map.length) {
				if(enable) {
					$('body').removeClass('list-only').addClass('list-map');
					self.map.addClass('show');
					self.map.css('width', self.widths['map'] + '%');
					if(self.filter.hasClass('show')) {
						self.list.css('width', self.widths['list'] + '%');
					}else{
						self.list.css('width', self.widths['list'] + self.widths['filter'] + 1 + '%');
					}
				}else{
					$('body').addClass('list-only').removeClass('list-map');
					self.map.removeClass('show');
					self.map.css('width', 0);
					if(self.filter.hasClass('show')) {
						self.list.css('width', self.widths['list'] + self.widths['map'] + 1 + '%');
					}else{
						self.list.css('width', '100%');
					}
				}
			}
		}
		mapSwitcher.prototype.allFilterTrigger = function(enable) {
			$('.elementor-widget-jvbpd-map-switch .map-switcher.type-filterToggle').each(function(){
				var $this = $(this);
				var $chkbox = $('input[type="checkbox"]', $this);
				$chkbox.attr('checked', enable);
			});
		}
		mapSwitcher.prototype.filterOpenToggle = function(enable) {
			var self = this;
			if(self.filter.length) {
				if(enable) {
					$('body').removeClass('filter-off').addClass('filter-on');
					self.filter.addClass('show').find('> div:first-child').css('visibility', 'visible');
					self.filter.css('width', self.widths['filter'] + '%');
					if(self.map.hasClass('show')) {
						self.list.css('width', self.widths['list'] + '%');
					}else{
						self.list.css('width', self.widths['list'] + self.widths['map'] + 1 + '%');
					}
				}else{
					$('body').removeClass('filter-on').addClass('filter-off');
					self.filter.removeClass('show').css('visibility', 'visible').find('> div:first-child').css('visibility', 'hidden');
					self.filter.css('width', 0 + '%');
					if(self.map.hasClass('show')) {
						self.list.css('width', self.widths['list'] + self.widths['filter'] + 1 + '%');
					}else{
						self.list.css('width', '100%');
					}
				}
			}
			self.allFilterTrigger(enable);
		}

		$('.elementor-widget-jvbpd-map-switch .map-switcher').each(function(){
			$(this).data('map-switcher', new mapSwitcher(this));
		});
	}
	jvbpd_core_elementor.prototype.getListingTypeFilterID = function() {
		return this.listingTypeFilterID;
	}
	jvbpd_core_elementor.prototype.mapSearchForm = function() {
		var self = this;
		$('.elementor-widget-jvbpd-map-search-form').each(function(_e){
			var $widget = $(this);
			var mapInstance = false;
			$('a[data-type].nav-link').on('click', function(_event){
				// var listingID = $(this).data('type');
				self.listingTypeFilterID = $(this).data('type');
				$( window ).on( 'javo:map/filter/before', function( _event, _items, obj ) {
					// obj.listing_type_filter = listingID;
					obj.listing_type_filter = self.getListingTypeFilterID();
					mapInstance = obj;
				});
				if(mapInstance) {
					mapInstance.filter();
				}
			});
			$('a[data-type].nav-link.active').trigger('click');
		});
	}
	jvbpd_core_elementor.prototype.mapListingTypeSelect = function() {
		var self = this;
		$('.elementor-widget-jvbpd-map-listing-type-select').each(function(_e){
			var mapInstance = window.jvbpd_map_box_func;
			$('a[data-type].listing-type-filter').on('click', function(_event){
				self.listingTypeFilterID = $(this).data('type');
				$( window ).on( 'javo:map/filter/before', function( _event, _items, obj ) {
					obj.listing_type_filter = self.getListingTypeFilterID();
					mapInstance = obj;
				});
				if(mapInstance) {
					mapInstance.filter();
				}
			});
		});
	}
	jvbpd_core_elementor.prototype.scrollMagic = function() {
		var self = this;
		const intro = document.querySelector(".jv-scroll-magic");
		if(null == intro) {
			return;
		}
		const video = intro.querySelector("video");
		const text = intro.querySelector("h1");
		//END SECTION
		const section = document.querySelector("section");
		const end = section.querySelector("h1");

		//SCROLLMAGIC
		const controller = new ScrollMagic.Controller();

		//Scenes
		let scene = new ScrollMagic.Scene({
		duration: 9000,
		triggerElement: intro,
		triggerHook: 0
		})
		.addIndicators()
		.setPin(intro)
		.addTo(controller);

		//Text Animation
		const textAnim = TweenMax.fromTo(text, 3, { opacity: 1 }, { opacity: 0 });

		let scene2 = new ScrollMagic.Scene({
		duration: 3000,
		triggerElement: intro,
		triggerHook: 0
		})
		.setTween(textAnim)
		.addTo(controller);

		//Video Animation
		let accelamount = 0.1;
		let scrollpos = 0;
		let delay = 0;

		scene.on("update", e => {
		scrollpos = e.scrollPos / 1000;
		});

		setInterval(() => {
		delay += (scrollpos - delay) * accelamount;

		video.currentTime = delay;
		}, 33.3);
	}

	jvbpd_core_elementor.prototype.jvTabsScript = function() {
		$('.elementor-widget-jv_tabs').each(function(){
			var $widget = $(this);
			var $nav = $('div.nav', $widget);
			if($nav.hasClass('nav-under-line')) {
				var $underline = $('.nav_underline', $nav);
				var $active = $('a.nav-item.active', $nav);

				$underline
					.width($active.outerWidth())
					.css('left', $active.position().left)

				$('a.nav-item', $nav).on('click', function(_event){
					var $item = $(this);
					$underline.css({
						'left': $item.position().left,
						'width': $item.outerWidth(),
					})
				})
			}

			$('a.nav-item', $nav).on('shown.bs.tab', function(_event){
				var $item = $(this);
				var bgType = $item.data('bg-type');

				if(!$item.hasClass('active')) {
					return;
				}

				$('.jv-nav-wrap-bg', $widget).css({
					'background-color': '',
					'background-image': '',
				});

				if('color' == bgType) {
					var bgColorCode = $item.data('bg-color');
					if($item.hasClass('active') && '' != bgColorCode) {
						$('.jv-nav-wrap-bg', $widget).css('background-color', bgColorCode);
					}
				}else if('image' == bgType) {
					var bgSRC = $item.data('bg-src');
					if($item.hasClass('active') && '' != bgSRC) {
						$('.jv-nav-wrap-bg', $widget).css('background-image', 'url(' +  bgSRC + ')');
					}
				}
			}).trigger('shown.bs.tab');
		})
	}

	jvbpd_core_elementor.prototype.navMenuSub = function() {
		$('.elementor-widget-jvbpd_nav_menu').each(function(){
			var $menu = $(this);
			var intSppend = 50;
			var isVertical = 'vertical' == $(this).data('dir');

			isVertical && $('li.main-menu-item', $menu).each(function() {
				var $menuItem = $(this);
				var $subItem = $('ul.nav', $menuItem);
				$subItem.each(function(){
					$(this).data('origin-height', $(this).height());
					$subItem.css({
						'display': 'flex',
						'overflow': 'hidden',
						'opacity': 0,
						'height':0,
					})
				})

				if($menu.hasClass('collapse-hover')){
					$menuItem.hover(function(){
						$subItem.animate({
							height: $subItem.data('origin-height'),
							'opacity': 1,
						}, intSppend)
					}, function(){
						$subItem.animate({
							height: 0,
							'opacity': 0,
						}, intSppend)
					});
				}else{
					let active = false;
					$menuItem.on('click', function(){
						$subItem.animate({
							height: $subItem.data('origin-height'),
							'opacity': 1,
						}, intSppend);
						active = true;
					}).on('mouseleave', function(){
						if(!active) {
							return;
						}
						$subItem.animate({
							height: 0,
							'opacity': 0,
						}, intSppend)
						active = true;
					})
				}

			})
		})
	}

	jvbpd_core_elementor.prototype.singleGroup = function() {
		var self = this;
		var lightBox = self.util.getLightBox('single-group-lightbox');
		$('.modal-dialog', lightBox).css({
			'width' : '750px',
			'max-width' : '750px',
		});

		$('.elementor-widget-jvbpd-single-gorup').each(function(){
			var $widget = $(this);

			$('a[data-show-group-detail]', $widget).on('click', function(_event){
				var $button = $(this);
				var post_id = $button.data('post-id');
				var group_id = $button.data('show-group-detail');

				$('.modal-body', lightBox).html('<div class="text-center">' +
					'<i class="fa fa-spinner fa-spin"></i>' +
					'</div>'
				);
				$('.close', lightBox).addClass('hidden');
				lightBox.modal('show');
				self.ajax( 'get_about_group', { 'post_id': post_id, 'group_id': group_id }, function( data ) {
					$('.close', lightBox).removeClass('hidden');
					$('.modal-body', lightBox).html(data.html);
					$('.google-map-wrap', lightBox).css('height', 300).each(function(){
						var lat = $(this).data('lat');
						var lng = $(this).data('lng');
						var latLng = new google.maps.LatLng(lat, lng);
						$(this).data('google-map', new google.maps.Map(this, {
							center: latLng,
							zoom: 12,
						}));
						$(this).data('google-map-marker', new google.maps.Marker({
							position: latLng,
							map: $(this).data('google-map'),
						}));
					});
				});
			});
		});
	}

	jvbpd_core_elementor.prototype.blockExtendPanel = function() {
		var self = this;
		var mapInstance = window.jvbpd_map_box_func;

		if(!mapInstance || !$('body').hasClass('lv-map-template')) {
			return;
		}

		var $panel = self.util.getExtendPanel('map-block-extend-panel');
		if('yes' != $panel.data('bind-close')) {
			$panel.on('panel.close', function(_event, _selector){
				mapInstance.isOpenExtendPanel = false;
				if(mapInstance.infoWindo) {
					mapInstance.infoWindo.setValues({'disableAutoPan': false})
				}
			}).data('bind-close', 'yes');
		}

		$('.elementor-widget-jvbpd-map-list-listing-blocks').each(function(){
			var $widget = $(this);

			if('yes' != $widget.data('extend-panel')) {
				return;
			}

			if('yes' == $widget.data('disable-infobubble')) {
				mapInstance.isActiveInfoBubble = false;
			}

			mapInstance.enableModuleLink = false;

			$(mapInstance).on('map-marker:click', function(_event, _marker, m){
				self.openExtendPanel($widget, $panel, m.data.post_id, mapInstance);
			})

			$('.jvbpd-module:not(.panel-bind)', $widget).each(function(){
				var $module = $(this);
				$module.addClass('panel-bind');

				$('a', $module).on('click', function(event){
					event.preventDefault();

					var $link = $(this);
					var item_id = $link.closest('.jvbpd-module').data( 'post-id' );

					if($link.hasClass('javo-infow-brief') || $link.hasClass('lava-favorite')) {
						return;
					}
					self.openExtendPanel($widget, $panel, item_id, mapInstance);
				});
			});
		});
	}

	jvbpd_core_elementor.prototype.openExtendPanel = function($widget, $panel, item_id, mapInstance) {

		var self = this;
		var prevItem = null;
		var prevItemData = null;

		// Set global variable extend panel open
		mapInstance.isOpenExtendPanel = true;

		var menuSettings = $widget.data('menu-settings');
		var contactSettings = {
			plugin: $widget.data('contact-form'),
			id: $widget.data('contact-form-id'),
		}

		// Disable infobubble auto moving
		if(mapInstance.infoWindo) {
			mapInstance.infoWindo.setValues({'disableAutoPan': true})
		}

		if (item_id != prevItem) {
			if(null !== prevItem) {
				mapInstance.swapIcon(prevItem, prevItemData.icon, prevItemData.zIndex);
			}
			prevItem = item_id;
			prevItemData = mapInstance.getMarker(item_id);

			var replaceMarker = '';
			if( 'replace_marker' == mapInstance.el.data('block-hover')){
				replaceMarker = mapInstance.el.data('block-hover-marker');
			}
			mapInstance.swapIcon(item_id, replaceMarker, 9999, false);
		}

		// Set Panel Position
		var leftPos = $widget.offset().left + $widget.width();
		$panel.css('left', leftPos + 'px');
		$panel.removeClass('hidden');

		// Loading Effect
		$('.panel-body', $panel).html('<div class="panel-loader"><i class="fas fa-circle-notch fa-spin"></i></div>');

		// Load Extend Contents
		self.ajax( 'map_extend_panel', {
			post_id: item_id,
			menus: menuSettings,
			cf: contactSettings.plugin,
			cfid: contactSettings.id
		}, function( data ) {
			$('.panel-body', $panel).html( data.html ).scrollTop(0);
			self.setupTooltips().setupExtendPanel($panel);
		} );

		// Moving Map
		if(mapInstance.getMarker(item_id).marker) {
			$('.javo-map-marker-label').removeClass('active');
			mapInstance.moveToMap(mapInstance.getMarker(item_id).marker.getPosition());
		}

		// Selected Effect for Marker
		var nSelectedmarkerID = setInterval(function(){
			$('.javo-map-marker-label[data-id="' + item_id + '"]').addClass('active');
			clearInterval(nSelectedmarkerID);
		}, 350);

	}

	jvbpd_core_elementor.prototype.setupExtendPanel = function($panel) {
		var self = this;

		// Get Direction
		var $getDirectionBox = self.util.getLightBox('map-block-get-direction-modal');
		$('button.cmd-get-direction').on('click', function(event){
			$('.modal-body', $getDirectionBox).html($('script[data-get-direction-template]').html());
			self.setupGetDirectionModal($getDirectionBox);
			$getDirectionBox.modal('show');
		})

		// Contact Form
		var $contactFormBox = self.util.getLightBox('map-block-contact-form-modal');
		$('button.cmd-show-contact-form').on('click', function(event){
			$('.modal-body', $contactFormBox).html($('script[data-contact-form-template]').html());
			$contactFormBox.modal('show');
		})

		// Tabs
		var $tabNav = $('.detail-nav', $panel);

		$('ul.nav.nav-tabs', $tabNav).scrollingTabs({
			bootstrapVersion: 4,
			cssClassLeftArrow: 'fa fa-chevron-left',
			cssClassRightArrow: 'fa fa-chevron-right'
		});

		$panel.addClass('current-tab-info');
		$('li.tab-nav', $tabNav).each(function(){
			var $nav = $(this);
			var target = $nav.data('tab');

			$('> a', $nav).on('click', function(event){
				event.preventDefault();
				var $link = $(this);

				$panel.removeClass(function(_index, className){
					return (className.match(/\bcurrent-tab-\S+/g) || []).join(' ')
				}).addClass('current-tab-' + target);

				$('li.tab-nav', $tabNav).removeClass('active');
				$('div.detail-tab-content', $panel).addClass('hidden');

				$nav.addClass('active');
				$('div.detail-tab-content.tab-' + target, $panel).removeClass('hidden');
			})
		})

		// Home(info)
		$('a.detail-nav-title-link', $panel).on('click', function(event){
			event.preventDefault();
			$('li.tab-nav[data-tab=info] > a', $tabNav).trigger('click');
		})

		// Thumbnails
		$('a.detail-header-image-link', $panel).on('click', function(event){
			event.preventDefault();
			$('li.tab-nav[data-tab=images] > a', $tabNav).trigger('click');
		})

		// More Reviews
		$('.reviews-more-items.section-btm-button > a', $panel).on('click', function(event){
			event.preventDefault();
			$('li.tab-nav[data-tab=review] > a', $tabNav).trigger('click');
		})

		// More Images
		$('.images-more-items.section-btm-button > a', $panel).on('click', function(event){
			event.preventDefault();
			$('li.tab-nav[data-tab=images] > a', $tabNav).trigger('click');
		})


		var $additionalPanel = self.util.getExtendPanel('map-block-additional-panel');
		$additionalPanel.css({
			'left' : $panel.offset().left + $panel.width(),
			'width' : 'auto',
			'right' : 0,
		});
		$('.panel-content', $additionalPanel).css({'overflow-y': 'hidden'});

		// Functions
		var $functions = $('.functions', $panel);
		$('li.list-group-item.cmd-street-view', $functions).on('click', function(event){
			event.preventDefault();

			var $cmd = $(this);
			var STREETVIEW_MAX_DISTANCE = 5;
			var latLng = new google.maps.LatLng($cmd.data('lat'), $cmd.data('lng'));
			var streetViewService = new google.maps.StreetViewService();

			streetViewService.getPanoramaByLocation(latLng, STREETVIEW_MAX_DISTANCE, function (_streetViewPanoramaData, status) {
				if (status === google.maps.StreetViewStatus.OK) {
					$additionalPanel.removeClass('hidden');
					$('.panel-body', $additionalPanel).html( '<div class="street-view" style="height:100%;"></div>');
					var panorama = new google.maps.StreetViewPanorama( $('.street-view', $additionalPanel)[0], {
						position: latLng,
						addressControl: false,
						linksControl: true,
						panControl: true,
						zoomControl: true,
						enableCloseButton: false,
						fullscreenControl: false,
						pov: {
							'heading': parseFloat($cmd.data('heading')),
							'pitch': parseFloat($cmd.data('pitch')),
							'zoom': parseFloat($cmd.data('zoom')),
						},
					});
				}
			});
		});

		// Favroite
		$(document).trigger('lava:favorite');

		// Share
		$('li.list-group-item.cmd-share', $functions).on('click', function(_event){
			$('.panel-body', $additionalPanel).html($('script[data-share-panel]', $panel).html());
			$('.panel-body button.close', $additionalPanel).remove();
			if(window.jvbpd_share_func) {
				window.jvbpd_share_func.init();
			}
			$additionalPanel.removeClass('hidden');
		});
		$('li.list-group-item.cmd-3d-view', $functions).on('click', function(_event){
			$('.panel-body', $additionalPanel).html($('script[data-3dviewer-panel]', $panel).html());
			$('.panel-body button.close', $additionalPanel).remove();
			$additionalPanel.removeClass('hidden');
		});

		// Detail Images Slider
		$('.meta-detail-images-item', $panel).on('click', function(_event){
			var $link = $(this);
			var target = $link.data('id');

			$('.panel-body', $additionalPanel).html($('script[data-images-panel]', $panel).html());
			$additionalPanel.removeClass('hidden');

			var $slider = $('.detail-images-slider', $additionalPanel);
			var slideIndex = $('.swiper-slide[data-image-id=' + target + ']', $slider).index() || 0;

			$slider.data('swiper', new Swiper($slider, {
				slidesPerView: 1,
				initialSlide: slideIndex,
				navigation: {
					nextEl: '.swiper-button-next',
					prevEl: '.swiper-button-prev',
				},
			}));
		})

		// Detail Review Images Slider
		$('.meta-detail-review-images-item', $panel).on('click', function(_event){
			var $link = $(this);
			var target = $link.data('id');

			$('.panel-body', $additionalPanel).html($('script[data-review-images-panel]', $panel).html());
			$additionalPanel.removeClass('hidden');

			var $slider = $('.detail-review-images-slider', $additionalPanel);
			var slideIndex = $('.swiper-slide[data-image-id=' + target + ']', $slider).index() || 0;

			$slider.data('swiper', new Swiper($slider, {
				slidesPerView: 1,
				initialSlide: slideIndex,
				navigation: {
					nextEl: '.swiper-button-next',
					prevEl: '.swiper-button-prev',
				},
			}));
		})

		// Menu
		$('a[data-show-menu-detail]', $panel).on('click', function(_event){
			var $button = $(this);
			var post_id = $button.data('post-id');
			var menu_id = $button.data('show-menu-detail');

			$('.panel-body', $additionalPanel).html(
				'<div class="panel-loader">' +
				'<i class="fas fa-circle-notch fa-spin"></i>' +
				'</div>'
			);
			$('.close', $additionalPanel).addClass('hidden');
			$additionalPanel.removeClass('hidden');
			self.ajax( 'get_about_menu', { 'post_id': post_id, 'menu_id': menu_id }, function( data ) {
				$('.close', $additionalPanel).removeClass('hidden');
				$('.panel-body', $additionalPanel).html(data.html);
			});
		});

		// Booking
		$('a[data-show-booking-detail]', $panel).on('click', function(_event){
			var $button = $(this);
			var post_id = $button.data('post-id');
			var group_id = $button.data('show-booking-detail');

			$('.panel-body', $additionalPanel).html(
				'<div class="panel-loader">' +
				'<i class="fas fa-circle-notch fa-spin"></i>' +
				'</div>'
			);
			$('.close', $additionalPanel).addClass('hidden');
			$additionalPanel.removeClass('hidden');
			self.ajax( 'get_about_group', { 'post_id': post_id, 'group_id': group_id }, function( data ) {
				$('.close', $additionalPanel).removeClass('hidden');
				$('.panel-body', $additionalPanel).html(data.html);
				$('.google-map-wrap', $additionalPanel).css('height', 300).each(function(){
					var lat = $(this).data('lat');
					var lng = $(this).data('lng');
					var latLng = new google.maps.LatLng(lat, lng);
					$(this).data('google-map', new google.maps.Map(this, {
						center: latLng,
						zoom: 12,
					}));
					$(this).data('google-map-marker', new google.maps.Marker({
						position: latLng,
						map: $(this).data('google-map'),
					}));
				});
			});
		});
		return self;
	}

	jvbpd_core_elementor.prototype.replaceTravelCode = function(code) {
		var output = google.maps.DirectionsTravelMode.DRIVING;
		switch( code.toString() ){
			case 'bicycling' : output = google.maps.DirectionsTravelMode.BICYCLING; break;
			case 'transit' : output = google.maps.DirectionsTravelMode.TRANSIT; break;
			case 'walking' : output = google.maps.DirectionsTravelMode.WALKING; break;
		}
		return output;
	}

	jvbpd_core_elementor.prototype.setupGetDirectionModal = function($modal) {
		var self = this;
		var search_strings = typeof jvbpd_search1_param != 'undefined' ? jvbpd_search1_param.strings : {};

		if('undefined' == typeof self.mapGetDirectionModal) {
			self.mapGetDirectionModal = {
				'mapInstance' : window.jvbpd_map_box_func,
				'directionsService' : new google.maps.DirectionsService(),
				'directionsRenderer' : new google.maps.DirectionsRenderer(),
			}
		}

		var $form = $('.detail-get-direction-modal-wrap', $modal);
		var $address = $('input[type=text]', $form);
		var $travelType = $('input[name=detail_get_direction_travel]', $form);

		// Google Init
		self.mapGetDirectionModal.directionsRenderer.set('directions', null);

		$address.autocomplete({
			source:[
				{
					type: 'get',
					value: 'current',
					label: search_strings.current_location || '',
				}
			],
			search: function(){
				if(0 < this.value.length) {
					return false;
				}
			},
			select: function(event, ui) {
				var term = ui.item.value;
				if('current' == term) {
					var geoCode = new google.maps.Geocoder();
					if(navigator.geolocation){
						navigator.geolocation.getCurrentPosition(function(pos){
							var gLatLng = new google.maps.LatLng(pos.coords.latitude, pos.coords.longitude);
							geoCode.geocode({latLng:gLatLng}, function(results, status){
								if(status == google.maps.GeocoderStatus.OK && results[0]){
									$address.val(results[0].formatted_address);
								}
							});
						});
					}
				}
				return false;
			},
			minLength:0,
		}).on('focus', function(event){
			$(this).autocomplete('instance').search($(this).val());
		}).autocomplete('instance')._renderItem = function(ul, item) {
			return $('<li>').css({
				color:'blue'
			})
			.append($('<i class="fa fas fa-location-arrow"></i>' + ' '))
			.append(item.label)
			.appendTo(ul);
		}

		$address.data('uiAutocomplete').menu.element.css('zIndex', 1050);
		$address.data('google-autocomplete', new google.maps.places.Autocomplete($address[0])) ;

		// Submit get direction
		$('.detail-get-directory', $modal).on('click', function(){
			var $button = $(this);
			var travelMode = $travelType.filter(':checked').val();
			var lat = $button.data('lat');
			var lng = $button.data('lng');
			var latLng = new google.maps.LatLng(lat, lng);

			$('.get-direction-msg', $modal).addClass('hidden');
			if('' != $address.val()) {
				self.mapGetDirectionModal.mapInstance.el.gmap3({getlatlng:{
					address: $address.val(),
					callback:function(results) {
						if(false !== results) {
							self.mapGetDirectionModal.directionsService.route({
								'origin': results[0].geometry.location,
								'destination': latLng,
								'travelMode': self.replaceTravelCode(travelMode),
							}, function(directionResult, status) {
								if (status == 'OK') {
									self.mapGetDirectionModal.directionsRenderer.setMap(self.mapGetDirectionModal.mapInstance.map);
									self.mapGetDirectionModal.directionsRenderer.setDirections(directionResult);
									$modal.modal('hide');
								}else{
									$('.get-direction-msg', $modal).removeClass('hidden');
								}
							});
						}
					}
				}});
			}
		})

		// Submit get direction (to google map)
		$('.detail-get-directory-to-google', $modal).on('click', function(){
			var $button = $(this);
			var travelMode = $travelType.filter(':checked').val();
			var lat = $button.data('lat');
			var lng = $button.data('lng');
			var latLng = new google.maps.LatLng(lat, lng);
			var requestURi = 'https://www.google.com/maps/';
			var requestQuery = $.param({
				daddr : [ latLng.lat(), latLng.lng() ].join( ',' ),
				saddr : $address.val().toString(),
				directionsmode : self.replaceTravelCode(travelMode),
			})
			window.open( [ requestURi, requestQuery].join( '?' ) );
			$modal.modal('hide');
		})

		$address.on('keypress', function(event){
			if(event.witch == 13) {
				$('.detail-get-directory', $modal).trigger('click');
			}
		})
	}

	jvbpd_core_elementor.prototype.mapSidePanel = function() {
		var self = this;
		var mapInstance = window.jvbpd_map_box_func;

		if(!mapInstance || !$('body').hasClass('lv-map-template')) {
			return;
		}

		var $panel = self.util.getExtendPanel('map-favorites-panel');
		var $canvasPanel = self.util.getExtendPanel('map-canvas-panel');
		var $blockWidget = $('.elementor-widget-jvbpd-map-list-listing-blocks');
		var $blockPanel = self.util.getExtendPanel('map-block-extend-panel');

		if('yes' != $blockPanel.data('bind-close')) {
			$blockPanel.on('panel.close', function(_event, _selector){
				mapInstance.isOpenExtendPanel = false;
				if(mapInstance.infoWindo) {
					mapInstance.infoWindo.setValues({'disableAutoPan': false})
				}
			}).data('bind-close', 'yes');
		}

		$('.elementor-widget-jvbpd-map-panels').each(function(){
			var $widget = $(this);
			$('a.jvbpd-map-panels-list-items-link.type-favorites', $widget).on('click', function(event){
				event.preventDefault();

				var $link = $(this);

				// Set Panel Position
				var leftPos = $widget.offset().left + $widget.width();
				$panel.css({
					'left': leftPos + 'px',
					'width' : $blockWidget.width(),
				});
				$panel.removeClass('hidden');

				// Loading Effect
				$('.panel-body', $panel).html('<div class="panel-loader"><i class="fas fa-circle-notch fa-spin"></i></div>');

				// Load Extend Contents
				self.ajax( 'map_favorites_panel', {}, function( data ) {
					$('.panel-body', $panel).html( data.html ).scrollTop(0);

					$('a.panel-opener', $panel).on('click', function(_event){
						var $wrap = $(this).closest('li');
						var itemID = $wrap.data('id');

						self.openExtendPanel($blockWidget, $blockPanel, itemID, mapInstance);
					});

					// Favroite
					$(document).trigger('lava:favorite');
				} );
			})

			$('a.jvbpd-map-panels-list-items-link.type-menu', $widget).on('click', function(event){
				event.preventDefault();
				var $link = $(this);

				// Set Panel Position
				var leftPos = $widget.offset().left + $widget.width();
				$canvasPanel.css({
					'left': leftPos + 'px',
					'width' : 'auto',
					'right' : '0px',
				});
				$canvasPanel.removeClass('hidden');
				if(! $link.hasClass('loaded')) {
					// Loading Effect
					$('.panel-body', $canvasPanel).html('<div class="panel-loader"><i class="fas fa-circle-notch fa-spin"></i></div>');
					self.ajax( 'get_canvas', { template: $link.data('menu-id') }, function( xhr ) {
						$link.addClass( 'loaded' );
						$canvasPanel.html( xhr.render );
						$('.jvbpd-menu-closer', $canvasPanel).on('click', function(){
							$canvasPanel.addClass('hidden');
						})
					} );
				}
			});
		})
		return self;
	}

	jvbpd_core_elementor.prototype.lavaNearByPOI = function($map, type, pos, icons) {
		var self = this;

		var service = new google.maps.places.PlacesService($map.data('google-map'));
		var bounds = $map.data('google-map').getBounds();
		var types = new Array();

		switch(type) {
            case 'transport':
                types = new Array('bus_station', 'subway_station', 'train_station', 'transit_station', 'airport');
                break;
            case 'supermarkets':
                types = new Array('bicycle_store', 'book_store', 'clothing_store', 'convenience_store', 'department_store', 'electronics_store', 'florist', 'furniture_store', 'hardware_store', 'home_goods_store', 'jewelry_store', 'liquor_store', 'shoe_store', 'shopping_mall', 'store', 'supermarket');
				break;
			case 'restaurant':
				types = new Array('restaurant');
				break;
			case 'schools':
				types = new Array('school');
				break;
            case 'cafes':
                types = new Array('bar', 'cafe');
                break;
            case 'pharma':
                types = new Array('pharma');
				break;
			case 'hospitals':
				types = new Array('hospitals');
				break;
		}

        $.each(types, function(i, t) {
            service.nearbySearch({
                location: pos,
                bounds: bounds,
                radius: 2000,
                types: [t]
            }, function poiCallback(results, status) {
                if (status === google.maps.places.PlacesServiceStatus.OK) {
                    for (var i = 0; i < results.length; i++) {
                        if (jQuery.inArray(results[i].place_id, self.placesID) == -1) {

							if('undefined' == typeof self.poiMarkers[type]) {
								self.poiMarkers[type] = new Array();
							}

							var markerIcon = '';
							if('undefined' != typeof icons[type]) {
								markerIcon = icons[type];
							}

							var poiMarker = new google.maps.Marker({
								map: $map.data('google-map'),
								icon: markerIcon,
								position: results[i].geometry.location,
							});

							self.poiMarkers[type].push(poiMarker);
							self.placesID.push(results[i].place_id);
							google.maps.event.addListener(poiMarker, 'click', (function(poiMarker, i){
								return function(event) {
									self.poiInfoWindow.setContent(results[i].name);
									self.poiInfoWindow.open($map.data('google-map'), poiMarker);
								}
							})(poiMarker, i));
                        }
                    }
                }
            });
        });
	}

	jvbpd_core_elementor.prototype.lavaNearby = function() {
		var self = this;
		self.placesID = new Array();
		self.poiMarkers = {};
		if('undefined' == typeof google) {
			return;
		}
		self.poiInfoWindow = new google.maps.InfoWindow();
		$('.elementor-widget-lava-nearby-places:not(.bind)').each(function(){
			let $widget = $(this);

			let $container = $('.lava-nearby-container', $widget);
			let $map = $('.lava-nearby-map', $widget);
			let $controls = $('.lava-nearby-controls', $widget);
			let markerIcons = $container.data('markers');

			let latLng = new google.maps.LatLng($container.data('lat'), $container.data('lng'));
			let mapZoomLv = $container.data('map-zoom-lv') ;

			$map.data('google-map', new google.maps.Map($map[0], {
				center: latLng,
				zoom: mapZoomLv,
				options:{
					scrollwheel: false,
					panControl: false,
					zoomControl: false,
					mapTypeControl: false,
					scaleControl: false,
					streetViewControl: false,
					rotateControl: false,
					fullscreenControl: false,
				},
			}))

			$map.data('google-map-marker', new google.maps.Marker({
				map: $map.data('google-map'),
				position: latLng,
			}))

			$('.item-zoom-in', $controls).on('click', function(event){
				$map.data('google-map').setZoom($map.data('google-map').getZoom() + 1);
			})

			$('.item-zoom-out', $controls).on('click', function(event){
				$map.data('google-map').setZoom($map.data('google-map').getZoom() - 1);
			})

			$('.poi-item', $controls).on('click', function(event){
				let $button = $(this);
				let cmd = $button.data('poi');
				let isActive = $button.hasClass('active');

				if(isActive) {
					if('undefined' != typeof self.poiMarkers[cmd]) {
						for (var i = 0; i < self.poiMarkers[cmd].length; i++) {
							self.poiMarkers[cmd][i].getMap() != null && self.poiMarkers[cmd][i].setMap(null);
						}
					}
				}else{
					self.lavaNearByPOI($map, cmd, latLng, markerIcons);
					if('undefined' != typeof self.poiMarkers[cmd]) {
						for (var i = 0; i < self.poiMarkers[cmd].length; i++) {
							self.poiMarkers[cmd][i].setMap($map.data('google-map'));
						}
					}
				}

				isActive ? $button.removeClass('active') : $button.addClass('active');
				google.maps.event.addListener($map.data('google-map'), 'bounds_changed', function() {
					!isActive &&
					self.lavaNearByPOI(
						$map,
						$map.data('google-map').getCenter(),
						cmd, markerIcons
					);
                });
			});

			$widget.addClass('bind');
		})

		$('.elementor-widget-lava-payment-calculator').each(function(){
			var $widget = $(this);

			$('canvas.calc-chart', $widget).each(function(){
				var $chart = $(this);
				$chart.data('chart', new Chart($chart.get(0).getContext('2d'), {
					type: 'doughnut',
					data: {
						datasets:[{
							data:[0,0,0,],
							backgroundColor:[
								"#0073e1",
								"#0dc3f8",
								"#FF5E5B",
							]
						}],
						labels:[
							$('.item-principal-interest > label', $widget).text().trim(),
							$('.item-property-tax > label', $widget).text().trim(),
							$('.item-hoo-fees > label', $widget).text().trim(),
						]
					},
					options: {
						responsive: true,
						cutoutPercentage:70,
						layout: {
							padding: {
								left: 50,
								right: 0,
								top: 0,
								bottom: 0
							}
						},
						title: {
							display: false,
						},
						animation: {
							animateScale: true,
							animateRotate: true
						},
						tooltips: {
							enabled: false
						},
						legend: {
							display: false,
						}
					}
				}))
			})

			var $downPayment = $('input[data-down-payment]', $widget);
			var $propertyPrice = $('input[data-property-price]', $widget);
			var $downPaymentPercent = $('input[data-down-payment-percent]', $widget);
			var $interest = $('input[data-interest]', $widget);
			var $term = $('input[data-term]', $widget);
			var $hooFees = $('input[data-hoo-fees]', $widget);
			var $propertyTax = $('input[data-property-tax]', $widget);

			var getDownPaymentPercent = function() {
				var downPay = parseFloat($downPayment.val(), 10);
				var propertyPrice = parseFloat($propertyPrice.val(), 10);
				var downPayPercent = parseFloat(downPay * 100 / propertyPrice, 10);
				return downPayPercent.toFixed(2);
			}

			var updateChart = function() {
				$downPaymentPercent.val(getDownPaymentPercent());

				var propertyPrice = parseFloat($propertyPrice.val(), 10);
				var downPay = parseFloat($downPayment.val(), 10);
				var interest = parseFloat($interest.val(), 10);
				var term = parseFloat($term.val(), 10);
				var hoo_fees = parseFloat($hooFees.val(), 10);
				var property_tax = parseFloat($propertyTax.val(), 10);

				var principal = propertyPrice - downPay;
				var operator_A  = parseFloat((interest / 100 / 12) * principal,10) ;
				var operator_B  = parseFloat( 1 + ( interest/ 100 / 12),10) ;


				var montly_pmt = parseFloat(
					operator_A / (1 - ( Math.pow( operator_B , (-1 * term * 12))))
				,10);
				if(0 == interest){
					montly_pmt = parseFloat( principal/ ( term*12) ,10);
				}

				var total_monthly  = montly_pmt + hoo_fees + property_tax;
				if(propertyPrice===0){
					total_monthly=0;
					montly_pmt=0;
				}

				$('span[data-calc-sum]').text(montly_pmt.toFixed(2));
				$('span[data-calc-total]').text( total_monthly.toFixed(2) );

				var percent_principal = parseFloat( montly_pmt*100/total_monthly, 10);
				var percent_hoa = parseFloat( hoo_fees*100/total_monthly, 10);
				var percent_tax = parseFloat( property_tax*100/total_monthly, 10);

				$('canvas.calc-chart', $widget).data('chart').data.datasets[0].data=[
					percent_principal,
					percent_tax,
					percent_hoa
				];

				$('canvas.calc-chart', $widget).data('chart').update();
			}

			$downPayment.on('change', function(event){
				$downPaymentPercent.val(getDownPaymentPercent());
				updateChart();
			})
			$downPaymentPercent.on('change', function(event){
				var propertyPrice = parseFloat($propertyPrice.val(), 10);
				var DownPayPercent = parseFloat($downPaymentPercent.val(), 10);
				var downPayment = parseFloat(
					propertyPrice * DownPayPercent / 100
				);
				$downPayment.val(downPayment.toFixed(2));
				updateChart();
			});

			$.merge($hooFees, $propertyTax).on('change', function(){
				var hoo_fees = parseFloat($hooFees.val(), 10);
				var property_tax = parseFloat($propertyTax.val(), 10);
				var principal = parseFloat($('span[data-calc-sum]').text(), 10);
				var total = principal + hoo_fees + property_tax;
				$('span[data-calc-total]').text( total.toFixed(2) );
			})

			$.merge($propertyPrice, $term, $interest, $hooFees, $propertyTax).on('change', function(){
				updateChart();
			});
			updateChart();
		});
	}

	jvbpd_core_elementor.prototype.lavaYelpNearby = function() {
		$('.elementor-widget-lava-yelp-nearby').each(function(){
			let $widget = $(this);
			let $wrapper = $('.lava-yelp-nearby-wrap', $widget);
			let settings = $wrapper.data('params');

			$('.term-item', $widget).each(function(){
				let $item = $(this);
				$('.rating-wrap', $item).raty({
					starOff: settings.star_off,
					starOn: settings.star_on,
					starHalf: settings.star_half,
					half: true,
					readOnly: true,
					score: function() {
						return $(this).data('score');
					}
				});
			});
		})
	}

	jvbpd_core_elementor.prototype.lavaDynamicAccordion = function() {
		var self = this;
		var lightBox = self.util.getLightBox('single-accordion-items-lightbox');

		$('.modal-dialog', lightBox).css({
			'width' : '750px',
			'max-width' : '750px',
		});

		$('.elementor-widget-lava-dynamic-accordion').each(function(){
			var $widget = $(this);
			$('a[data-show-item-detal]', $widget).on('click', function(event){
				var $button = $(this);
				var post_id = $button.data('post-id');
				var plan_id = $button.data('show-item-detal');

				$('.modal-body', lightBox).html('<div class="text-center">' +
					'<i class="fa fa-spinner fa-spin"></i>' +
					'</div>'
				);

				lightBox.modal('show');

				self.ajax( 'accordion_item_get_detail', { 'post_id': post_id, 'item_id': plan_id }, function( data ) {
					$('.close', lightBox).removeClass('hidden');
					$('.modal-body', lightBox).html(data.html);
				});
			})
		})
	}

	jvbpd_core_elementor.prototype.lavaDynamicCompare = function() {
		var self = this;
		$('.elementor-widget-lava-dynamic-compare-button').each(function(){
			let $widget = $(this);
			let compareIDs = ( $.cookie('lava-dynamic-compare-ids') || '|').split('|').filter(function(a){return a!==''});

			$('.compare-badge', $widget).text(compareIDs.length);
			$(window).on('lava/dynamicCompare/add_item', function(event, ids, post_id){
				$('.compare-badge', $widget).text(ids.length);
			});
		});

		$('table.dynamic-compare-list-items').each(function(){
			let $table = $(this);
			$('button.compare-all-remove', $(this)).on('click', function(event){
				$('td[data-post-id]', $table).remove();
				$.removeCookie('lava-dynamic-compare-ids', {'path' : '/'});
			})

			$('button.compare-remove', $(this)).on('click', function(event){
				let compareIDs = ( $.cookie('lava-dynamic-compare-ids') || '|').split('|').filter(function(a){return a!==''});

				let $itemWrap = $(this).closest('td');
				let listID = $itemWrap.data('post-id') || 0;

				compareIDs = compareIDs.filter(function(a){ return a !== listID.toString()});

				if(compareIDs.length) {
					$.cookie('lava-dynamic-compare-ids', compareIDs.join('|'), {
						'expires' : 365,
						'path' : '/',
					});
				}else{
					$.removeCookie('lava-dynamic-compare-ids', {'path' : '/'});
				}
				$('td[data-post-id=' + listID + ']', $table).remove();
			})
		})
	}

	jvbpd_core_elementor.prototype.reviewFilter = function() {
		var filterBy = '';
		var score = '';
		$('.elementor-widget-jvbpd-map-review-filter').each(function(){
			var $widget = $(this);
			$('.dropdown-item', $widget).on('click', function(event){
				var $wrap = $(this).closest('.dropdown');
				var $button = $('button.dropdown-toggle', $wrap);

				filterBy = $button.data('review-filter');
				score = $(this).data('score');

				$('.dropdown-item', $widget).removeClass('active');
				$(this).addClass('active');
				$( document ).trigger( 'javo:map_refresh' );
				$('button', $widget).addClass('disabled').prop('disabled', true);
			});
			$(window).on('javo:map/items/get/after', function(){
				$('button', $widget).removeClass('disabled').prop('disabled', false);
			});
		})
		$( window ).on( 'javo:map/filter/after', function( _event, item ) {
			var items = item.items;
			if(score) {
				var results = $.grep(items, function (itemData) {
					return 'undefined' != typeof itemData.rating_filter_scores &&
					'undefined' != typeof itemData.rating_filter_scores[filterBy] &&
					parseInt(itemData.rating_filter_scores[filterBy]) == score;
				});
				item.set(results);
			}
			// items.sort(obj.review_compare("Location"));
		});
	}

	jvbpd_core_elementor.prototype.categoryBlock = function() {
		var self = this;
		$('.elementor-widget-jvbpd-category-block').each(function(){
			let $widget = $(this);
			let $wrap = $('.javo-featured-block', $widget);
			let alertNotSupport = function(){
				alert('Geolocation not supported!');
				$wrap.removeClass('redirecting');
			};
			if('yes' == $widget.data('use-geolocation')) {
				$('a.category-block-link', $widget).on('click', function(event) {
					event.preventDefault();
					let $anchor = $(this);
					if(navigator.geolocation) {
						$wrap.addClass('redirecting');
						navigator.geolocation.getCurrentPosition(function(pos){
							let lat = pos.coords.latitude;
							let lng = pos.coords.longitude;

							self.ajax('get_current_location_string', {
								'lat' : lat, 'lng' : lng,
							}, function(response) {
								// window.location.href = $anchor.attr('href').replace(/\/$/, '') +
								// '/?' + 'radius_key=' + response.string;
								window.location.href = self.util.updateURL($anchor.attr('href'), 'radius_key', response.string)
							})
						}, function(){
							alertNotSupport();
						});
					}else{
						alertNotSupport();
					}
				});
			}
		})
	}
	window.jvbpd_core_elementor = new jvbpd_core_elementor;

} )( jQuery, window )

;(function($, window, document, _undefined){

    window.JVinInitElementsOnReady = function( $scope ){
        $scope = $scope || $(document);
        $.fn.JVinParallaxBoxInit( $scope );
        $.fn.JVinParallaxSectionInit( $scope );
        $.fn.JVinScrollableAnimsInit( $scope );
    }

    $(function(){
        JVinInitElementsOnReady();
    });

})(jQuery, window, document);