<?php

$listingTypeData = Array();
if(class_exists('\\LavaDirectoryManagerPro\\Base\\BaseController')) {
    $listingProBase = new \LavaDirectoryManagerPro\Base\BaseController;
    $listingTypeID = $listingProBase->getListingType($lvltGroupListing->ID);
    $listingTypeData = get_post_meta($listingTypeID, \LavaDirectoryManagerPro\Base\BaseController::LVLT_META_KEY, true);
    $listingTypeFields = isset($listingTypeData['lt_fields']) ? json_decode($listingTypeData['lt_fields'], true) : Array();
}
$groupDefaultImage = false;
foreach($listingTypeFields as $field) {
    if(
        isset($field['type']) && isset($field['group_type']) &&
        $field['type'] == 'field_group' && $field['group_type'] != 'type2'
    ){
        $groupDefaultImage = isset($field['default_image_id']) ? $field['default_image_id'] : false;
        break;
    }
}

$classTypes = isset($lvltGroup->class_type) ? ( is_array($lvltGroup->class_type) ? $lvltGroup->class_type : Array($lvltGroup->class_type) ) : Array();
$classTypesReplaces = Array(
    'makeup' => esc_html__('Makeup', 'lava-directory-manager-pro'),
    'Hair' => esc_html__('Hair', 'lava-directory-manager-pro'),
    'eyebrow' => esc_html__('Eyebrow', 'lava-directory-manager-pro'),
    'eyelash' => esc_html__('Eyelash', 'lava-directory-manager-pro'),
    'personal_styling' => esc_html__('Personal Styling', 'lava-directory-manager-pro'),
);
$classTypes = str_replace(array_keys($classTypesReplaces), array_values($classTypesReplaces), $classTypes);

$classTypes = join(', ', array_filter($classTypes));
$classImageID = $groupDefaultImage;
if($lvltGroup->featured_image_id) {
    $classImageID = $lvltGroup->featured_image_id;
}
$lvltGroupListingAuthor = get_user_by('id', $lvltGroupListing->post_author);
$logoImageID = get_post_meta($lvltGroupListing->ID, '_logo', true);

?>
<div class="single-group-wrap">
    <div class="row">
        <div class="col single-group-left">
            <div class="single-group-thumbnail">
                <?php echo wp_get_attachment_image($classImageID, 'large'); ?>
            </div>
        </div>
        <div class="col single-group-right">
            <h3 class="single-group-title"><?php echo esc_html($lvltGroup->title); ?></h3>
            <div class="single-group-type"><?php echo esc_html($classTypes); ?></div>

            <div class="media single-group-author p-1 m-0 border border-light">
                <?php echo wp_get_attachment_image($logoImageID, Array(50, 50)); ?>
                <div class="media-body align-self-center">
                    <?php echo $lvltGroupListingAuthor->display_name; ?>
                </div>
            </div>
            <p class="single-group-description"><?php echo esc_html($lvltGroup->description); ?></p>
            <?php if(isset($lvltGroup->contact_type) && in_array($lvltGroup->contact_type, Array('phone', 'email', 'link'))){ ?>
                <p class="single-group-contact alert bg-dark text-white p-1">
                    <?php
                    switch($lvltGroup->contact_type) {
                    case 'phone':
                        printf(
                            '%1$s<a href="tel:%2$s" class="text-white" target="_blank">%2$s</a>',
                            esc_html__("Phone : ", 'lava-directory-manager-pro'),
                            esc_attr($lvltGroup->contact_phone)
                        );
                        break;
                    case 'email':
                        printf(
                            '%1$s<a href="mailto:%2$s" class="text-white" target="_blank">%2$s</a>',
                            esc_html__("Email : ", 'lava-directory-manager-pro'),
                            esc_attr($lvltGroup->contact_email)
                        );
                        break;
                    case 'link':
                        printf(
                            '%1$s<a href="%2$s" class="text-white" target="_blank">%2$s</a>',
                            esc_html__("Sign-up : ", 'lava-directory-manager-pro'),
                            esc_attr($lvltGroup->contact_link)
                        );
                        break;
                    } ?>
                </p>
            <?php } ?>
            <?php if(0 < count($lvltRelateGroups)) { ?>
                <div class="row">
                <?php foreach($lvltRelateGroups as $relateGroupID => $relateGroup) { ?>
                    <div class="col-4 text-center">
                        <?php
                        $groupFeaturedImageID = $groupDefaultImage;
                        if(\WP_Post::get_instance($relateGroup->featured_image_id)) {
                            $groupFeaturedImageID = $relateGroup->featured_image_id;
                        }
                        if(\WP_Post::get_instance($groupFeaturedImageID)) { ?>
                            <p><?php echo wp_get_attachment_image($groupFeaturedImageID, Array(80, 80)); ?></p>
                        <?php } ?>
                        <h4><?php echo $relateGroup->title; ?></h4>
                    </div>
                <?php } ?>
                </div>
            <?php } ?>
        </div>
    </div>
    <?php if($lvltGroup->location_lat && $lvltGroup->location_lng); ?>
    <div class="row">
        <div class="col single-group-left">
            <h4><?php esc_html_e("Location", 'lava-directory-manager-pro'); ?></h4>
            <div class="google-map-wrap" data-lat="<?php echo esc_attr($lvltGroup->location_lat); ?>" data-lng="<?php echo esc_attr($lvltGroup->location_lng); ?>"></div>
        </div>
    </div>
</div>
