<?php

$listingTypeData = Array();
if(class_exists('\\LavaDirectoryManagerPro\\Base\\BaseController')) {
    $listingProBase = new \LavaDirectoryManagerPro\Base\BaseController;
    $listingTypeID = $listingProBase->getListingType($lvltMenuListing->ID);
    $listingTypeData = get_post_meta($listingTypeID, \LavaDirectoryManagerPro\Base\BaseController::LVLT_META_KEY, true);
    $listingTypeFields = isset($listingTypeData['lt_fields']) ? json_decode($listingTypeData['lt_fields'], true) : Array();
}
$menuDefaultImage = false;
foreach($listingTypeFields as $field) {
    if(
        isset($field['type']) && isset($field['group_type']) &&
            $field['type'] == 'field_group' && $field['group_type'] == 'type2'
    ){
        $menuDefaultImage = isset($field['default_image_id']) ? $field['default_image_id'] : false;
        break;
    }
}

$menuImageID = $menuDefaultImage;
if($lvltMenu->featured_image_id) {
    $menuImageID = $lvltMenu->featured_image_id;
}
$lvltMenuListingAuthor = get_user_by('id', $lvltMenuListing->post_author);
$logoImageID = get_post_meta($lvltMenuListing->ID, '_logo', true);

?>
<div class="single-menu-wrap">
    <div class="row">
        <div class="col single-menu-left">
            <div class="single-menu-thumbnail">
                <?php echo wp_get_attachment_image($menuImageID, 'large'); ?>
            </div>
        </div>
        <div class="col single-menu-right">
            <h3 class="single-menu-title"><?php echo esc_html($lvltMenu->title); ?></h3>

            <div class="media single-menu-author p-1 m-0 border border-light">
                <?php echo wp_get_attachment_image($logoImageID, Array(50, 50)); ?>
                <div class="media-body align-self-center">
                    <?php echo $lvltMenuListingAuthor->display_name; ?>
                </div>
            </div>
            <p class="single-menu-description"><?php echo esc_html($lvltMenu->description); ?></p>
            <?php if(isset($lvltMenu->contact_type) && in_array($lvltMenu->contact_type, Array('phone', 'email', 'link'))){ ?>
                <p class="single-menu-contact alert bg-dark text-white p-1">
                    <?php
                    switch($lvltMenu->contact_type) {
                    case 'phone':
                        printf(
                            '%1$s<a href="tel:%2$s" class="text-white" target="_blank">%2$s</a>',
                            esc_html__("Phone : ", 'lava-directory-manager-pro'),
                            esc_attr($lvltMenu->contact_phone)
                        );
                        break;
                    case 'email':
                        printf(
                            '%1$s<a href="mailto:%2$s" class="text-white" target="_blank">%2$s</a>',
                            esc_html__("Email : ", 'lava-directory-manager-pro'),
                            esc_attr($lvltMenu->contact_email)
                        );
                        break;
                    case 'link':
                        printf(
                            '%1$s<a href="%2$s" class="text-white" target="_blank">%2$s</a>',
                            esc_html__("Sign-up : ", 'lava-directory-manager-pro'),
                            esc_attr($lvltMenu->contact_link)
                        );
                        break;
                    } ?>
                </p>
            <?php } ?>
            <?php if(0 < count($lvltRelateMenus)) { ?>
                <div class="row">
                <?php foreach($lvltRelateMenus as $relateMenuID => $relateMenu) { ?>
                    <div class="col-4 text-center">
                        <?php
                        $groupFeaturedImageID = $menuDefaultImage;
                        if(\WP_Post::get_instance($relateMenu->featured_image_id)) {
                            $groupFeaturedImageID = $relateMenu->featured_image_id;
                        }
                        if(\WP_Post::get_instance($groupFeaturedImageID)) { ?>
                            <p><?php echo wp_get_attachment_image($groupFeaturedImageID, Array(80, 80)); ?></p>
                        <?php } ?>
                        <h4><?php echo $relateMenu->title; ?></h4>
                    </div>
                <?php } ?>
                </div>
            <?php } ?>
        </div>
    </div>
</div>