<?php
global $post;
if($lvListing instanceof \WP_Post ) {
    $post = $lvListing;
    setup_postdata($post);
    $images_meta = get_post_meta(get_the_ID(), 'detail_images', true);
    $images = is_array($images_meta) ? $images_meta : Array();
    if(has_post_thumbnail()) {
        $images = wp_parse_args($images, Array(get_post_thumbnail_id()));
    }
    $images_count = sizeof($images_meta);
    $managerInstance = function_exists('lava_directory') ? lava_directory() : false;
    $reviewInstnace = function_exists('lv_directoryReview') ? lv_directoryReview() : false;
    $d3Instance = function_exists('lava_directory_3DViewer') ? lava_directory_3DViewer() : false;
    $favInstance = class_exists( 'lvDirectoryFavorite_button' ) ? new lvDirectoryFavorite_button( Array(
        'format' => '{text}' . esc_html__("Bookmark", 'jvfrmtd'),
        'post_id' => get_the_ID(),
        'save' => "<i class='far fa-bookmark'></i>",
        'unsave' => "<i class='fas fa-bookmark'></i>"
    ) ) : false;

    $groupBookings = get_post_meta(get_the_ID(), 'field_group', true);
    $groupMenus = get_post_meta(get_the_ID(), 'field_group_type2', true);

    $listingTypeData = Array();
    if(class_exists('\\LavaDirectoryManagerPro\\Base\\BaseController')) {
        $listingProBase = new \LavaDirectoryManagerPro\Base\BaseController;
        $listingTypeID = $listingProBase->getListingType(get_the_ID());
        $listingTypeData = get_post_meta($listingTypeID, \LavaDirectoryManagerPro\Base\BaseController::LVLT_META_KEY, true);
        $listingTypeFields = isset($listingTypeData['lt_fields']) ? json_decode($listingTypeData['lt_fields'], true) : Array();
    }
    $groupType1DefaultImage = false;
    $groupType2DefaultImage = false;
    foreach($listingTypeFields as $field) {
        if(
            isset($field['type']) && isset($field['group_type']) &&
            $field['type'] == 'field_group' && $field['group_type'] == 'type1'
        ) {
            $groupType1DefaultImage = isset($field['default_image_id']) ? $field['default_image_id'] : false;
        }
        if(
            isset($field['type']) && isset($field['group_type']) &&
            $field['type'] == 'field_group' && $field['group_type'] == 'type2'
        ) {
            $groupType2DefaultImage = isset($field['default_image_id']) ? $field['default_image_id'] : false;
        }
    }
}else{
    return;
}

$allReviewImages = Array(); ?>
<div class="detail-header">
    <?php
    $intImageIndex = 0;
    if(0 < $images_count) { ?>
        <div class="detail-header-container">
            <div class="detail-header-column column-left">
                <?php
                $image_src = wp_get_attachment_image_src($images[$intImageIndex]);
                $intImageIndex++;
                if(false !== $image_src) { ?>
                    <a class="detail-header-image-link">
                        <div class="detail-header-image" style="background-image:url(<?php echo esc_attr($image_src[0]); ?>"></div>
                    </a>
                <?php } ?>
            </div>
            <div class="detail-header-column column-right">
                <div class="detail-header-row">
                    <?php
                    if(isset($images[$intImageIndex])) {
                        $image_src = wp_get_attachment_image_src($images[$intImageIndex]);
                        $intImageIndex++;
                        if(false !== $image_src) { ?>
                            <div class="detail-header-column">
                                <a class="detail-header-image-link">
                                    <div class="detail-header-image" style="background-image:url(<?php echo esc_attr($image_src[0]); ?>"></div>
                                </a>
                            </div>
                        <?php } ?>
                    <?php } ?>
                    <?php
                    if(isset($images[$intImageIndex])) {
                        $image_src = wp_get_attachment_image_src($images[$intImageIndex]);
                        $intImageIndex++;
                        if(false !== $image_src) { ?>
                            <div class="detail-header-column">
                                <a class="detail-header-image-link">
                                    <div class="detail-header-image" style="background-image:url(<?php echo esc_attr($image_src[0]); ?>"></div>
                                </a>
                            </div>
                        <?php } ?>
                    <?php } ?>
                </div>
                <div class="detail-header-row">
                    <?php
                    if(isset($images[$intImageIndex])) {
                        $image_src = wp_get_attachment_image_src($images[$intImageIndex]);
                        $intImageIndex++;
                        if(false !== $image_src) { ?>
                            <div class="detail-header-column">
                                <a class="detail-header-image-link">
                                    <div class="detail-header-image" style="background-image:url(<?php echo esc_attr($image_src[0]); ?>"></div>
                                </a>
                            </div>
                        <?php } ?>
                    <?php } ?>
                    <?php
                    if(isset($images[$intImageIndex])) {
                        $image_src = wp_get_attachment_image_src($images[$intImageIndex]);
                        $intImageIndex++;
                        if(false !== $image_src) { ?>
                            <div class="detail-header-column">
                                <a class="detail-header-image-link">
                                    <div class="detail-header-image" style="background-image:url(<?php echo esc_attr($image_src[0]); ?>"></div>
                                </a>
                            </div>
                        <?php } ?>
                    <?php } ?>
                </div>
            </div>
        </div>
    <?php } ?>
</div>

<div class="detail-content p-2">

    <div class="title-line text-center">
        <span>
            <?php
            $categories = wp_get_object_terms(get_the_ID(), 'listing_category', Array('fields' => 'names'));
            echo join(', ', $categories);?>
        </span>
        <h1><a href="<?php the_permalink(); ?>" target="_blank"><?php the_title(); ?></a></h1>
        <h5><?php echo esc_html(get_post_meta(get_the_ID(), '_tagline', true)); ?></h5>
    </div>

    <div class="rating d-flex justify-content-center">
        <ul class="list-group list-group-horizontal no-border">
            <?php if(false !== $reviewInstnace) { ?>
                <li class="list-group-item"><i class="fas fa-star"></i><?php echo $reviewInstnace->core->get( 'average' ); ?><span>/5</span></li>
            <?php } ?>
            <?php if(function_exists('pvc_get_post_views')) { ?>
                <li class="list-group-item"><i class="far fa-eye"></i><?php echo esc_html(pvc_get_post_views(get_the_ID())); ?> <span><?php esc_html_e("views", 'jvfrmtd'); ?></span></li>
            <?php } ?>
            <?php if(false !== $reviewInstnace) {
                $counts = $managerInstance->admin->reviewCount( get_the_ID() );
                $counts = intVal($counts);
                $displayCount = 1 < $counts ? __('Reviews','jvfrmtd') : __('Review','jvfrmtd');?>
                <li class="list-group-item"><i class="far fa-comment-alt"></i><?php echo esc_html($counts); ?> <span><?php echo esc_html($displayCount); ?></span></li>
            <?php } ?>
        </ul>
    </div>

    <div class="destination d-flex justify-content-center">
        <button type="button" class="btn btn-primary btn-sm cmd-get-direction">
            <i class="fas fa-location-arrow"></i>
            <?php esc_html_e("Direction", 'jvfrmtd'); ?>
        </button>
        <button type="button" class="btn btn-secondary btn-sm btn-sm cmd-show-contact-form">
            <i class="fas fa-id-card"></i>
            <?php esc_html_e("Contact", 'jvfrmtd'); ?>
        </button>
    </div>

    <div class="functions d-flex justify-content-around">
        <ul class="list-group list-group-horizontal no-border">
            <?php if(false !== $favInstance) { ?>
                <li class="list-group-item text-center cmd-bookmark">
                    <?php $favInstance->output(); ?>
                </li>
            <?php } ?>

            <?php if('1' == get_post_meta(get_the_ID(), 'lv_listing_street_visible', true)) { ?>
                <li class="list-group-item text-center cmd-street-view" data-lat="<?php echo esc_attr(get_post_meta(get_the_ID(), 'lv_listing_street_lat', true)); ?>" data-lng="<?php echo esc_attr(get_post_meta(get_the_ID(), 'lv_listing_street_lng', true)); ?>" data-heading="<?php echo esc_attr(get_post_meta(get_the_ID(), 'lv_listing_street_heading', true)); ?>" data-zoom="<?php echo esc_attr(get_post_meta(get_the_ID(), 'lv_listing_street_zoom', true)); ?>" data-pitch="<?php echo esc_attr(get_post_meta(get_the_ID(), 'lv_listing_street_pitch', true)); ?>"><i class="d-block fas fa-road"></i><?php esc_html_e("Streetview", 'jvfrmtd'); ?></li>
            <?php } ?>

            <?php if(false !== $d3Instance) { ?>
                <li class="list-group-item text-center cmd-3d-view"><i class="d-block fas fa-street-view"></i><?php esc_html_e("3D View", 'jvfrmtd'); ?></li>
            <?php } ?>

            <li class="list-group-item text-center cmd-share"><i class="fas fa-share-square"></i><?php esc_html_e("Share", 'jvfrmtd'); ?></li>
        </ul>
    </div>

    <div class="detail-nav">
        <h1 class="nav-title">
            <a class="detail-nav-title-link">
                <i class="fas fa-arrow-left"></i> <?php the_title(); ?></a>
            </a>
            <a href="<?php the_permalink(); ?>" target="_blank"><i class="fas fa-external-link-alt"></i></a>
        </h1>
        <?php if(is_array($lvMenus)) { ?>
            <ul class="nav nav-tabs">
                <?php
                foreach($lvMenus as $menuItemIDX => $menuItem) {
                    $menuTabType = '';
                    $menu_format = '<li class="%1$s" data-tab="%2$s">' .
                        '<a href="javascript:volid(0);" class="sticky-link">%3$s</a>' .
                    '</li>';
                    $menuItemClass = Array('tab-nav', 'text-center');

                    if(0 == $menuItemIDX) {
                        $menuItemClass[] = 'active';
                    }

                    switch($menuItem['type']) {
                    case 'home':
                        $menuTabType = 'info';
                        break;
                    case 'menu':
                        if(!is_array($groupMenus) || empty($groupMenus)) {
                            $menu_format = '';
                        }else{
                            $menuTabType = 'menu';
                        }
                        break;
                    case 'booking':
                        if(!is_array($groupBookings) || empty($groupBookings)) {
                            $menu_format = '';
                        }else{
                            $menuTabType = 'booking';
                        }
                        break;
                    case 'review':
                        if(false !== $reviewInstnace) {
                            $menuTabType = 'review';
                        }else{
                            $menu_format = '';
                        }
                        break;
                    case 'images':
                        $menuTabType = 'images';
                        break;
                    }
                    printf($menu_format, join(' ', $menuItemClass), $menuTabType, $menuItem['text']);
                } ?>
            </ul>
            <?php } ?>
    </div>

    <!-- Information -->
    <div class="detail-tab-content tab-info">
        <div class="detail-meta meta-info">
            <div class="info-item item-email d-flex justify-content-start">
                <div class="icon"><i class="fas fa-envelope" target="_new" data-toggle="tooltip" data-placement="top" title="<?php esc_attr_e("Email", 'jvfrmtd'); ?>"></i></div>
                <div class="txt">
                    <!-- <?php echo esc_html(get_post_meta(get_the_ID(), '_email', true)); ?> -->
                    <a href="mailto:<?php echo esc_html(get_post_meta(get_the_ID(), '_email', true)); ?>"><?php echo esc_html(get_post_meta(get_the_ID(), '_email', true)); ?></a>
                </div>
            </div>

            <div class="info-item item-address d-flex justify-content-start">
                <div class="icon"><i class="fas fa-map-marker-alt" target="_new" data-toggle="tooltip" data-placement="top" title="<?php esc_attr_e("Location", 'jvfrmtd'); ?>"></i></div>
                <div class="txt">
                    <?php echo esc_html(get_post_meta(get_the_ID(), '_address', true)); ?>
                </div>
            </div>

            <div class="info-item item-contact1 d-flex justify-content-start">
                <div class="icon"><i class="fas fa-phone-alt" target="_new" data-toggle="tooltip" data-placement="top" title="<?php esc_attr_e("Phone", 'jvfrmtd'); ?>"></i></div>
                <div class="txt">
                    <a href="tel:<?php echo esc_html(get_post_meta(get_the_ID(), '_phone1', true)); ?>"><?php echo esc_html(get_post_meta(get_the_ID(), '_phone1', true)); ?></a>
                    , <a href="tel:<?php echo esc_html(get_post_meta(get_the_ID(), '_phone2', true)); ?>"><?php echo esc_html(get_post_meta(get_the_ID(), '_phone2', true)); ?></a>
                </div>
            </div>

            <div class="info-item item-keyword d-flex justify-content-start">
                <div class="icon"><i class="fas fa-key" target="_new" data-toggle="tooltip" data-placement="top" title="<?php esc_attr_e("Keyword", 'jvfrmtd'); ?>"></i></div>
                <div class="txt">
                <?php
                    $categories = wp_get_object_terms(get_the_ID(), 'listing_keyword', Array('fields' => 'names'));
                    echo join(', ', $categories);?>
                </div>
            </div>

            <div class="social-item d-flex">
                <ul class="list-group list-group-horizontal no-border">
                    <li class="list-group-item"><a href="<?php echo esc_html(get_post_meta(get_the_ID(), '_website', true)); ?>" target="_new" data-toggle="tooltip" data-placement="top" title="<?php esc_attr_e("Website", 'jvfrmtd'); ?>"><i class="fas fa-globe"></i></a></li>
                    <li class="list-group-item"><a href="<?php echo esc_html(get_post_meta(get_the_ID(), '_facebook_link', true)); ?>" target="_new" data-toggle="tooltip" data-placement="top" title="<?php esc_attr_e("Facebook", 'jvfrmtd'); ?>"><i class="fab fa-facebook"></i></a></li>
                    <li class="list-group-item"><a href="<?php echo esc_html(get_post_meta(get_the_ID(), '_twitter_link', true)); ?>" target="_new" data-toggle="tooltip" data-placement="top" title="<?php esc_attr_e("Twitter", 'jvfrmtd'); ?>"><i class="fab fa-twitter"></i></a></li>
                    <li class="list-group-item"><a href="<?php echo esc_html(get_post_meta(get_the_ID(), '_instagram_link', true)); ?>" target="_new" data-toggle="tooltip" data-placement="top" title="<?php esc_attr_e("Instagram", 'jvfrmtd'); ?>"><i class="fab fa-instagram"></i></a></li>
                </ul>
            </div>

            <div class="info-item item-amenities">
                <ul class="list-group list-group-horizontal row">
                <?php
                $termsOutput = Array();
                $amenities = wp_get_object_terms(get_the_ID(), 'listing_amenities');
                foreach($amenities as $amenity) {
                    $termsOutput[] = sprintf(
                        '<li class="list-item col-6 item-%1$s"><i class="fas fa-check"></i> %2$s</li>',
                        $amenity->term_id, $amenity->name,
                        $managerInstance->admin->getTermOption( $amenity, 'icon')
                    );
                }
                echo join(' ', $termsOutput);?>
                </ul>
            </div>

        </div>
        <div class="detail-contact section-btm-button">
            <a href="<?php the_permalink(); ?>" class="btn btn-sm btn-secondary w-100" target="_self">
                <?php esc_html_e("Contact", 'jvfrmtd'); ?>
            </a>
        </div>


        <?php if(false !== $reviewInstnace) { ?>
            <hr />
            <!-- <h2 class=""><?php esc_html_e("Review", 'jvfrmtd'); ?></h2> -->

            <div class="detail-meta meta-review">
                <div class="detail-meta meta-review-average">
                    <?php
                    $counts = $managerInstance->admin->reviewCount( get_the_ID() );
                    $counts = intVal($counts);
                    $displayCount = 1 < $counts ? __('Reviews','jvfrmtd') : __('Review','jvfrmtd');                    ?>
                    <div class="review-avg-score-box">
                        <div class="review-avg-score d-inline"><?php echo $reviewInstnace->core->get( 'average' ); ?></div>
                        <div class="review-right">
                            <div class="review-amount d-inline">
                                <?php echo $counts.' '. $displayCount;  ?>
                            </div>
                            <div class="review-avg-stars"><?php echo $reviewInstnace->core->fa_get();?></div>
                        </div>
                    </div>
                </div>

                <div class="detail-meta meta-new-review">
                    <a href="<?php the_permalink(); ?>" class="btn btn-primary btn-block" target="_self">
                        <?php esc_html_e("Add Your Review", 'jvfrmtd'); ?>
                    </a>
                </div>

                <div class="detail-meta meta-review-list">
                    <?php
                    $reviewQuery = new \WP_Comment_Query(Array(
                        'post_id' => get_the_ID(),
                        'parent' => 0,
                        'status' => 'approve',
                        'type__not_in' => Array( \Lava_Directory_Review_CORE::NONREVIEW ),
                        'number' => 3,
                    ) );

                    if($reviewQuery->comments) { ?>
                        <div class="reviews-items-wrap p-2">
                        <?php foreach($reviewQuery->comments as $review) { ?>
                            <?php
                            $reviewAverageScore = get_comment_meta($review->comment_ID, 'rating_average', true);
                            $reviewAverageScore = is_numeric($reviewAverageScore) ? floatVal($reviewAverageScore) : 0;
                            $reviewFeaturedImage = false;
                            $reviewDetailImages = get_comment_meta( $review->comment_ID, 'detail_images', true );
                            if(is_array($reviewDetailImages) && 0 < count($reviewDetailImages)) {
                                $reviewFeaturedImage = wp_get_attachment_image($reviewDetailImages[0], Array(84, 84));
                            } ?>

                            <hr />
                            <div class="reviews-item item-<?php echo esc_attr($review->comment_ID); ?>">
                            <div class="review-item-author">
                                    <?php
                                    $author_data = get_user_by('id', $review->user_id);
                                    $author_display = get_comment_meta($review->comment_ID, 'author_display', true);
                                    $reviewItemDate = human_time_diff(
                                        get_comment_date( 'U', $review ),
                                        current_time('timestamp')
                                    );
                                    if('anonymous' == $author_display) { ?>
                                        <div class="review-item-author-name mr-2">
                                            <?php echo esc_html__("Anonymous", 'jvfrmtd'); ?>
                                        </div>
                                        <div class="review-item-date">
                                            <?php echo esc_html($reviewItemDate); ?>
                                        </div>
                                    <?php }else{ ?>
                                        <div class="media">
                                            <?php if($author_data && 'first_name' == $author_display) { ?>
                                                <div class="media-body">
                                                    <div class="review-item-author-name">
                                                        <?php echo $author_data->first_name; ?>
                                                    </div>
                                                    <div class="review-item-date">
                                                        <?php echo esc_html($reviewItemDate); ?>
                                                    </div>
                                                </div>
                                            <?php }else{ ?>
                                                <?php echo get_avatar($review->user_id, 32, '', '', Array(
                                                    'class' => 'rounded-circle mr-2',
                                                )); ?>
                                                <div class="media-body">
                                                    <div class="review-item-author-name">
                                                        <?php
                                                        if($author_data) {
                                                            echo $author_data->display_name;
                                                        }else{
                                                            echo $review->comment_author;
                                                        } ?>
                                                    </div>
                                                    <div class="review-item-date">
                                                        <?php echo esc_html($reviewItemDate); ?>
                                                    </div>
                                                </div>
                                            <?php } ?>
                                        </div>
                                    <?php } ?>
                                </div>
                                <div class="review-item-content">
                                    <div class="review-item-score">
                                        <?php
                                        printf(
                                            '<div class="module-rating-wrap d-inline-block align-top">' .
                                                '<div class="module-ratings" style="width:%1$s%%;"></div>' .
                                            '</div>',
                                            ( $reviewAverageScore / 5 * 100 )
                                        ); ?>
                                        <div class="review-item-score-number font-weight-bold d-inline-block align-top">
                                            <?php printf("%.1f", $reviewAverageScore); ?>
                                        </div>
                                    </div>
                                    <div class="media">
                                        <div class="media-body">
                                            <?php echo $review->comment_content; ?>
                                        </div>
                                        <?php if($reviewFeaturedImage) { ?>
                                            <?php echo $reviewFeaturedImage; ?>
                                        <?php } ?>
                                    </div>
                                </div>
                            </div>
                        <?php } ?>

                        </div>
                    <?php } ?>
                </div>

            </div>
            <div class="reviews-more-items section-btm-button">
                <a class="btn btn-sm btn-secondary w-100">
                    <?php esc_html_e("More Reviews", 'jvfrmtd'); ?>
                </a>
            </div>
        <?php } ?>

        <hr />
        <h2 class=""><?php esc_html_e("Images", 'jvfrmtd'); ?></h2>
        <div class="detail-meta meta-detail-images row">
            <?php foreach($images as $image_id) { ?>
                <div class="col-sm-4">
                    <a class="meta-detail-images-item d-inline-block" data-id="<?php echo esc_attr($image_id); ?>">
                        <?php echo wp_get_attachment_image($image_id); ?>
                    </a>
                </div>
            <?php } ?>
        </div>
        <div class="images-more-items section-btm-button mb-5">
            <a class="btn btn-sm btn-secondary w-100" target="_self">
                <?php esc_html_e("More Images", 'jvfrmtd'); ?>
            </a>
        </div>
    </div>

    <!-- Menu -->
    <?php if(is_array($groupMenus) && 0 < count($groupMenus)) { ?>
        <div class="detail-tab-content tab-menu hidden">
            <?php foreach($groupMenus as $menu_index => $menu) { ?>
                <?php
                $menuImageID = $groupType2DefaultImage;
                if(\WP_Post::get_instance($menu->featured_image_id)) {
                    $menuImageID = $menu->featured_image_id;
                } ?>
                <div class="media mt-2">
                    <a href="javascript:void(0);" data-post-id="<?php the_ID();?>" data-show-menu-detail="<?php echo esc_attr($menu_index); ?>">
                        <?php echo wp_get_attachment_image($menuImageID, Array(32, 32)); ?>
                    </a>
                    <div class="media-body">
                        <h3><a href="javascript:void(0);" data-post-id="<?php the_ID();?>" data-show-menu-detail="<?php echo esc_attr($menu_index); ?>">
                            <?php echo $menu->title; ?>
                        </a></h3>
                    </div>
                </div>
            <?php } ?>
        </div>
    <?php } ?>

    <!-- Booking -->
    <?php if(is_array($groupBookings) && 0 < count($groupBookings)) { ?>
        <div class="detail-tab-content tab-booking hidden">
            <?php foreach($groupBookings as $booking_index => $booking) { ?>
                <?php
                $groupImageID = $groupType1DefaultImage;
                if(\WP_Post::get_instance($booking->featured_image_id)) {
                    $groupImageID = $booking->featured_image_id;
                } ?>
                <div class="media mt-2">
                    <a href="javascript:void(0);" data-post-id="<?php the_ID();?>" data-show-booking-detail="<?php echo esc_attr($booking_index); ?>">
                        <?php echo wp_get_attachment_image($groupImageID, Array(32, 32)); ?>
                    </a>
                    <div class="media-body">
                        <h3><a href="javascript:void(0);" data-post-id="<?php the_ID();?>" data-show-booking-detail="<?php echo esc_attr($booking_index); ?>">
                            <?php echo $booking->title; ?>
                        </a></h3>
                    </div>
                </div>
            <?php } ?>
        </div>
    <?php } ?>

    <?php if(false !== $reviewInstnace) { ?>
        <!-- Reviews -->
        <div class="detail-tab-content tab-review hidden">

            <h2 class=""><?php esc_html_e("Reviews", 'jvfrmtd'); ?></h2>

            <div class="detail-meta meta-review-process">
                <?php $reviewInstnace->core->part_progress(); ?>
            </div>

            <?php
            $reviewQuery = new \WP_Comment_Query(Array(
                'post_id' => get_the_ID(),
                'parent' => 0,
                'status' => 'approve',
                'type__not_in' => Array( \Lava_Directory_Review_CORE::NONREVIEW ),
            ) );

            if($reviewQuery->comments) { ?>
                <div class="reviews-items-wrap p-2">
                <?php foreach($reviewQuery->comments as $review) { ?>
                    <?php
                    $reviewAverageScore = get_comment_meta($review->comment_ID, 'rating_average', true);
                    $reviewAverageScore = is_numeric($reviewAverageScore) ? floatVal($reviewAverageScore) : 0;
                    $reviewDetailImages = get_comment_meta( $review->comment_ID, 'detail_images', true ); ?>
                    <hr />
                    <div class="reviews-item item-<?php echo esc_attr($review->comment_ID); ?>">
                    <div class="review-item-author">
                            <?php
                            $author_data = get_user_by('id', $review->user_id);
                            $author_display = get_comment_meta($review->comment_ID, 'author_display', true);
                            $reviewItemDate = human_time_diff(
                                get_comment_date( 'U', $review ),
                                current_time('timestamp')
                            );
                            if('anonymous' == $author_display) { ?>
                                <div class="review-item-author-name mr-2">
                                    <?php echo esc_html__("Anonymous", 'jvfrmtd'); ?>
                                </div>
                                <div class="review-item-date">
                                    <?php echo esc_html($reviewItemDate); ?>
                                </div>
                            <?php }else{ ?>
                                <div class="media">
                                    <?php if($author_data && 'first_name' == $author_display) { ?>
                                        <div class="media-body">
                                            <div class="review-item-author-name">
                                                <?php echo $author_data->first_name; ?>
                                            </div>
                                            <div class="review-item-date">
                                                <?php echo esc_html($reviewItemDate); ?>
                                            </div>
                                        </div>
                                    <?php }else{ ?>
                                        <?php echo get_avatar($review->user_id, 32, '', '', Array(
                                            'class' => 'rounded-circle mr-2',
                                        )); ?>
                                        <div class="media-body">
                                            <div class="review-item-author-name">
                                                <?php
                                                if($author_data) {
                                                    echo $author_data->display_name;
                                                }else{
                                                    echo $review->comment_author;
                                                } ?>
                                            </div>
                                            <div class="review-item-date">
                                                <?php echo esc_html($reviewItemDate); ?>
                                            </div>
                                        </div>
                                    <?php } ?>
                                </div>
                            <?php } ?>
                        </div>
                        <div class="review-item-content">
                            <div class="review-item-score">
                                <?php
                                printf(
                                    '<div class="module-rating-wrap d-inline-block align-top">' .
                                        '<div class="module-ratings" style="width:%1$s%%;"></div>' .
                                    '</div>',
                                    ( $reviewAverageScore / 5 * 100 )
                                ); ?>
                                <div class="review-item-score-number font-weight-bold d-inline-block align-top">
                                    <?php printf("%.1f", $reviewAverageScore); ?>
                                </div>
                            </div>
                            <div class="media">
                                <div class="media-body">
                                    <?php echo $review->comment_content; ?>
                                </div>
                            </div>
                            <?php
                            if(is_array($reviewDetailImages) && 0 < count($reviewDetailImages)) { ?>
                                <div class="detail-meta meta-detail-review-images">
                                    <?php foreach($reviewDetailImages as $detailImageID) {
                                        $allReviewImages[] = $detailImageID;
                                        ?>
                                        <a class="meta-detail-review-images-item" data-id="<?php echo esc_attr($detailImageID); ?>">
                                            <?php echo wp_get_attachment_image($detailImageID, Array(84, 84)); ?>
                                        </a>
                                    <?php } ?>
                                </div>
                            <?php } ?>
                        </div>
                    </div>
                <?php } ?>
                </div>
            <?php } ?>

        </div>
    <?php } ?>

    <!-- Images -->
    <div class="detail-tab-content tab-images hidden">
        <h2 class=""><?php esc_html_e("Images", 'jvfrmtd'); ?></h2>
        <div class="detail-meta meta-detail-images row">
            <?php foreach($images as $image_id) { ?>
                <div class="col-sm-4">
                    <a class="meta-detail-images-item d-inline-block" data-id="<?php echo esc_attr($image_id); ?>">
                        <?php echo wp_get_attachment_image($image_id); ?>
                    </a>
                </div>
            <?php } ?>
        </div>
    </div>
</div>

<script type="text/html" data-share-panel>
    <div class="m-2 mt-5">
        <?php jvbpdCore()->template_instance->load_template( 'part-single-share-modal' ); ?>
    </div>
</script>

<script type="text/html" data-images-panel>
    <div class="detail-images-slider swiper-container">
        <div class="swiper-wrapper">
            <?php
            foreach($images as $image_id) {
                $imageSrc = wp_get_attachment_image_src($image_id, 'full');
                if(false !== $imageSrc) { ?>
                <div class="swiper-slide" data-image-id="<?php echo esc_attr($image_id); ?>">
                    <div class="slide-item" style="background-image:url(<?php echo esc_attr($imageSrc[0]); ?>);"></div>
                </div>
                <?php } ?>
            <?php } ?>
        </div>
        <div class="swiper-button-prev"></div>
        <div class="swiper-button-next"></div>
    </div>
</script>

<script type="text/html" data-get-direction-template>
    <h3><?php esc_html_e("Get Direction", 'jvfrmtd'); ?></h3>
    <div class="detail-get-direction-modal-wrap">
        <div class="form-row" >
            <div class="col-sm-7">
                <input type="text" class="form-control" placeholder="<?php esc_html_e("Departure Address", 'jvfrmtd'); ?>">
                <div class="alert alert-danger get-direction-msg hidden">
                    <?php esc_html_e("There is no result value. Please try again", 'jvfrmtd'); ?>
                </div>
            </div>
            <div class="col-sm-5">
                <button type="button" class="btn btn-block btn-primary detail-get-directory" data-lat="<?php echo esc_attr(get_post_meta(get_the_ID(), 'lv_listing_lat', true)); ?>" data-lng="<?php echo esc_attr(get_post_meta(get_the_ID(), 'lv_listing_lng', true)); ?>">
                    <?php esc_html_e("Get Direction", 'jvfrmtd'); ?>
                </button>
            </div>
        </div>

        <div class="form-row" >
            <div class="col-sm-7">
                <div class="btn-group btn-group-toggle detail-get-direction-travel-type" data-toggle="buttons">
                    <label class="btn btn-secondary active">
                        <input type="radio" name="detail_get_direction_travel" value="driving" checked>
                        <i class="fas fa-car"></i>
                    </label>
                    <label class="btn btn-secondary">
                        <input type="radio" name="detail_get_direction_travel" value="bicycling">
                        <i class="fas fa-bicycle"></i>
                    </label>
                    <label class="btn btn-secondary">
                        <input type="radio" name="detail_get_direction_travel" value="transit">
                        <i class="fas fa-train"></i>
                    </label>
                    <label class="btn btn-secondary">
                        <input type="radio" name="detail_get_direction_travel" value="walking">
                        <i class="fas fa-walking"></i>
                    </label>
                </div>
            </div>
            <div class="col-sm-5">
                <button type="button" class="btn btn-block btn-primary detail-get-directory-to-google" data-lat="<?php echo esc_attr(get_post_meta(get_the_ID(), 'lv_listing_lat', true)); ?>" data-lng="<?php echo esc_attr(get_post_meta(get_the_ID(), 'lv_listing_lng', true)); ?>">
                    <?php esc_html_e("View Google", 'jvfrmtd'); ?>
                </button>
            </div>
        </div>
    </div>
</script>

<script type="text/html" data-contact-form-template>
    <?php echo do_shortcode($lvContactFormCode); ?>
</script>

<script type="text/html" data-review-images-panel>
    <div class="detail-review-images-slider swiper-container">
        <div class="swiper-wrapper">
            <?php
            foreach($allReviewImages as $image_id) {
                $imageSrc = wp_get_attachment_image_src($image_id, 'full');
                if(false !== $imageSrc) { ?>
                <div class="swiper-slide" data-image-id="<?php echo esc_attr($image_id); ?>">
                    <div class="slide-item" style="background-image:url(<?php echo esc_attr($imageSrc[0]); ?>);"></div>
                </div>
                <?php } ?>
            <?php } ?>
        </div>
        <div class="swiper-button-prev"></div>
        <div class="swiper-button-next"></div>
    </div>
</script>

<?php if(false !== $d3Instance) { ?>
    <script type="text/html" data-3dviewer-panel>
        <?php
        $objRender = new lvDirectory3DViewer_Render(get_post());
        echo $objRender->output(); ?>
    </script>
<?php } ?>