<?php
global $post;

$arrFavoritesItems = function_exists('lv_directory_favorite') && is_user_logged_in() ?
    lv_directory_favorite()->core->getFavorites(get_current_user_id()) : Array();
?>
<div class="favorite-panel-header p-2">
    <h3><?php esc_html_e("Favorites", 'jvfrmtd'); ?></h3>
</div>
<div class="favorite-panel-wrap p-2">
    <?php
    if(is_user_logged_in()) {
        if( !empty( $arrFavoritesItems ) ) {
            $intFavoriteCount = 0; ?>
            <ul class="list-group">
                <?php foreach( $arrFavoritesItems as $arrFavoriteMeta ) { ?>
                    <?php
                    $post = isset($arrFavoriteMeta['post_id'])? \WP_Post::get_instance($arrFavoriteMeta['post_id']) : false;
                    if($post) {
                        setup_postdata($post);
                        $intFavoriteCount++;
                    }else{
                        continue;
                    } ?>
                    <li class="list-group-item" data-id="<?php the_ID(); ?>">
                        <div class="favroite-item-content">
                            <?php if(has_post_thumbnail()) { ?>
                                <div class="favorite-item-thumbnail d-inline-block">
                                    <a class="panel-opener">
                                        <?php the_post_thumbnail(Array(64, 64)); ?>
                                    </a>
                                </div>
                            <?php } ?>
                            <div class="favroite-item-body d-inline-block">
                                <div class="favorite-item-title">
                                    <a class="panel-opener"><?php the_title(); ?></a>
                                </div>
                                <div class="favorite-item-meta d-inline-block">
                                    <span class="favorite-item-save-time">
                                        <?php echo date( get_option( 'date_format' ), strtotime( $arrFavoriteMeta[ 'save_day' ] ) ); ?>
                                    </span>
                                </div>
                                <div class="favorite-item-action d-inline-block">
                                    <?php
                                    $favoriteInstance = new lvDirectoryFavorite_button(
                                        Array(
                                            'format' => '{text}',
                                            'post_id'	=> get_the_ID(),
                                            'unsave'	=> __( "Remove", 'jvfrmtd' ),
                                            'dashboard'	=> true
                                        )
                                    );
                                    $favoriteInstance->output(); ?>
                                </div>
                            </div>
                        </div>
                    </li>
                <?php } ?>
            </ul>
        <?php }else{ ?>
            <p><?php esc_html_e("Not found any data", 'jvfrmtd'); ?></p>
        <?php } ?>
    <?php }else{ ?>
        <div class="m-2">
            <h3 class="not-logged-in-header"><?php esc_html_e("To use the Favorite list, Please log in.", 'jvfrmtd'); ?></h3>
            <p class="text-center mt-4">
                <a class="btn btn-primary text-white" data-toggle="modal" data-target="#login_panel"><?php esc_html_e("Login", 'jvfrmtd'); ?></a>
            </p>
        </div>
    <?php } ?>
</div>