let mix = require('laravel-mix');
let webpack = require('webpack');

const path = require('path');

/*
module.exports = {
    resolve: {
        alias: {
            "TweenLite": path.resolve('node_modules', 'gsap/src/uncompressed/TweenLite.js'),
            "TweenMax": path.resolve('node_modules', 'gsap/src/uncompressed/TweenMax.js'),
            "TimelineLite": path.resolve('node_modules', 'gsap/src/uncompressed/TimelineLite.js'),
            "TimelineMax": path.resolve('node_modules', 'gsap/src/uncompressed/TimelineMax.js'),
            "ScrollMagic": path.resolve('node_modules', 'scrollmagic/scrollmagic/uncompressed/ScrollMagic.js'),
            "animation.gsap": path.resolve('node_modules', 'scrollmagic/scrollmagic/uncompressed/plugins/animation.gsap.js'),
            "debug.addIndicators": path.resolve('node_modules', 'scrollmagic/scrollmagic/uncompressed/plugins/debug.addIndicators.js')
        }
    }
}; */

// BrowserSync and LiveReload on `npm run watch` command
// Update the `proxy` and the location of your SSL Certificates if you're developing over HTTPS
mix.browserSync({
    proxy: "http://localhost/wp/",
    files: ["**/*.php", "dist/css/**/*.css", "dist/js/**/*.js"],
    injectChanges: true,
    open: false
});

/*
 |--------------------------------------------------------------------------
 | Mix Asset Management
 |--------------------------------------------------------------------------
 |
 | Mix provides a clean, fluent API for defining some Webpack build steps
 | for your Laravel application. By default, we are compiling the Sass
 | file for your application, as well as bundling up your JS files.
 |
 */

mix.setPublicPath("dist");

mix.js("src/js/main.js", "dist/js/")
    .js('src/js/admin.js', 'dist/js/')
    .js('src/js/single.js', 'dist/js/')
    .js('src/js/modernizr.min.js', 'dist/js/')
    .scripts([
        "src/js/modules/grid-loader/isotope.min.js",
        "src/js/flexmenu.min.js",
        "src/js/mailchimp.js",
        "src/js/block.js",
        "src/js/jquery-jvbpd-search.js",
        "src/js/modules/markerclustererplus.min.js",
        "src/js/modules/jquery.sticky.js",
        "src/js/modules/theia-sticky-sidebar.js",
        "src/js/modules/appearl.js",
        "src/js/modules/parallax.js",
        "src/js/modules/scrollani.js",
        "src/js/modules/slick.min.js",
        "src/js/modules/jquery.scrolling-tabs.min.js",
        "src/js/modules/ScrollMagic.min.js",
        "src/js/modules/addIndicators.js",
        "src/js/modules/animation.gsap.js",
        "src/js/modules/jquery.magnific-popup.min.js",
        "src/js/modules/jquery.cookie.js",
        "src/js/modules/clipboard.min.js",
        "src/js/modules/metisMenu.min.js",
        "src/js/modules/markerwithlabel.js",
        // "src/js/jquery-type-header.js", issue
        "src/js/map-template.js",
        "src/js/elementor.js",
        "src/js/document.js",
    ], 'dist/js/all.js')
    .sass("src/scss/style.scss", "dist/css")
    .sass('src/scss/partials/_javo-icons.scss', 'dist/css')
    .sass("src/scss/admin.scss", "dist/css")

    // .sourceMaps()
    .webpackConfig({
        // devtool: 'source-map',
        plugins: [
            new webpack.ProvidePlugin({
                noUiSlider: 'nouislider'
            })
        ],
    })
    .options({
        processCssUrls: false
    });

// Add versioning to assets in production environment
if (mix.inProduction()) {
    mix.version();
}


// Full API
// mix.js(src, output);
// mix.react(src, output); <-- Identical to mix.js(), but registers React Babel compilation.
// mix.preact(src, output); <-- Identical to mix.js(), but registers Preact compilation.
// mix.coffee(src, output); <-- Identical to mix.js(), but registers CoffeeScript compilation.
// mix.ts(src, output); <-- TypeScript support. Requires tsconfig.json to exist in the same folder as webpack.mix.js
// mix.extract(vendorLibs);
// mix.sass(src, output);
// mix.standaloneSass('src', output); <-- Faster, but isolated from Webpack.
// mix.fastSass('src', output); <-- Alias for mix.standaloneSass().
// mix.less(src, output);
// mix.stylus(src, output);
// mix.postCss(src, output, [require('postcss-some-plugin')()]);
// mix.browserSync('my-site.test');
// mix.combine(files, destination);
// mix.babel(files, destination); <-- Identical to mix.combine(), but also includes Babel compilation.
// mix.copy(from, to);
// mix.copyDirectory(fromDir, toDir);
// mix.minify(file);
// mix.sourceMaps(); // Enable sourcemaps
// mix.version(); // Enable versioning.
// mix.disableNotifications();
// mix.setPublicPath('path/to/public');
// mix.setResourceRoot('prefix/for/resource/locators');
// mix.autoload({}); <-- Will be passed to Webpack's ProvidePlugin.
// mix.webpackConfig({}); <-- Override webpack.config.js, without editing the file directly.
// mix.babelConfig({}); <-- Merge extra Babel configuration (plugins, etc.) with Mix's default.
// mix.then(function () {}) <-- Will be triggered each time Webpack finishes building.
// mix.extend(name, handler) <-- Extend Mix's API with your own components.
// mix.options({
//   extractVueStyles: false, // Extract .vue component styling to file, rather than inline.
//   globalVueStyles: file, // Variables file to be imported in every component.
//   processCssUrls: true, // Process/optimize relative stylesheet url()'s. Set to false, if you don't want them touched.
//   purifyCss: false, // Remove unused CSS selectors.
//   uglify: {}, // Uglify-specific options. https://webpack.github.io/docs/list-of-plugins.html#uglifyjsplugin
//   postCss: [] // Post-CSS options: https://github.com/postcss/postcss/blob/master/docs/plugins.md
// });