<?php
/**
 * Widget Name: Map Location filter
 * Author: Javo
 * Version: 1.0.0.0
*/

namespace jvbpdelement\Widgets;

use Elementor\Widget_Base;
use Elementor\Controls_Manager;
use Elementor\Icons_Manager;
use Elementor\Repeater;

if( !defined( 'ABSPATH' ) ) {
    exit;
}

class Jvbpd_Map_Location_Filters extends Widget_Base {

    public function get_name() { return 'jvbpd-map-location-filters'; }
	public function get_title() { return 'Map Location Filters'; }
    public function get_icon() { return 'eicon-button'; }
    public function get_categories() { return [ 'jvbpd-elements' ]; }

	protected function _register_controls() {
        $this->start_controls_section( 'section_general', array(
			'label' => esc_html__( 'General', 'jvfrmtd' ),
        ) );

        $this->end_controls_section();
    }

    protected function render() {
        $this->add_render_attribute('filter_wrap', 'class', 'jvbpd-filter-wrap');
        $this->add_render_attribute('filter_review_top_10', Array(
            'class' => Array('btn', 'btn-primary', 'jvbpd-filter-review-top-10'),
            // 'data-toggle' => 'button',
            'href' => 'javascript:void(0);',
        ));
        $this->add_render_attribute('filter_review_bottom_10', Array(
            'class' => Array('btn', 'btn-primary', 'jvbpd-filter-review-bottom-10'),
            // 'data-toggle' => 'button',
            'href' => 'javascript:void(0);',
        ));
        ?>
        <div <?php echo $this->get_render_attribute_string('filter_wrap'); ?>>
            <div class="filter-item item-review-sort d-inline-block">
                <a <?php echo $this->get_render_attribute_string('filter_review_bottom_10'); ?>>
                    <?php esc_html_e("Bottom 10", 'jvfrmtd'); ?>
                </a>
                <a <?php echo $this->get_render_attribute_string('filter_review_top_10'); ?>>
                    <?php esc_html_e("Top 10", 'jvfrmtd'); ?>
                </a>
            </div>
            <div class="filter-item item-listing-category d-inline-block">
                <?php
                echo jvbpd_elements_tools()->getTaxonomyElement( Array(
                    'type' => 'select',
                    'remove_button' => true,
                    'limit_items' => 0,
                    'taxonomy' => 'listing_category',
                    'placeholder' => esc_html__("Category", 'jvfrmtd'),
                    'hide_empty' => true,
                ) ); ?>
            </div>
            <div class="filter-item item-listing-location d-inline-block">
                <?php
                echo jvbpd_elements_tools()->getTaxonomyElement( Array(
                    'type' => 'select',
                    'remove_button' => true,
                    'limit_items' => 0,
                    'taxonomy' => 'listing_location',
                    'placeholder' => esc_html__("Location", 'jvfrmtd'),
                    'hide_empty' => true,
                ) ); ?>
            </div>
        </div>
        <?php
    }
}