<?php
namespace jvbpdelement\Widgets;

use Elementor\Widget_Base;
use Elementor\Controls_Manager;

if ( ! defined( 'ABSPATH' ) ) exit;

class Jvbpd_Single_Group extends Widget_Base {

	public function get_name() { return 'jvbpd-single-gorup'; }
	public function get_title() { return 'Single listing group'; }
	public function get_icon() { return 'eicon-button'; }
	public function get_categories() { return [ 'jvbpd-single-listing' ]; }

	protected function _register_controls() {
		$this->start_controls_section( 'section_general', array(
			'label' => esc_html__( 'General', 'jvfrmtd' ),
		) );
		$this->end_controls_section();
    }

    public function getAnyImage() {
        $query = new \WP_Query(Array(
            'post_type' => 'attachment',
            'post_status' => 'any',
            'post_mime_type' => 'image/jpeg',
            'posts_per_page' => -1,
            'fields' => 'ids',
        ));
        $images = $query->get_posts();
        return isset($images[0]) ? $images[0] : false;
    }

	protected function render() {
        global $post;
        jvbpd_elements_tools()->switch_preview_post();

        $listingTypeData = Array();
        if(class_exists('\\LavaDirectoryManagerPro\\Base\\BaseController')) {
            $listingProBase = new \LavaDirectoryManagerPro\Base\BaseController;
            $listingTypeID = $listingProBase->getListingType(get_the_ID());
            $listingTypeData = get_post_meta($listingTypeID, \LavaDirectoryManagerPro\Base\BaseController::LVLT_META_KEY, true);
            $listingTypeFields = isset($listingTypeData['lt_fields']) ? json_decode($listingTypeData['lt_fields'], true) : Array();
        }
        $groupLabel = '';
        $groupDefaultImage = false;
        foreach($listingTypeFields as $field) {
            if(isset($field['type']) && $field['type'] == 'field_group') {
                $groupLabel = isset($field['label']) ? $field['label'] : '';
                $groupDefaultImage = isset($field['default_image_id']) ? $field['default_image_id'] : false;
                break;
            }
        }
        $group_values = get_post_meta($post->ID, 'field_group', true);
        if(is_array($group_values) && 0 < count($group_values)) { ?>
            <div class="heading-wapper style1">
                <div class="heading-header jv-heading-style1">
                    <span class="jv-heading-text"><?php echo esc_html($groupLabel); ?></span>
                    <span class="jv-heading-style7-strip bottom"></span>
                </div>
            </div>
            <div class="row">
                <?php
                foreach($group_values as $group_index => $group) {
                    $classImageID = $groupDefaultImage;
                    if(\WP_Post::get_instance($group->featured_image_id)) {
                        $classImageID = $group->featured_image_id;
                    }

                    $this->add_render_attribute('group-detail', Array(
                        'data-post-id' => $post->ID,
                        'data-show-group-detail' => $group_index,
                    ), false, true);
                    ?>
                    <div class="col-4 text-center">
                        <a <?php echo $this->get_render_attribute_string('group-detail'); ?>>
                            <?php echo wp_get_attachment_image($classImageID, 'thumbnail'); ?>
                        </a>
                        <h3><a <?php echo $this->get_render_attribute_string('group-detail'); ?>><?php echo $group->title; ?></a></h3>
                    </div>
                <?php } ?>
            </div>
            <?php
        }
        jvbpd_elements_tools()->restore_preview_post();
	}
}