<?php
/**
 * Template part for displaying results in search pages
 *
 * @link https://codex.wordpress.org/Template_Hierarchy
 *
 *
 */

?>

<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
	<header class="entry-header">
		<?php the_title( '<h2 class="entry-title"><a href="' . esc_url( get_permalink() ) . '" rel="bookmark">', '</a></h2>' ); ?>

				<?php if ( 'post' === get_post_type() ) : ?>
						<div class="entry-meta">
							<?php Javo\Core\Tags::posted_on(); ?>
						</div><!-- .entry-meta -->

		<?php endif; ?>
	</header><!-- .entry-header -->

	<div class="entry-content">
		<?php
			the_content( sprintf(
					/* translators: %s: Name of current post. */
					wp_kses( __( 'Continue reading %s <span class="meta-nav">&rarr;</span>', 'jvbpd' ), array(
						'span' => array(
							'class' => array(),
						),
					) ), the_title( '<span class="screen-reader-text">"', '"</span>', false ) ) );

			wp_link_pages( array(
				'before' => '<div class="page-links">' . esc_html__( 'Pages:', 'jvbpd' ),
				'after' => '</div>',
			) );
			?>
	</div><!-- .entry-content -->

	<footer class="entry-footer">
		<?php Javo\core\tags::entry_footer(); ?>
	</footer><!-- .entry-footer -->
</article><!-- #post-## -->
