/*
 * AWPS uses Laravel Mix
 *
 * Check the documentation at
 * https://laravel.com/docs/5.6/mix
 */

let mix = require('laravel-mix');
let webpack = require('webpack');

// BrowserSync and LiveReload on `npm run watch` command
// Update the `proxy` and the location of your SSL Certificates if you're developing over HTTPS
// mix.browserSync({
// 	proxy: 'https://wp.dev',
// 	https: {
// 		key: '/home/jason/.valet/Certificates/wp.dev.key',
// 		cert: '/home/jason/.valet/Certificates/wp.dev.crt'
// 	},
// 	files: [
// 		'**/*.php',
// 		'assets/dist/css/**/*.css',
// 		'assets/dist/js/**/*.js'
// 	],
// 	injectChanges: true,
// 	open: false
// });

// Autloading jQuery to make it accessible to all the packages, because, you know, reasons
// You can comment this line if you don't need jQuery
// mix.autoload({
// 	jquery: ['$', 'window.jQuery', 'jQuery'],
// });

mix.setPublicPath('./assets/dist');

// Compile assets
mix.js('assets/src/scripts/app.js', 'assets/dist/js')
	.js('assets/src/scripts/admin.js', 'assets/dist/js')
	.js('assets/src/scripts/backend.js', 'assets/dist/js')
	// .scripts([
	// 	'assets/dist/js/app.js'
	// ], 'assets/dist/js/front.js')
	.sass('assets/src/sass/style.scss', 'assets/dist/css')
	.sass('assets/src/sass/icons.scss', 'assets/dist/css')
	// .sourceMaps()
	.webpackConfig({
		// devtool: 'source-map'
	})
	.options({
		processCssUrls: false
	})
	//.sass('assets/src/sass/buddypress.scss', 'buddypress/css')
	.sass('assets/src/sass/admin.scss', 'assets/dist/css')

// Add versioning to assets in production environment
if (mix.inProduction()) {
	mix.version();
}